/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  DirectDraw
 *
 *
 */
#ifndef A_DIRECTDRAW_H
#define A_DIRECTDRAW_H

/****** System Includes ******/
#include <stdio.h>
#ifdef WIN32
#include "windowsx.h"
extern "C" {
#include <ddraw.h>
}
#endif

/****** External library ******/
#include "SDL.h"

/****** Application includes ******/
#include "M_types.h"


/****** Class definition ******/
class TC_DDRAW
{
  public:
	char					winName[255];
	char					winTitle[255];

	TP_DD					lpDD;           // DirectDraw object
	TP_DDSurface			lpDDSPrimary;   // DirectDraw primary surface
	TP_DDSurface			lpDDSBack;      // DirectDraw back surface
	TP_DDCLIPPER			lpClipper;      // clipper for primary
	TP_DDSurface			lpDDSOne;       // Offscreen surface 1
	TP_DDPALETTE			lpDDPal;        // DirectDraw palette
 #ifdef USE_SDL
 #else
	HWND					hwnd;
//	TP_DD					lpDD;           // DirectDraw object
//	TP_DDCLIPPER			lpClipper;      // clipper for primary
//	TP_DDPALETTE			lpDDPal;        // DirectDraw palette
 #endif

	int						mode_Windows;
	TC_DDRAW();
	T_BOOL initFail(char *ip_msg);
	void finiObjects();

	HRESULT restoreAll();
	void AffTextDC(char *msg, int len, long i_x=0, long i_y=0);
	void AffText(char *msg, int len, long i_x, long i_y, T_BOOL l_isFond);
	void AffText(char *msg, int len, T_BOOL l_isFond);
	HWND CreateDDWindow(int mode_Windows, WNDPROC WindowProc, HINSTANCE hInstance, int nCmdShow);
	T_BOOL AttachDDWindow(int i_mode_Windows, HWND i_hwnd, int resX, int resY, int resColorBit, Uint32 i_videoflags);
	T_BOOL traceEmptyRect( int i_left,  int i_top,  int i_right,  int i_bottom, T_WORD i_coul);
	T_BOOL traceRect( int i_left,  int i_top,  int i_right,  int i_bottom, T_WORD i_coul);
	T_BOOL traceRectSoftCorner( int i_left,  int i_top,  int i_right,  int i_bottom, int i_R, int i_G, int i_B);

	void updateFrame();
};
typedef TC_DDRAW	*TPC_DDRAW;


SDL_Surface *sge_rotate_scaled_surface(SDL_Surface *src, int angle, float scale, Uint32 bcol);

#endif