/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Affichage
 *
 *
 */
#ifndef A_TEXT_H
#define A_TEXT_H

/****** System Includes ******/
#ifdef WIN32
#include <windows.h>
#endif

/****** Application Includes ******/
#include "R_ressources.h"

typedef struct {
	T_BOOL		isActif;
	T_POINT		ptCoord;
	T_DWORD		dureeAff;
	T_DWORD		debutAff;
	TE_ResId	resId;
	T_BOOL		isFond;
	T_BOOL		isScroll;
	int			nbLignesScroll;
	T_DWORD		timerScroll;
} cgb_text;

typedef long cgb_text_id;

/****** Global Variables ******/
#define	CGB_NB_TEXT_MAX	64 // Au plus 64 textes simultans
extern cgb_text		A_gTab_Text[CGB_NB_TEXT_MAX];

/****** Functions ******/
void	 cgb_text_init();
cgb_text_id cgb_text_set(char *ip_resName, long i_x, long i_y, T_DWORD i_dureeAff, cgb_text_id i_lastTextId, T_BOOL i_isFond);
void	 cgb_text_remove(cgb_text_id i_textId);
void	 cgb_text_scroll_set(cgb_text_id idText,int i_nbLignes, T_DWORD i_timerScroll);

#endif
