/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */


/*
 *
 *  Coconut
 *  Engine
 *
 *
 */


#ifndef M_ENGINE_H
#define M_ENGINE_H


/****** System Includes ******/
#ifdef USE_SDL
#include "SDL.h"
#endif

/****** Application Includes ******/
extern T_BOOL    M_gbActive; 
extern int s_LastTickCount;
extern int s_DureeAff;
extern int M_g_coco_editor;
extern int M_g_mode_Windows;
extern int M_gQuitter;

/*********************************/
/** internal functions          **/
T_BOOL M_doInit( char *ip_configFile );
extern "C" T_BOOL M_doInit_SDL( int argc, char *argv[]);
#ifdef WIN32
T_BOOL M_doInit_DirectX( HINSTANCE hInstance, int nCmdShow);
#endif
void M_doTerminate();

// Engine data process
void M_process( void );
int M_process_for_n_sec( int i_nmsec );
// In/out process
void M_SDL_Process();

//T_BOOL M_doInit_SDL( int argc, char *argv[]);


/*************************************/
/** Some global objects & resources **/
void cgb_set_scene_depart_name(char *ip_name);
void cgb_set_scene_perso_name(char *ip_name);
char *cgb_get_scene_depart_name();
char *cgb_get_scene_perso_name();

extern T_Name O_gObjName_Mouse;
extern T_Name O_gObjName_Perso;
void M_set_obj_mouse_name(char *ip_name);
void M_set_obj_perso_name(char *ip_name);
char *M_get_obj_perso_name();

extern T_Name	O_gSceneName_Pannel;
extern T_Name	O_gObjetName_Panneau;
extern T_Name	O_gObjetName_PanneauDroit;
extern T_Name	O_gObjetName_PanneauGauche;
extern T_Name	O_gObjetName_Panneau_Aff1;
extern T_Name	O_gObjetName_Panneau_Aff2;
extern T_Name	O_gObjetName_Panneau_Aff3;

void M_setSceneName_Pannel(char *ip_name);
void M_setObjetName_Panneau(char *ip_name);
void M_setObjetName_PanneauDroit(char *ip_name);
void M_setObjetName_PanneauGauche(char *ip_name);
void M_setObjetName_Panneau_Aff1(char *ip_name);
void M_setObjetName_Panneau_Aff2(char *ip_name);
void M_setObjetName_Panneau_Aff3(char *ip_name);

extern T_Name	I_gSceneName_Dialogue;
void M_setSceneName_Dialogue(char *ip_name);

extern T_Name	A_gResName_Ascii;
void A_setResName_Ascii(char *ip_name);

extern T_Name	I_gResName_Mouse_normal;
extern T_Name	I_gResName_Mouse_clickable;
extern T_Name	I_gResName_Mouse_go;
void I_setResName_Mouse_Normal(char *ip_name);
void I_setResName_Mouse_Clickable(char *ip_name);
void I_setResName_Mouse_Go(char *ip_name);

extern T_Name	M_gResName_Dep_Attente;
extern T_Name	M_gResName_Dep_Gauche;
extern T_Name	M_gResName_Dep_Droit;
void I_setResName_Dep_Attente(char *ip_name);
void I_setResName_Dep_Gauche(char *ip_name);
void I_setResName_Dep_Droit(char *ip_name);


/*********************************/
/**** scenes engine fonctions ****/
void cgb_scenes_current_set(char *ip_name);
char *cgb_scenes_current_get_name();


/*********************************/
/**** Project                 ****/
void M_project_new();

#endif

