/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Scnes
 *
 *
 */
#ifndef M_SCENE_H
#define M_SCENE_H


/****** System Includes ******/
/****** Application Includes ******/
#include "M_types.h"
#include "R_ressources.h"


typedef	int TE_SceneId;

class TC_SCENE {
	public:
    T_BOOL      isUsed;
	TE_ResId	list_res[255];
	char		name[NAMELEN];
	float		scale_perso;
	TC_SCENE();
	void clear();
	void setName(char *ip_name);
	void setScalePerso(float i_scale);
	void loadScene();
	void unloadScene();
	T_BOOL isName(char *ip_name);
};
typedef TC_SCENE* TPC_Scene;


#define Nb_scenesMax	200
extern TC_SCENE			M_gTab_scene[Nb_scenesMax];
extern int				M_gNb_scenes;
extern TC_SCENE			M_gScene_active;


/*******************************/
/**** scene fonctions       ****/
char *M_Scene_get_name(TPC_Scene ip_scene);
char *M_Scene_set_name(TPC_Scene ip_scene);

/*******************************/
/**** scenes list fonctions ****/
int  cgb_scenes_clear();
int  cgb_scenes_add(char *ip_name, float i_scale);
int  cgb_scenes_add_from_file(char *ip_bufScene, char *ip_fileName);
int  cgb_scenes_add_from_mem(char *ip_bufScene);
int  cgb_scenes_ren(char *ip_name_old, char *ip_name_new);
int  cgb_scenes_del(char *ip_name);
int  cgb_scenes_get_index_by_name(char *ip_name);
TPC_Scene cgb_scenes_get_ptr_by_name(char *ip_name);
TPC_Scene cgb_scenes_get_ptr_by_index(int i_index);
int cgb_scenes_get_count();


#endif
