/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Type definitions
 *
 *
 */

#ifndef M_TYPES_H
#define M_TYPES_H

#define NAMELEN 255
#define PATHLEN	255
#define STRINGLEN	255

typedef char	T_Name[NAMELEN];
typedef char	T_String[STRINGLEN];

#ifdef USE_SDL
#include "SDL.h"
typedef	int * TP_DDCLIPPER ;      
typedef	int * TP_DDPALETTE;        
typedef int * TP_DD;
typedef SDL_Surface * TP_DDSurface;
#else

extern "C" {
#include <ddraw.h>
}
typedef	LPDIRECTDRAWCLIPPER     TP_DDCLIPPER ;
typedef	LPDIRECTDRAWPALETTE     TP_DDPALETTE;
typedef LPDIRECTDRAW TP_DD;
typedef	LPDIRECTDRAWSURFACE TP_DDSurface;
//typedef int Uint32;

#endif


#ifndef MSDEV_COCONUT // Linux, borland

typedef long T_DWORD;
typedef long CGB_DWORD; // CGB_ for Coconut Game Builder
typedef int T_WORD;
typedef struct {
    long    left;
    long    top;
    long    right;
    long    bottom;
} T_RECT;
typedef struct {
    long    x;
    long    y;
} T_POINT;

typedef int T_BOOL;
const T_BOOL T_FALSE=0;
const T_BOOL T_TRUE=1;

#define T_DDBLTFAST_NOCOLORKEY 0
#define T_DDBLTFAST_SRCCOLORKEY 1
#ifndef WIN32
typedef int HRESULT;
typedef int HWND;
typedef int WNDPROC;
typedef int HINSTANCE;
#endif

#else

#define T_WORD  WORD
#define T_DWORD DWORD
#define T_RECT  RECT
#define T_POINT POINT
#define T_BOOL  BOOL
#define T_TRUE  TRUE
#define T_FALSE FALSE

#define T_DDBLTFAST_NOCOLORKEY DDBLTFAST_NOCOLORKEY
#define T_DDBLTFAST_SRCCOLORKEY DDBLTFAST_SRCCOLORKEY
#endif


int M_name_cpy(char *op_outname, char *ip_inname);

#endif

