/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Objets
 *
 *
 */

#ifndef O_OBJETS_H
#define O_OBJETS_H


/****** System Includes ******/
/****** Application Includes ******/
#include "M_types.h"
#include "R_ressources_anims.h"
#include "M_scenes.h"
#include "A_text.h"

typedef enum {
	EtatId_Null,
	EtatId_Normal,
	EtatId_Presse,
	EtatId_Max
} TE_EtatId;


class TC_Object {
	public:
	char					name[NAMELEN];
	char					affName[NAMELEN];
	char					ResAnimName[NAMELEN];
	TPC_RESBITMAP			ptAnimCourante;
	TPC_RESBITMAP			PtImageAnimCourante;
	T_DWORD					cptTick;
	T_POINT					ptCoordInit;
	T_POINT					ptCoord;
	T_POINT					ptCoordDest;
	long					timeDest;
	float					ptCoordResteX;
	float					ptCoordResteY;
	T_POINT					ptSize; // Si zone de click sans Anim
	T_POINT					ptHotSpot;
	T_POINT					ptVit;
	T_POINT					ptVitScroll;
	T_POINT					ptScroll;
	T_POINT					ptText;
	cgb_text_id				idText;
	TE_SceneId				Scene;
	char					SceneName[NAMELEN];
	char					SceneSuivanteName[NAMELEN];
	char					SceneSuivantePoint[NAMELEN];
	T_BOOL					isClickable;
	T_BOOL					isDragAndDrop;
	T_BOOL					isAfficher;
	T_BOOL					is_ZoneDep;
	TE_EtatId				etat;
	float					scale;
	int Clear();
	int SetName(char *ip_name);
	int SetAffName(char *ip_name);
	int SetResAnimName(char *ip_name);
	int SetSceneName(char *ip_name);
	int SetSceneSuivanteName(char *ip_name);
	int SetSceneSuivantePoint(char *ip_name);
	int SetptCoordInit(int i_x, int i_y);
	int SetptCoord(int i_x, int i_y);
	int SetptSize(int i_x, int i_y);
	int SetptText(int i_x, int i_y);
	int SetptHotSpot(int i_x, int i_y);
	int SetisClickable(T_BOOL i_val);
	int SetisAfficher(T_BOOL i_val);
	int SetisZoneDep(T_BOOL i_val);
	int SetisDragAndDrop(T_BOOL i_val);
	void SetAnimCourante(TE_ResId i_idResAnim);
	void SetAnimCourantebyName(char *ip_name);
	int SetScale(float i_scale);
	T_BOOL isName(char *ip_name);
	T_BOOL isSceneName(char *ip_name);
    T_BOOL isResAnimName(char *ip_name);
	T_BOOL isChgtScene();
	T_BOOL isZoneDep();
	void SetPointDest(char *ip_pointDest, long i_tempsParcours);
	void SetPointDest(char *ip_pointDest, int i_dx, int i_dy, long i_tempsParcours);
	void Reinit();

	void AffOffScreen(TP_DDSurface ip_Dest);
	void AffOffScreen(TP_DDSurface ip_Dest, long i_dX, long i_dY);

	int Anim();
	T_BOOL ContientPt(int i_x, int i_y);
	int AffText(char *ip_resName, T_DWORD i_dureeAff, T_BOOL i_isFond);
	void SetTextScroll(int i_nbLignes, T_DWORD i_timerScroll);
	int getWidth();
};

typedef TC_Object* TPC_Object;

typedef int TE_ObjectId;

#define			 Nb_objetsMax	500
extern TC_Object O_gTab_Objets[Nb_objetsMax];
extern int		 O_gNb_objets;


/*******************************/
/**** object fonctions       ****/



/*******************************/
/**** objects list fonctions ****/
int cgb_obj_clear();
int cgb_obj_add_default(char *ip_bufName);
int cgb_obj_add_attr(
			   char *ip_bufName,
			   char *ip_bufResAnimName,
			   char *ip_bufSceneName,
			   int i_ptCoord_x, int i_ptCoord_y,
			   int i_ptSize_x, int i_ptSize_y,
			   int i_ptHotSpot_x, int i_ptHotSpot_y,
			   int l_ptText_x, int l_ptText_y,
			   T_BOOL i_isClickable,
               T_BOOL i_isAfficher,  T_BOOL i_isZoneDep, T_BOOL l_isDragAndDrop,
			   char *ip_bufSceneSuivanteName, 
			   char *ip_bufSceneSuivantePoint);
int cgb_obj_add_from_file(char *ip_bufObj, char *ip_fileName);
int cgb_obj_add_from_mem(char *ip_bufObj);
int cgb_obj_ren(char *ip_name_old, char *ip_name_new);
void cgb_obj_del(char *ip_name);

int cgb_obj_get_index_by_name(char *ip_name);
TPC_Object cgb_obj_get_ptr_by_name(char *ip_name);
TPC_Object cgb_obj_get_ptr_by_index(int i_index);
int cgb_obj_get_count();

int cgb_obj_set_selected_name(char *ip_name);
char *cgb_obj_get_selected_name();
int cgb_obj_is_selected_name(char *ip_name);

void cgb_obj_warning_resource_update(char *ip_res_name);

#endif