/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Affichage du panneau droit droulant
 *
 *
 */
#ifndef A_PANNEAU_H
#define A_PANNEAU_H

/****** System Includes ******/
#ifdef WIN32
#include "windows.h"
#endif
/****** Application Includes ******/
#include "M_types.h"
#include "O_objets.h"

typedef enum {
	EtatPanneau_Ferme,
	EtatPanneau_Ouvrant,
	EtatPanneau_Ouvert,
	EtatPanneau_Fermant
} TE_EtatPanneau;

class TC_Panneau : public TC_Object {
public:
	int				premObjetAff;
	TE_EtatPanneau	etatOuverture;
	long			xPanneauFerme;
	long			xPanneauOuvert;
	long			vitPanneau;
	void InitPanneau(long i_xOuvert, long i_xFerme);
	void GestionPanneau(long i_xMouse, long i_yMouse);
	int				getNbObjets();
};

/****** Variables globales ******/
extern TC_Panneau O_gPanneau;
/****** Fonctions ******/


#endif