/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Ressources
 *
 *
 */

#ifndef R_RESSOURCES_H
#define R_RESSOURCES_H

/****** System Includes ******/
/****** Application Includes ******/
#include "M_types.h"
#include "R_ressources_anims.h"
#include "R_ressources_text.h"
#include "R_ressources_bmp.h"


typedef int TE_ResId;

typedef enum {
	ResType_Null=0,
	ResType_Anim,
	ResType_Bmp,
	ResType_AviCD,
	ResType_Wav,
	ResType_Mid,
	ResType_PisteCD,
	ResType_Text
} TE_ResType;



class TC_Res {
	public:
	T_Name			name;
	TE_ResType		type;
	TC_RESBITMAP	resAnim;
	TC_RESBMP		resBmp;
	TC_RESTEXT		resText;
    TC_RESSON       resSon;
	int isName(char *ip_name);
	int Clear();
	int SetName(char *ip_name);
	int SetType(char *ip_type);
	int GetName(char *op_name);
	int GetType(char *op_type);
    T_BOOL isTypeAnim();
    T_BOOL isTypeText();
    T_BOOL isTypeWav();
    T_BOOL isTypeMid();
    T_BOOL isTypePisteCD();
    T_BOOL isTypeSon();
};
typedef TC_Res* TPC_Res;


#define R_LastLabel "ENDTAB"
typedef struct {
	char			label[16];
} TS_label;

#define Nb_resMax	1500
extern TC_Res	R_gTab_res[Nb_resMax];
extern int		R_gNb_res;
extern TS_label	R_gTab_resType[];

/***** functions ****/
int cgb_res_clear();
int cgb_res_add(char *ip_name, char *ip_type);
int cgb_res_ren(char *ip_name_old, char *ip_name_new);
int cgb_res_del(char *ip_name);
int cgb_res_text_add(char *ip_name, char *ip_text, char *ip_textEng);
int cgb_res_anim_add(char *ip_name);
int cgb_res_wav_add(char *ip_name, char *ip_fileName);
int cgb_res_mid_add(char *ip_name, char *ip_fileName);

int cgb_res_add_from_file(char *ip_bufRes, char *ip_fileName);
int cgb_res_add_from_mem(char *ip_bufRes);

int cgb_res_get_index_by_name(char *ip_name);
TPC_Res cgb_res_get_ptr_by_name(char *ip_name);
TPC_Res cgb_res_get_ptr_by_index(int i_index);
int cgb_res_get_count();

int cgb_res_anim_get_index_by_name(char *ip_name);


#endif