/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Ressources Anims
 *
 *
 */
#ifndef R_RESSOURCES_ANIMS_H
#define R_RESSOURCES_ANIMS_H


#include "SDL.h"

/****** System Includes ******/
#ifdef WIN32
#include <ddraw.h>
#endif
/****** Application Includes ******/
#include "M_types.h"


#include "A_directdraw.h"
#include "A_directdraw_util.h"

class TC_RESBITMAP
{
  public:
 	TC_RESBITMAP		*pNext;
 	T_DWORD				tempo;	// Temps d'afichage de l'image en ms
	T_DWORD				dwColor;
	T_DWORD				dwTrans;

	TP_DDSurface	lpSurface;

	T_RECT				recRect;
	T_POINT				ptHotSpot;
	char				filePath[PATHLEN];
	TC_RESBITMAP();
	~TC_RESBITMAP();
	void SetNext(TC_RESBITMAP* pNext);
	void FreeSurface();

	void SetSurface(TP_DD ip_DD, TP_DDSurface lpSource, T_RECT recZone, T_BOOL isTransparentKey);
	void AffOffScreen(TP_DDSurface ip_Dest, int i_x, int i_y, T_RECT *rectSrc, float i_scale, int i_scroll_x, int i_scroll_y);
	void AffOffScreen(TP_DDSurface ip_Dest, int i_x, int i_y, float i_scale, int i_scroll_x, int i_scroll_y);
	void AffOffScreen(TP_DDSurface ip_Dest, T_POINT ptCoord, float i_scale, int i_scroll_x, int i_scroll_y);
	T_BOOL LoadBitmapFromWholeFile(TPC_DDRAW pdDraw, int i_position, char *ip_filename);
	T_BOOL LoadBitmapFromPartOfFile(TPC_DDRAW pdDraw, char *ip_filename);

	T_BOOL SetBitmapFromWholeFile(int i_position, char *ip_filename);
	void SetTempo(int i_position, T_DWORD i_tempo);
    int GetNbNext();
    TC_RESBITMAP *GetNNext(int i_n);
    int AddNewResBitmapAtPosN(int i_n);
    int DelResBitmapAtPosN(int i_n);
    T_BOOL  isTransparent();

	void SetSurfaceDXFromSDL(TP_DD ip_DD, SDL_Surface *ip_Source, T_RECT i_recZone, T_BOOL isTransparentKey/*=TRUE*/);

};
typedef TC_RESBITMAP	*TPC_RESBITMAP;


#endif


