/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */



/****** Includes systmes ******/
#include <stdlib.h>
#include <time.h>

/****** Includes applicatifs ******/
#include "A_aff.h"
#include "M_scenes.h"
#include "O_objets.h"
#include "O_panneau.h"
#include "A_text.h"
#include "M_dialogue.h"
#include "I_input.h"
#include "M_engine.h"

/****** Global Variables ******/
TC_DDRAW		A_gAff;
int				A_cpt_mvt=0;
int				A_nbObjAff=0;
int				A_tabObjAff[Nb_objetsMax];
int				A_secousse=0;
int				A_sec_on=0;
int				A_sec_timer;
T_BOOL			A_gAffMouse=T_TRUE;
T_BOOL			A_gAffPerso=T_TRUE;

void gcd_aff_mouse_on()
{
	A_gAffMouse=T_TRUE;
}

void gcd_aff_mouse_off()
{
	A_gAffMouse=T_FALSE;
}

void gcd_aff_player_on()
{
	A_gAffPerso=T_TRUE;
}

void gcd_aff_player_off()
{
	A_gAffPerso=T_FALSE;
}

void gcd_aff_shake()
{
	A_sec_on = 1;
	A_sec_timer = 50;
	srand( (unsigned)time( NULL ) );
}

void gcb_aff_offscreen()
{
	int cpt;
	int l_c1, l_c2, l_c_tmp;
	int l_h1, l_h2;
	static int s_sec_x =0;
	static int s_sec_y =0;
	int l_xPos;
	int l_cptAff;
	int l_len;

	/*** Gestion des secoussess ***/
	if (A_sec_on) {
		A_sec_timer--;
		s_sec_x = rand()%8;
		s_sec_y = rand()%8;
		if (A_sec_timer<=0) {
			A_sec_on = 0;
			s_sec_x = 0;
			s_sec_y = 0;
		}
	}

	/*** Liste des objets a afficher, dont perso ***/
	A_nbObjAff=0;
	if (M_g_coco_editor) {
		for (cpt=1; cpt<O_gNb_objets; cpt++) {
			if (O_gTab_Objets[cpt].isSceneName(cgb_scenes_current_get_name())) 
			{
					A_tabObjAff[A_nbObjAff++]=cpt;
			}
		}
	} else {
		for (cpt=1; cpt<O_gNb_objets; cpt++) {
			if (  (O_gTab_Objets[cpt].isSceneName(cgb_scenes_current_get_name())) 
				||(O_gTab_Objets[cpt].isSceneName(cgb_get_scene_perso_name())))
			{
				if (O_gTab_Objets[cpt].isAfficher) {
					A_tabObjAff[A_nbObjAff++]=cpt;
				}
			}
		}
	}
	/*** Tri pour affichage ***/
	for (l_c1=A_nbObjAff; l_c1>=0; l_c1--) {
		for (l_c2=0; l_c2<l_c1; l_c2++) {
			l_h1 = (O_gTab_Objets[A_tabObjAff[l_c1]].ptCoord.y +
				   O_gTab_Objets[A_tabObjAff[l_c1]].ptHotSpot.y);
			l_h2 = (O_gTab_Objets[A_tabObjAff[l_c2]].ptCoord.y +
				   O_gTab_Objets[A_tabObjAff[l_c2]].ptHotSpot.y);
			if ( l_h1 < l_h2 ) {
				l_c_tmp = A_tabObjAff[l_c1];
				A_tabObjAff[l_c1] = A_tabObjAff[l_c2];
				A_tabObjAff[l_c2] = l_c_tmp;
			}
		}
	}

	/**** Deplacement du perso ***/
	TPC_Object lp_perso;
	lp_perso = cgb_obj_get_ptr_by_name(O_gObjName_Perso);
	A_gAff.traceRect(0,  0, 640,  480, 255);
	if (M_g_coco_editor) {
	} else {
		if ((A_cpt_mvt==5)||(A_cpt_mvt==10)) {
			lp_perso->ptCoord.x += (30*lp_perso->ptVit.x);
			lp_perso->ptCoord.y += (30*lp_perso->ptVit.y);
			A_cpt_mvt++;
		}
		if (A_cpt_mvt>=10) {
			A_cpt_mvt=1;
		}
	}
	/*** Affichage des objets ***/
	int l_perso_num;
	l_perso_num = cgb_obj_get_index_by_name(O_gObjName_Perso);

	for (cpt=0; cpt<A_nbObjAff; cpt++) {
		if (A_tabObjAff[cpt] != l_perso_num) {
			O_gTab_Objets[A_tabObjAff[cpt]].Anim();
			O_gTab_Objets[A_tabObjAff[cpt]].AffOffScreen(A_gAff.lpDDSBack, s_sec_x, s_sec_y);
//			O_gTab_Objets[A_tabObjAff[cpt]].AffOffScreen(A_gAff.lpDDSPrimary, s_sec_x, s_sec_y);
		} else {
			if (A_gAffPerso==T_TRUE) {
				O_gTab_Objets[A_tabObjAff[cpt]].AffOffScreen(A_gAff.lpDDSBack, s_sec_x, s_sec_y);
			}
		}
	}
	//O_gTab_Objets[ObjectId_Perso].AffOffScreen(A_gAff.lpDDSBack);

	/*** animation du perso ***/
	A_cpt_mvt += lp_perso->Anim();




	/*** Panneau ***/
	O_gPanneau.Anim();
	if (!M_g_coco_editor) {
		O_gPanneau.AffOffScreen(A_gAff.lpDDSBack);

		if (cgb_dialog_is_on()) {
		/*** Dialogue ***/
			for (cpt=1; cpt<O_gNb_objets; cpt++) {
				if (O_gTab_Objets[cpt].isSceneName(I_gSceneName_Dialogue)) {
						O_gTab_Objets[cpt].Anim();
						O_gTab_Objets[cpt].AffOffScreen(A_gAff.lpDDSBack,
							0, 0);
				}
			}
		} else {
		/*** Objets du panneau ***/
			l_xPos = O_gPanneau.ptCoord.x+30;
			l_cptAff=0;
			for (cpt=1; cpt<O_gNb_objets; cpt++) {
				if (O_gTab_Objets[cpt].isSceneName(O_gSceneName_Pannel)) {
					if (O_gTab_Objets[cpt].isAfficher) {
						O_gTab_Objets[cpt].Anim();
						//if ( (!O_gTab_Objets[cpt].isName(O_gObjetName_PanneauDroit)) && (!O_gTab_Objets[cpt].isName(O_gObjetName_PanneauGauche))) {
								O_gTab_Objets[cpt].SetptCoord(l_xPos, O_gPanneau.ptCoord.y+10);
								if ( (l_xPos + O_gTab_Objets[cpt].getWidth()) < (O_gPanneau.ptCoord.x + O_gPanneau.getWidth())) {
									l_cptAff++;
									if (l_cptAff>=O_gPanneau.premObjetAff) {
										O_gTab_Objets[cpt].AffOffScreen(A_gAff.lpDDSBack,
											0, O_gPanneau.ptCoord.y - O_gPanneau.xPanneauOuvert);
										l_xPos += O_gTab_Objets[cpt].getWidth();
									}
								}
			
						//} else {
						//			O_gTab_Objets[cpt].AffOffScreen(A_gAff.lpDDSBack,
						//				0, O_gPanneau.ptCoord.y - O_gPanneau.xPanneauOuvert);
						//}
						// Perhaps, something to do here !!!!!!!!!!!
					}
				}
			}
		}
	}

	/*** texte ***/
	for (cpt=1; cpt<CGB_NB_TEXT_MAX; cpt++) 
	{
		if (A_gTab_Text[cpt].isActif == T_TRUE) 
		{
			// Dure d'affichage
			if (A_gTab_Text[cpt].debutAff == 0) {
				A_gTab_Text[cpt].debutAff = I_GetTickCount();
			} else {
				if ((I_GetTickCount()-A_gTab_Text[cpt].debutAff)>A_gTab_Text[cpt].dureeAff) {
					cgb_text_remove(cpt);
				}
			}
			// Affichage
			if (A_gTab_Text[cpt].isScroll == T_FALSE) {
				l_len = R_gTab_res[A_gTab_Text[cpt].resId].resText.GetTextLen();
			} else {
				l_len = (I_GetTickCount()-A_gTab_Text[cpt].debutAff)*R_gTab_res[A_gTab_Text[cpt].resId].resText.GetTextLen()/A_gTab_Text[cpt].timerScroll;
			}
			A_gAff.AffText( 
				R_gTab_res[A_gTab_Text[cpt].resId].resText.GetText(),
				l_len,
				A_gTab_Text[cpt].ptCoord.x,
				A_gTab_Text[cpt].ptCoord.y,
				A_gTab_Text[cpt].isFond
			);
		}
	}	


	/*** souris ***/
	TPC_Object lp_mouse;
	if (A_gAffMouse == T_TRUE) {
		lp_mouse = cgb_obj_get_ptr_by_name(O_gObjName_Mouse);

		lp_mouse->ptCoord.x = A_gXMouse;
		lp_mouse->ptCoord.y = A_gYMouse;
		lp_mouse->Anim();
		lp_mouse->AffOffScreen(A_gAff.lpDDSBack);
	}

#ifdef USE_SDL
#else
	/*** Aff test d'acces direct ***/
	T_RECT DestRect={0,0,300,0} ;
	DDSURFACEDESC ddsd;
	T_DWORD dwFlags=DDLOCK_WAIT;
	HRESULT ret,ret2;
	T_DWORD x,y;
	char *ptr_c;
	WORD *ptr_w;
	static WORD col=0;
//	WORD RR,GG,BB;

    ddsd.dwSize = sizeof(ddsd);
	col++;
	//ret = A_gAff.lpDDSBack->Lock(NULL, &DDSurfaceDesc, NULL, NULL);
    while ((ret2 = A_gAff.lpDDSBack->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
	switch(ret2) {
	case DD_OK:
		// ddsd.dwHeight : Hauteur
		// ddsd.dwWidth  : Largeur
		// ddsd.lPitch   : distance mmoire entre deux lignes
		// Mise en noir de la ligne du bas (-2 et -1)
		ptr_c = (char *)(ddsd.lpSurface);

		ptr_w = (WORD *)(ptr_c + ((ddsd.dwHeight-2)*(ddsd.lPitch)));
		for (x=0; x<(ddsd.dwWidth); x+=1) {
			(*ptr_w) = 0;
			ptr_w++;
		}

		ptr_w = (WORD *)(ptr_c + ((ddsd.dwHeight-1)*(ddsd.lPitch)));
		for (x=0; x<(ddsd.dwWidth); x+=1) {
			(*ptr_w) = 0;
			ptr_w++;
		}



	// Mise en noir de la colonne de droite
		ptr_c = (char *)(ddsd.lpSurface);
		for (y=0; y<(ddsd.dwHeight); y+=1) {
			ptr_w = (WORD *)(ptr_c + y*(ddsd.lPitch) + ((ddsd.dwWidth-2)*(2)));
			(*ptr_w) = 0;
		}
		ptr_w = (WORD *)(ptr_c + ((ddsd.dwWidth-1)*(2)));
		for (y=0; y<(ddsd.dwHeight); y+=1) {
			ptr_w = (WORD *)(ptr_c + y*(ddsd.lPitch) + ((ddsd.dwWidth-1)*(2)));
			(*ptr_w) = 0;
		}

/*		for (x=50; x<(ddsd.dwWidth-50); x+=1) {
			for (y=50; y<(ddsd.dwHeight-50); y+=1) {
				// Pixel sur 16 bits
				ptr_w  = (WORD *)(ptr_c+(x+x)+(y*(ddsd.lPitch)));

				RR = (WORD)(y+col+x);
				GG = (WORD)(y+col+2*x+3*y);
				BB = (WORD)(y+col);

				(*ptr_w) = ( (0x00007C00 & RR)
							|(0x000003E0 & GG)
							|(0x0000001F & BB)
						   );
				(*ptr_w) = 0;
			}
		}
*/
		break;
	case DDERR_INVALIDOBJECT :
		ret=DD_OK;
		break;
	case DDERR_INVALIDPARAMS: 
		ret=DD_OK;
		break;
	case DDERR_OUTOFMEMORY :
		ret=DD_OK;
		break;
	case DDERR_SURFACEBUSY: 
		ret=DD_OK;
		break;
	case DDERR_SURFACELOST:
		ret=DD_OK;
		break;
	case DDERR_WASSTILLDRAWING: 
		ret=DD_OK;
		break;
	default:
		ret=DD_OK;
		break;
	}
	A_gAff.lpDDSBack->Unlock(NULL);
	if (ret2==DD_OK) {
		ret=DD_OK;
	}
#endif
}



void gcb_aff_screen()
{
	A_gAff.updateFrame();
}