/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  DirectDraw
 *
 *
 */
/****** Includes systmes ******/
#ifdef WIN32
#include <windowsx.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/****** Includes applicatifs ******/
#include "A_directdraw.h"
#include "R_ressources.h"
#include "A_aff.h"
#include "M_types.h"
#include "A_text.h"
#include "A_sge.h"
#include "M_engine.h"




T_BOOL TC_DDRAW::initFail(char *ip_msg)
{
    finiObjects();
#ifdef USE_SDL
#else
    MessageBox( hwnd, ip_msg, "Init Direct Draw", MB_OK );
    DestroyWindow( hwnd );
#endif
    return T_FALSE;
} 

T_BOOL TC_DDRAW::traceEmptyRect( int i_left,  int i_top,  int i_right,  int i_bottom, T_WORD i_coul)
{
#ifdef USE_SDL
	Uint32 l_color=i_coul;

	if (i_left<0) i_left=0;
	if (i_top<0) i_top=0;
	if (i_right<i_left) i_right=i_left;
	if (i_right>640) i_right=640;
	if (i_bottom<i_top) i_bottom=i_top;
	if (i_bottom>640) i_bottom=640;
	sge_Rect(lpDDSBack, i_left, i_top, i_right, i_bottom, l_color);
	return T_FALSE;
#else
	/*** Aff test d'acces direct ***/
	RECT DestRect={0,0,300,0} ;
	DDSURFACEDESC ddsd;
	T_DWORD dwFlags=DDLOCK_WAIT;
	HRESULT ret,ret2;
	int x,y;
	char *ptr_c;
	T_WORD *ptr_w;
	static T_WORD col=0;

    ddsd.dwSize = sizeof(ddsd);
	col++;
    while ((ret2 = lpDDSBack->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
	switch(ret2) {
	case DD_OK:
		// ddsd.dwHeight : Hauteur
		// ddsd.dwWidth  : Largeur
		// ddsd.lPitch   : distance mmoire entre deux lignes
		// Mise en noir de la ligne du bas (-2 et -1)
		if (i_left<0)	{ i_left=0;}
		if (i_top<0)	{ i_top=0;}
		if (i_right<0)	{ i_right=0;}
		if (i_bottom<0) { i_bottom=0;}
		if (i_left>=(signed int)ddsd.dwWidth)	{ i_left=(signed int)ddsd.dwWidth-1;}
		if (i_top>=(signed int)ddsd.dwHeight)	{ i_top=(signed int)ddsd.dwHeight-1;}
		if (i_right>=(signed int)ddsd.dwWidth)	{ i_right=(signed int)ddsd.dwWidth-1;}
		if (i_bottom>=(signed int)ddsd.dwHeight){ i_bottom=(signed int)ddsd.dwHeight-1;}

		ptr_c = (char *)(ddsd.lpSurface);

		for (y=i_top; y<i_bottom; y+=1) {
			for (x=i_left; x<i_right; x+=1) {
				ptr_w = (T_WORD *)(ptr_c + (y*(ddsd.lPitch)) + (x*(2)));
				(*ptr_w) = i_coul;
				ptr_w++;
			}
		}

		break;
	case DDERR_INVALIDOBJECT :
		ret=DD_OK;
		break;
	case DDERR_INVALIDPARAMS: 
		ret=DD_OK;
		break;
	case DDERR_OUTOFMEMORY :
		ret=DD_OK;
		break;
	case DDERR_SURFACEBUSY: 
		ret=DD_OK;
		break;
	case DDERR_SURFACELOST:
		ret=DD_OK;
		break;
	case DDERR_WASSTILLDRAWING: 
		ret=DD_OK;
		break;
	default:
		ret=DD_OK;
		break;
	}
	A_gAff.lpDDSBack->Unlock(NULL);
	if (ret2==DD_OK) {
		ret=DD_OK;
	}
	return ret;
#endif
}


T_BOOL TC_DDRAW::traceRect( int i_left,  int i_top,  int i_right,  int i_bottom, T_WORD i_coul)
{
#ifdef USE_SDL
	SDL_Rect l_rect;

	l_rect.x = i_left;
	l_rect.y = i_top;
	l_rect.w = i_right-i_left;
	l_rect.h = i_bottom-i_top;

	SDL_FillRect(lpDDSBack, &l_rect, i_coul);
	return T_FALSE;
#else
	/*** Aff test d'acces direct ***/
	RECT DestRect={0,0,300,0} ;
	DDSURFACEDESC ddsd;
	T_DWORD dwFlags=DDLOCK_WAIT;
	HRESULT ret,ret2;
	int x,y;
	char *ptr_c;
	T_WORD *ptr_w;
	static T_WORD col=0;

    ddsd.dwSize = sizeof(ddsd);
	col++;
    while ((ret2 = lpDDSBack->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
	switch(ret2) {
	case DD_OK:
		// ddsd.dwHeight : Hauteur
		// ddsd.dwWidth  : Largeur
		// ddsd.lPitch   : distance mmoire entre deux lignes
		// Mise en noir de la ligne du bas (-2 et -1)
		if (i_left<0)	{ i_left=0;}
		if (i_top<0)	{ i_top=0;}
		if (i_right<0)	{ i_right=0;}
		if (i_bottom<0) { i_bottom=0;}
		if (i_left>=(signed int)ddsd.dwWidth)	{ i_left=(signed int)ddsd.dwWidth-1;}
		if (i_top>=(signed int)ddsd.dwHeight)	{ i_top=(signed int)ddsd.dwHeight-1;}
		if (i_right>=(signed int)ddsd.dwWidth)	{ i_right=(signed int)ddsd.dwWidth-1;}
		if (i_bottom>=(signed int)ddsd.dwHeight){ i_bottom=(signed int)ddsd.dwHeight-1;}

		ptr_c = (char *)(ddsd.lpSurface);

		for (y=i_top; y<i_bottom; y+=1) {
			for (x=i_left; x<i_right; x+=1) {
				ptr_w = (T_WORD *)(ptr_c + (y*(ddsd.lPitch)) + (x*(2)));
				(*ptr_w) = i_coul;
				ptr_w++;
			}
		}

		break;
	case DDERR_INVALIDOBJECT :
		ret=DD_OK;
		break;
	case DDERR_INVALIDPARAMS: 
		ret=DD_OK;
		break;
	case DDERR_OUTOFMEMORY :
		ret=DD_OK;
		break;
	case DDERR_SURFACEBUSY: 
		ret=DD_OK;
		break;
	case DDERR_SURFACELOST:
		ret=DD_OK;
		break;
	case DDERR_WASSTILLDRAWING: 
		ret=DD_OK;
		break;
	default:
		ret=DD_OK;
		break;
	}
	A_gAff.lpDDSBack->Unlock(NULL);
	if (ret2==DD_OK) {
		ret=DD_OK;
	}
	return ret;
#endif
}

#ifndef WIN32
int min(int i_a, int i_b)
{
  if (i_a<i_b) return i_a;
  else
    return i_b;
}
#endif

T_BOOL TC_DDRAW::traceRectSoftCorner( int i_left,  int i_top,  int i_right,  int i_bottom, int i_R, int i_G, int i_B)
{
	int x,y;
	char *ptr_c;
	char *ptr_p1;
	T_WORD *ptr_p2;
	char *ptr_p3;
	long *ptr_p4;
	static T_WORD col=0;
	long i_xdep, i_xfin;
	int l_BytesPerPixel;
	Uint32 l_coul;
	char *lp_coul;
#ifdef USE_SDL
	if (ptr_c) {
		if (i_left<0)	{ i_left=0;}
		if (i_top<0)	{ i_top=0;}
		if (i_right<0)	{ i_right=0;}
		if (i_bottom<0) { i_bottom=0;}
		if (i_left>=(signed int)lpDDSBack->w)	{ i_left=(signed int)lpDDSBack->w-1;}
		if (i_top>=(signed int)lpDDSBack->h)	{ i_top=(signed int)lpDDSBack->h-1;}
		if (i_right>=(signed int)lpDDSBack->w)	{ i_right=(signed int)lpDDSBack->w-1;}
		if (i_bottom>=(signed int)lpDDSBack->h){ i_bottom=(signed int)lpDDSBack->h-1;}

		ptr_c = (char *)(lpDDSBack->pixels);
		l_BytesPerPixel = (lpDDSBack->format)->BytesPerPixel;

		for (y=i_top; y<i_bottom; y+=1) {
			if ((y>(i_top+3))&&(y<(i_bottom-3))) {
				i_xdep = i_left;
				i_xfin = i_right;
			} else {
				i_xdep = i_left+3-min((y-i_top),(i_bottom-y));
				i_xfin = i_right-3+min((y-i_top),(i_bottom-y));
			}
			for (x=i_xdep; x<i_xfin; x+=1) {
				switch (l_BytesPerPixel) {
				case 1:
					ptr_p1 = (char *)(ptr_c + (y*(lpDDSBack->pitch)) + (x*(l_BytesPerPixel)));
					(*ptr_p1) = SDL_MapRGB(lpDDSBack->format, i_R, i_G, i_B);
					break;
				case 2:
					ptr_p2 = (T_WORD *)(ptr_c + (y*(lpDDSBack->pitch)) + (x*(l_BytesPerPixel)));
					(*ptr_p2) = SDL_MapRGB(lpDDSBack->format, i_R, i_G, i_B);
					break;
				case 3:
					ptr_p3 = (char *)(ptr_c + (y*(lpDDSBack->pitch)) + (x*(l_BytesPerPixel)));
					l_coul = SDL_MapRGB(lpDDSBack->format, i_R, i_G, i_B);
					lp_coul = (char *)&l_coul;
					(*(ptr_p3)) = (*lp_coul++);
					(*(ptr_p3+1)) = (*lp_coul++);;
					(*(ptr_p3+2)) = (*lp_coul++);;
					break;
				case 4:
					ptr_p4 = (long *)(ptr_c + (y*(lpDDSBack->pitch)) + (x*(l_BytesPerPixel)));
					(*ptr_p4) = SDL_MapRGB(lpDDSBack->format, i_R, i_G, i_B);
					break;
				default:
					break;
				}
			}
		}
	}
	return T_FALSE;
#else
	/*** Aff test d'acces direct ***/
	RECT DestRect={0,0,300,0} ;
	DDSURFACEDESC ddsd;
	T_DWORD dwFlags=DDLOCK_WAIT;
	HRESULT ret,ret2;
	T_WORD *ptr_w;

    ddsd.dwSize = sizeof(ddsd);
	col++;
    while ((ret2 = lpDDSBack->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
	switch(ret2) {
	case DD_OK:
		// ddsd.dwHeight : Hauteur
		// ddsd.dwWidth  : Largeur
		// ddsd.lPitch   : distance mmoire entre deux lignes
		// Mise en noir de la ligne du bas (-2 et -1)
		if (i_left<0)	{ i_left=0;}
		if (i_top<0)	{ i_top=0;}
		if (i_right<0)	{ i_right=0;}
		if (i_bottom<0) { i_bottom=0;}
		if (i_left>=(signed int)ddsd.dwWidth)	{ i_left=(signed int)ddsd.dwWidth-1;}
		if (i_top>=(signed int)ddsd.dwHeight)	{ i_top=(signed int)ddsd.dwHeight-1;}
		if (i_right>=(signed int)ddsd.dwWidth)	{ i_right=(signed int)ddsd.dwWidth-1;}
		if (i_bottom>=(signed int)ddsd.dwHeight){ i_bottom=(signed int)ddsd.dwHeight-1;}

		ptr_c = (char *)(ddsd.lpSurface);

		for (y=i_top; y<i_bottom; y+=1) {
			if ((y>(i_top+3))&&(y<(i_bottom-3))) {
				i_xdep = i_left;
				i_xfin = i_right;
			} else {
				i_xdep = i_left+3-min((y-i_top),(i_bottom-y));
				i_xfin = i_right-3+min((y-i_top),(i_bottom-y));
			}
			for (x=i_xdep; x<i_xfin; x+=1) {
				ptr_w = (T_WORD *)(ptr_c + (y*(ddsd.lPitch)) + (x*(2)));
				(*ptr_w) = i_R;
				ptr_w++;
			}
		}

		break;
	case DDERR_INVALIDOBJECT :
		ret=DD_OK;
		break;
	case DDERR_INVALIDPARAMS: 
		ret=DD_OK;
		break;
	case DDERR_OUTOFMEMORY :
		ret=DD_OK;
		break;
	case DDERR_SURFACEBUSY: 
		ret=DD_OK;
		break;
	case DDERR_SURFACELOST:
		ret=DD_OK;
		break;
	case DDERR_WASSTILLDRAWING: 
		ret=DD_OK;
		break;
	default:
		ret=DD_OK;
		break;
	}
	A_gAff.lpDDSBack->Unlock(NULL);
	if (ret2==DD_OK) {
		ret=DD_OK;
	}
	return ret;
#endif
}

/*
 * finiObjects
 *
 * finished with all objects we use; release them
 */
void TC_DDRAW::finiObjects()
{
#ifdef USE_SDL
	SDL_FreeSurface(lpDDSPrimary);
	SDL_FreeSurface(lpDDSBack);
	SDL_FreeSurface(lpDDSOne);

#else
    if( lpDD != NULL )
    {
        if( lpDDSPrimary != NULL )
        {
            lpDDSPrimary->Release();
            lpDDSPrimary = NULL;
        }
        if( lpDDSOne != NULL )
        {
            lpDDSOne->Release();
            lpDDSOne = NULL;
        }
        if( lpDDPal != NULL )
        {
            lpDDPal->Release();
            lpDDPal = NULL;
        }
        lpDD->Release();
        lpDD = NULL;
    }
#endif
} 


void TC_DDRAW::AffTextDC(char *msg, int len, long i_x, long i_y)
{
#ifdef USE_SDL
#else
  HDC		hdc;
  POINT     pt;

  if (lpDDSPrimary->GetDC(&hdc) == DD_OK)
  {
    SetTextColor(hdc, RGB(255, 255, 0));
	//SetBkMode(hdc,TRANSPARENT);
    SetBkColor(hdc, RGB(0, 0, 0));
	pt.x = i_x;
	pt.y = i_y;
	ClientToScreen(hwnd, &pt );
    TextOut(hdc, pt.x, pt.y, msg, len);

    lpDDSPrimary->ReleaseDC(hdc);
  }
#endif
}

void TC_DDRAW::AffText(char *msg, int len, long i_x, long i_y, T_BOOL l_isFond)
{
	long	cpt,l_cpt_bitmap;
	T_POINT	l_pos;
	TPC_RESBITMAP	lp_resBitmap;
	TPC_Res  lp_res;
	int		l_xmax, l_ymax;

	l_pos.x = i_x;
	l_xmax  = i_x;
	l_pos.y	= i_y;
	l_ymax  = i_y;
	lp_res = cgb_res_get_ptr_by_name(A_gResName_Ascii);

	if (l_isFond) {
		// Premier passage pour avoir les dimensions
		for (cpt=0; cpt<len; cpt++) {
			// Recupration de l'anim des lettres Ascii
			lp_resBitmap = &(lp_res->resAnim);

			// On gere les sauts de ligne
			if ((msg[cpt]=='/')) {
				l_pos.x = i_x;
				l_pos.y += 25;
			} else {
				// Positionnement sur la bonne lettre
				for (l_cpt_bitmap=0; l_cpt_bitmap<(unsigned char)msg[cpt]; l_cpt_bitmap++) {
					if (lp_resBitmap) {
						lp_resBitmap = lp_resBitmap->pNext;
					}
				}
				// Si l'anim des lettres n'est pas dispo, on rentre...
				if ((lp_resBitmap)&&(msg[cpt]!=0)) {
					// Incrment de la position d'affichage
					if (abs(lp_resBitmap->recRect.right)<50) {
						l_pos.x += lp_resBitmap->recRect.right;
					}
					if (l_pos.x>l_xmax) { 
						l_xmax = l_pos.x; 
					}
					l_ymax = l_pos.y+ lp_resBitmap->recRect.bottom;
				}
			}
		}
		// Affichage de la boite en blanc
		traceRectSoftCorner(i_x, i_y, l_xmax, l_ymax, 0, 0, 0);
		traceRectSoftCorner(i_x+1, i_y+1, l_xmax-1, l_ymax-1, 255, 255, 255);
	}

	// Second passage pour afficher le texte
	l_pos.x = i_x;
	l_pos.y	= i_y;
	for (cpt=0; cpt<len; cpt++) {
		// Recupration de l'anim des lettres Ascii
		lp_resBitmap = &(lp_res->resAnim);

		// On gere les sauts de ligne
		if ((msg[cpt]=='/')) {
			l_pos.x = i_x;
			l_pos.y += 25;
		} else {
			// Positionnement sur la bonne lettre
			for (l_cpt_bitmap=0; l_cpt_bitmap<(unsigned char)msg[cpt]; l_cpt_bitmap++) {
				if (lp_resBitmap) {
					lp_resBitmap = lp_resBitmap->pNext;
				}
			}
			// Si l'anim des lettres n'est pas dispo, on rentre...
			if (lp_resBitmap) {

				// Affichage de la lettre
				lp_resBitmap->AffOffScreen(A_gAff.lpDDSBack, l_pos, 0, 0, 0);

				// Incrment de la position d'affichage
				l_pos.x += lp_resBitmap->recRect.right;
			}
		}
	}  
}


void TC_DDRAW::AffText(char *msg, int len, T_BOOL l_isFond)
{
	AffText(msg, len, 0, 0, l_isFond);
}


void TC_DDRAW::updateFrame()
{
#ifdef USE_SDL
	SDL_BlitSurface(lpDDSBack, NULL, lpDDSPrimary, NULL);
	SDL_UpdateRect(lpDDSPrimary,0,0,0,0);
#else
    RECT                destRect;
    RECT                rcRect;
    POINT               pt;
    static int			hauteur_bordure=0;
    HRESULT				ddrval;

	if (mode_Windows) {
		// Recopie du back buffer dans le clipper;
		GetClientRect( hwnd, &destRect );
		if (destRect.right  < 128) destRect.right = 64;
		if (destRect.bottom < 64)  destRect.bottom = 64;
		rcRect=destRect;
		pt.x = pt.y = 0;
		ClientToScreen( hwnd, &pt );
		OffsetRect(&destRect, pt.x, pt.y+hauteur_bordure);
		ddrval = lpDDSPrimary->Blt( &destRect, lpDDSBack, &rcRect, 0,NULL );
	} else {
		// Flip the surfaces
		lpDD->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN, 0);
		while( 1 )
		{
			ddrval = lpDDSPrimary->Flip( NULL, 0 );
			if( ddrval == DD_OK )
			{
				break; 
			}
			if( ddrval == DDERR_SURFACELOST )
			{
				ddrval = restoreAll();
				if( ddrval != DD_OK )
				{
					break;
				}
			}
			if( ddrval != DDERR_WASSTILLDRAWING )
			{
				break;
			}
		}
	}
#endif
}


HRESULT TC_DDRAW::restoreAll( void )
{
#ifdef USE_SDL
	return 0;
#else
    HRESULT     ddrval;

    ddrval = lpDDSPrimary->Restore();
    if( ddrval == DD_OK )
    {
        ddrval = lpDDSOne->Restore();
        if( ddrval == DD_OK )
        {
            //DDReLoadBitmap(lpDDSOne, szBitmap);
        }
    }
    return ddrval;
#endif
} 


HWND TC_DDRAW::CreateDDWindow(int i_mode_Windows, WNDPROC WindowProc, HINSTANCE hInstance, int nCmdShow)
{
#ifdef USE_SDL
	/* La fentre existe dej, pas besoin de la crer*/
	return 0;
#else
    WNDCLASS            wc;

	mode_Windows = i_mode_Windows;

    /*
     * set up and register window class
     */
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon( hInstance, IDI_APPLICATION );
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    //wc.hbrBackground = (HBRUSH)GetStockBrush(BLACK_BRUSH);
    wc.hbrBackground = (HBRUSH)GetStockBrush(GRAY_BRUSH);
    wc.lpszMenuName = "winName";
    wc.lpszClassName = "winName";
    RegisterClass( &wc );
    
    /*
     * create a window
     */
	if (!mode_Windows) {
		hwnd = CreateWindowEx(
			0,
			"winName",
			"winTitle",
			WS_POPUP,
			0,
			0,
			GetSystemMetrics(SM_CXSCREEN),
			GetSystemMetrics(SM_CYSCREEN),
			NULL,
			NULL,
			hInstance,
			NULL );
	} else {
		hwnd = CreateWindowEx(
			0,
			"winName",
			"winTitle",
			WS_OVERLAPPEDWINDOW ,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			640+6, //GetSystemMetrics(SM_CXSCREEN)/4,
			480+26, //GetSystemMetrics(SM_CXSCREEN)/4,
			NULL,
			NULL,
			hInstance,
			NULL );
	}

    if( !hwnd )
    {
        return T_FALSE;
    }

    ShowWindow( hwnd, nCmdShow );
    UpdateWindow( hwnd );
	return hwnd;
#endif
}


T_BOOL TC_DDRAW::AttachDDWindow(int i_mode_Windows, HWND i_hwnd, int resX, int resY, int resColorBit, Uint32 i_videoflags)
{
#ifdef USE_SDL
	Uint8 *buffer;
	int i;
	Uint32 flags;
	Uint32 Rmask=0;
	Uint32 Gmask=0;
	Uint32 Bmask=0;
	Uint32 Amask=0;
	const SDL_VideoInfo *lp_videoInfo;

	/* Set 640x480 video mode */
	printf("Set SDL video Mode\n");

	// Si on est en fentr, on rcupre le bpp actuel
	if ((i_videoflags&SDL_FULLSCREEN)==0) {
		lp_videoInfo = SDL_GetVideoInfo();
		if (lp_videoInfo) {
			resColorBit = lp_videoInfo->vfmt->BitsPerPixel;
		}
	}
	
	// On utilise la memoire video
	i_videoflags |= SDL_HWSURFACE;

	// On recupre la surface
	if ( (lpDDSPrimary=SDL_SetVideoMode(resX,resY,resColorBit,i_videoflags)) == NULL ) {
		fprintf(stderr, "Couldn't set 640x480x%d video mode: %s\n",
						resColorBit, SDL_GetError());
		return T_FALSE;
	}

	// Allocation de la surface de flipping
	flags = SDL_HWSURFACE;
	lpDDSBack = SDL_AllocSurface (flags, resX,resY,resColorBit, Rmask, Gmask, Bmask, Amask);



	/* Set the surface pixels and refresh! */
	printf("Init fond\n");
	if ( SDL_LockSurface(lpDDSPrimary) < 0 ) {
		fprintf(stderr, "Couldn't lock the display surface: %s\n",
							SDL_GetError());
		return T_FALSE;
	}
	buffer=(Uint8 *)lpDDSPrimary->pixels;
	for ( i=0; i<lpDDSPrimary->h; ++i ) {
		//memset(buffer,(i*255)/lpDDSPrimary->h, lpDDSPrimary->pitch);
		memset(buffer,0, lpDDSPrimary->pitch);
		buffer += lpDDSPrimary->pitch;
	}
	SDL_UnlockSurface(lpDDSPrimary);
	SDL_UpdateRect(lpDDSPrimary, 0, 0, 0, 0);

	return T_TRUE;
#else
    DDSURFACEDESC       ddsd;
    DDSCAPS             ddscaps;
    HRESULT             ddrval;


	mode_Windows = i_mode_Windows;
	if (i_hwnd) hwnd = i_hwnd;
    /*
     * create the main DirectDraw object
     */
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
    if( ddrval != DD_OK )
    {
        return initFail("DirectDrawCreate failed");
    }

	if (!mode_Windows) {
		// Get exclusive mode
		ddrval = lpDD->SetCooperativeLevel( hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
		if( ddrval != DD_OK )
		{
			return initFail("SetCooperativeLevel failed");
		}

		// Set the video mode to 800x600x16
		ddrval = lpDD->SetDisplayMode( resX, resY, resColorBit);
		if( ddrval != DD_OK )
		{
			return initFail("SetDisplayMode failed");
		}
	} else {
		ddrval = lpDD->SetCooperativeLevel( hwnd, DDSCL_NORMAL );
	}

	if (!mode_Windows) {
		// Create the primary surface with 1 back buffer
		ddsd.dwSize = sizeof( ddsd );
		ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
							  DDSCAPS_FLIP |
							  DDSCAPS_COMPLEX;
		ddsd.dwBackBufferCount = 1;
		ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
		if( ddrval != DD_OK )
		{
			return initFail("CreateSurface failed");
		}

		ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
		ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, &lpDDSBack);
		if( ddrval != DD_OK )
		{
			return initFail("GetAttachedSurface failed");
		}
	} else {
		// Create the primary surface
		ddsd.dwSize = sizeof( ddsd );
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

		ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
		if( ddrval != DD_OK )
		{
			return initFail("CreateSurface failed");
		}


		// Create a back surface
		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT |DDSD_WIDTH;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
		ddsd.dwWidth = resX;
		ddsd.dwHeight = resY;
		ddrval = lpDD->CreateSurface( &ddsd, &lpDDSBack, NULL );
		if( ddrval != DD_OK )
		{
			return initFail("CreateSurface failed");
		}



		// create a clipper for the primary surface
		ddrval = lpDD->CreateClipper( 0, &lpClipper, NULL );
		if( ddrval != DD_OK )
		{
			return initFail("CreateClipper failed");
		}
    
		ddrval = lpClipper->SetHWnd( 0, hwnd );
		if( ddrval != DD_OK )
		{
			return initFail("SetHWnd failed");
		}

		ddrval = lpDDSPrimary->SetClipper( lpClipper );
		if( ddrval != DD_OK )
		{
			return initFail("SetClipper failed");
		}

		// dimensionnement de la fentre
		SetWindowExtEx(hwnd, resX, resY, NULL);
		SetViewportExtEx(hwnd, resX, resY, NULL);
	}
	return T_TRUE;
#endif
}

TC_DDRAW::TC_DDRAW()
{
	sprintf(winName,"DDrawTst");
	sprintf(winTitle, "Test DDraw");
}


