/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Affichage du texte
 *
 *
 */
/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "A_text.h"

/****** Variables globales ******/
cgb_text		A_gTab_Text[CGB_NB_TEXT_MAX];


void cgb_text_init()
{
	long cpt;
	for (cpt=0; cpt<CGB_NB_TEXT_MAX; cpt++) {
		A_gTab_Text[cpt].isActif=   T_FALSE;
		A_gTab_Text[cpt].isFond=    T_FALSE;
		A_gTab_Text[cpt].isScroll = T_FALSE;
	}
}


void cgb_text_scroll_set(cgb_text_id idText,int i_nbLignes, T_DWORD i_timerScroll)
{
	A_gTab_Text[idText].isScroll		= T_TRUE;
	A_gTab_Text[idText].nbLignesScroll	= i_nbLignes;
	A_gTab_Text[idText].timerScroll	= i_timerScroll;
}



cgb_text_id cgb_text_set(char *ip_resName, long i_x, long i_y, T_DWORD i_dureeAff, cgb_text_id i_lastTextId, T_BOOL i_isFond)
{
	long cpt;
	TE_ResId  l_res;
	long l_id;

	// On recupere le texte
	l_res = cgb_res_get_index_by_name(ip_resName);
	// On lui trouve une place nouvelle(0), ou ancienne(i_lastTextId)
	l_id=0;
	if ((i_lastTextId==0)||(i_lastTextId>CGB_NB_TEXT_MAX)) {
		for (cpt=1; cpt<CGB_NB_TEXT_MAX; cpt++) {
			if (A_gTab_Text[cpt].isActif == T_FALSE) {
				l_id = cpt;
				cpt = CGB_NB_TEXT_MAX;
			}
		}
	} else {
		l_id = i_lastTextId;
	}
	if (l_id!=0) {
			A_gTab_Text[l_id].isActif	= T_TRUE;
			A_gTab_Text[l_id].ptCoord.x	= i_x;
			A_gTab_Text[l_id].ptCoord.y	= i_y;
			A_gTab_Text[l_id].dureeAff	= i_dureeAff;
			A_gTab_Text[l_id].resId		= l_res;
			A_gTab_Text[l_id].debutAff	= 0;
			A_gTab_Text[l_id].isFond	= i_isFond;
			A_gTab_Text[l_id].isScroll	= T_FALSE;
	} else {
			// Pb, dj trop de textes  l'cran
	}
	return l_id;
}

void	cgb_text_remove(cgb_text_id i_textId)
{
	A_gTab_Text[i_textId].isActif=T_FALSE;
	A_gTab_Text[i_textId].isFond=T_FALSE;
}