/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Input
 *
 *
 */
/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "I_input.h"
#include "A_aff.h"
#include "M_scenes.h"
#include "O_objets.h"
#include "O_panneau.h"
#include "S_scenario.h"
#include "M_dep.h"
#include "M_engine.h"
#include "M_dialogue.h"

/**** Variables globales ****/
TE_ObjectId		I_gObjetDebutClick;
TE_ObjectId		I_gObjetMoveOver;
int		A_gXMouse;
int		A_gYMouse;
int		A_gXMouseLast;
int		A_gYMouseLast;


/******************* Fonctions Haut niveau ****/
void I_LClick(TE_ObjectId i_ObjetDebutClick)
{
	// Si on est en mode dialogue
	if (cgb_dialog_is_on()) {
		// C'est un truc de dialogue?
		if (O_gTab_Objets[i_ObjetDebutClick].isSceneName(I_gSceneName_Dialogue)) {
			// Prevenir le mode de dialogue
			M_gdialogue.setChoix(O_gTab_Objets[i_ObjetDebutClick].name);
		}
	} else {
		// Aller jusqu' l'objet
		if (!M_g_coco_editor) {
			if ((O_gTab_Objets[i_ObjetDebutClick].ptHotSpot.x!=0) && (O_gTab_Objets[i_ObjetDebutClick].ptHotSpot.y!=0)) {
				cgb_obj_player_go_to(O_gTab_Objets[i_ObjetDebutClick].ptCoord.x + O_gTab_Objets[i_ObjetDebutClick].ptHotSpot.x, 
					O_gTab_Objets[i_ObjetDebutClick].ptCoord.y + O_gTab_Objets[i_ObjetDebutClick].ptHotSpot.y);
				while (!cgb_obj_player_is_waiting()) {
					M_process_for_n_sec(0);
				}
			}
		}
		// Actionner le truc
		M_Action(i_ObjetDebutClick);
	}
}

void I_LDrop(TE_ObjectId i_ObjetDebutClick, TE_ObjectId i_ObjetFinClick)
{
	if (!M_g_coco_editor) {
		// Aller jusqu' l'objet
		cgb_obj_player_go_to(O_gTab_Objets[i_ObjetFinClick].ptCoord.x + O_gTab_Objets[i_ObjetFinClick].ptHotSpot.x, 
			O_gTab_Objets[i_ObjetFinClick].ptCoord.y + O_gTab_Objets[i_ObjetFinClick].ptHotSpot.y);
		while (!cgb_obj_player_is_waiting()) {
			M_process_for_n_sec(0);
		}
	}
		// Actionner le truc
		M_UtiliseSur(i_ObjetDebutClick, i_ObjetFinClick);
}

void I_MoveIn(TE_ObjectId i_ObjetMoveOver)
{
	TPC_Object lp_mouse;
	M_MouseMoveIn(i_ObjetMoveOver);
	// Chgt de decors possible ???
	if (O_gTab_Objets[i_ObjetMoveOver].SceneSuivanteName[0] != 0) {
		lp_mouse = cgb_obj_get_ptr_by_name(O_gObjName_Mouse);
		lp_mouse->SetAnimCourantebyName(I_gResName_Mouse_go);
		//lp_mouse->ptAnimCourante = R_getResAnimPtrByName(C_Res_Res_But_Go);
		
	} else 	if (O_gTab_Objets[i_ObjetMoveOver].isClickable) {
		lp_mouse = cgb_obj_get_ptr_by_name(O_gObjName_Mouse);
		lp_mouse->SetAnimCourantebyName(I_gResName_Mouse_clickable);
		//lp_mouse->ptAnimCourante = R_getResAnimPtrByName(C_Res_Res_But_Go);
		
	}
	if (O_gTab_Objets[i_ObjetMoveOver].affName[0] != 0) {
		O_gTab_Objets[i_ObjetMoveOver].AffText(O_gTab_Objets[i_ObjetMoveOver].affName, 1000, T_TRUE);
		//lp_mouse->ptAnimCourante = R_getResAnimPtrByName(C_Res_Res_But_Go);
		
	} 

}

void I_MoveOut(TE_ObjectId i_ObjetMoveOver)
{
	TPC_Object lp_mouse;
	M_MouseMoveOut(i_ObjetMoveOver);
	// Chgt de decors possible ???
	if ((O_gTab_Objets[i_ObjetMoveOver].SceneSuivanteName[0] != 0)
		||(O_gTab_Objets[i_ObjetMoveOver].isClickable) ) {
		lp_mouse = cgb_obj_get_ptr_by_name(O_gObjName_Mouse);
		lp_mouse->SetAnimCourantebyName(I_gResName_Mouse_normal);
		//lp_mouse->ptAnimCourante = R_getResAnimPtrByName(C_Res_ResId_Mouse);
	}
}

/******************* Fonctions Bas niveau ****/

TE_ObjectId I_TestObjetClick(int i_x, int i_y)
{
	int cpt;

	if (M_g_coco_editor) {

		/*** Tous les objets tris de la scene active ***/
		for (cpt=A_nbObjAff; cpt>=0; cpt--) {
				if (O_gTab_Objets[A_tabObjAff[cpt]].ContientPt(i_x, i_y)) {
					return (TE_ObjectId)A_tabObjAff[cpt];
				}
		}

	} else {

		/*** objets ***/
		// Si on est en mode dialogue
		if (cgb_dialog_is_on()) {
				// Un truc de dialogue?
			for (cpt=1; cpt<O_gNb_objets; cpt++) {
				if (O_gTab_Objets[cpt].isSceneName(I_gSceneName_Dialogue))
				{
					if (O_gTab_Objets[cpt].isClickable) {
						if (O_gTab_Objets[cpt].ContientPt(i_x, i_y)) 
						{
							return (TE_ObjectId)cpt;
						}
					}
				}
			}
		} else {


			// Un objets du panneau ?
			for (cpt=1; cpt<O_gNb_objets; cpt++) {
				if (O_gTab_Objets[cpt].isSceneName(O_gSceneName_Pannel))
				{
					if (O_gTab_Objets[cpt].isClickable) {
						if (O_gTab_Objets[cpt].ContientPt(
							i_x, 
							i_y + (O_gPanneau.xPanneauOuvert - O_gPanneau.ptCoord.y))) 
						{
							return (TE_ObjectId)cpt;
						}
					}
				}
			}

			/*** objets tris de la scene active ***/
			for (cpt=A_nbObjAff; cpt>=0; cpt--) {
				if (O_gTab_Objets[A_tabObjAff[cpt]].isClickable) {
					if (O_gTab_Objets[A_tabObjAff[cpt]].ContientPt(i_x, i_y)) {
						return (TE_ObjectId)A_tabObjAff[cpt];
					}
				}
			}

		}
	}
	return 0;
}


void I_LMouseDown(int i_x, int i_y)
{
	// Objet de click
	I_gObjetDebutClick = I_TestObjetClick(A_gXMouse, A_gYMouse);
	//trace(1, "Objet de click n");
}

void I_MouseMove(int i_x, int i_y, T_WORD i_param)
{
	TE_ObjectId l_ObjetMoveOver;
	TPC_Object lp_mouse;

	A_gXMouseLast = A_gXMouse;
	A_gYMouseLast = A_gYMouse;
	A_gXMouse = i_x;
	A_gYMouse = i_y;

	// Objet part dessus lequel on passe
	l_ObjetMoveOver = I_TestObjetClick(A_gXMouse, A_gYMouse);

	// Bouton non press ? MK_LBUTTON
	if (!i_param) {
		// Changement d'objet
		if (l_ObjetMoveOver != I_gObjetMoveOver) {
			// Sortie
			if ((I_gObjetMoveOver != 0) ) {
				I_MoveOut(I_gObjetMoveOver);
			}
			// Entree
			if ((l_ObjetMoveOver != 0) ) {
				I_MoveIn(l_ObjetMoveOver);
			}
		}
	}
	I_gObjetMoveOver = l_ObjetMoveOver;

	// Pas de drag en cours ???
	if (I_gObjetDebutClick	== 0) return;

	// gestion du drag&drop
	if (M_g_coco_editor) {
		O_gTab_Objets[I_gObjetDebutClick].ptCoord.x += (A_gXMouse - A_gXMouseLast);
		O_gTab_Objets[I_gObjetDebutClick].ptCoord.y += (A_gYMouse - A_gYMouseLast);
		O_gTab_Objets[I_gObjetDebutClick].ptCoordInit.x = O_gTab_Objets[I_gObjetDebutClick].ptCoord.x;
		O_gTab_Objets[I_gObjetDebutClick].ptCoordInit.y = O_gTab_Objets[I_gObjetDebutClick].ptCoord.y;
	} else  {
		if (O_gTab_Objets[I_gObjetDebutClick].isDragAndDrop) {
			lp_mouse = cgb_obj_get_ptr_by_name(O_gObjName_Mouse);
			lp_mouse->ptAnimCourante = O_gTab_Objets[I_gObjetDebutClick].ptAnimCourante;
		}
	}
}

void I_LMouseUp(int i_x, int i_y )
{
	TE_ObjectId l_ObjetFinClick;

	// Objet de fin de click
	l_ObjetFinClick = I_TestObjetClick(A_gXMouse, A_gYMouse);

	// On rcupre le pointeur de souris
	TPC_Object  lp_mouse;
	TPC_Res		lp_res;
	lp_mouse = cgb_obj_get_ptr_by_name(O_gObjName_Mouse);
	lp_res = cgb_res_get_ptr_by_name(I_gResName_Mouse_normal);
	lp_mouse->ptAnimCourante = &(lp_res->resAnim);

	// Click valide ?
	if (  (I_gObjetDebutClick	== 0)
	    ||(l_ObjetFinClick		== 0) )
	{
		I_gObjetDebutClick = 0;
		// Le click tait dans la fentre du jeu ?
		// Dplacement
		if (cgb_obj_player_is_valid_dest(i_x,i_y))  {
			cgb_obj_player_go_to(i_x,i_y);
		}
		return;
	}
	
	// C'est un click simple ou un drag&drop ?
	if (l_ObjetFinClick == I_gObjetDebutClick) {
		I_LClick(I_gObjetDebutClick);
	} else {
		I_LDrop(I_gObjetDebutClick, l_ObjetFinClick);
	}

	// On remet tout  zero
	I_gObjetDebutClick = 0;

}





int I_GetTickCount()
{
#ifdef USE_SDL
	return SDL_GetTicks();
#else
	return GetTickCount();
#endif
}