/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Moteur dplacement
 *
 *
 */

/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "M_dep.h"
#include "O_objets.h"
#include "R_ressources.h"
#include "M_engine.h"

/**** Variables globales ****/
T_POINT		M_gPersoPointDest;
TE_ResId	M_gResId_Fond_Bmp;
extern int A_cpt_mvt;


 
void cgb_obj_player_coord_set(long i_x, long i_y)
{
	TPC_Object lp_perso;
	lp_perso = cgb_obj_get_ptr_by_name(O_gObjName_Perso);
	if (lp_perso->scale) {
		lp_perso->ptCoord.x = i_x - (long)((lp_perso->ptHotSpot.x)*(lp_perso->scale));
		lp_perso->ptCoord.y = i_y - (long)((lp_perso->ptHotSpot.y)*(lp_perso->scale));
	} else  {
		lp_perso->ptCoord.x = i_x - lp_perso->ptHotSpot.x;
		lp_perso->ptCoord.y = i_y - lp_perso->ptHotSpot.y;
	}
}

void cgb_obj_player_coord_cpy_by_name(char *ip_name)
{
	TPC_Object lp_objet;
	
	lp_objet = cgb_obj_get_ptr_by_name(ip_name);
	if (!lp_objet) return;
	cgb_obj_player_coord_set(lp_objet->ptCoord.x + lp_objet->ptHotSpot.x, 
					lp_objet->ptCoord.y + lp_objet->ptHotSpot.y);
}

T_BOOL cgb_obj_player_is_valid_dest(long i_x, long i_y)
{
	// Recherche des objets ZoneDep dans la scene
	int l_cpt;

	for (l_cpt=1; l_cpt<O_gNb_objets; l_cpt++) {
		if (O_gTab_Objets[l_cpt].isSceneName(cgb_scenes_current_get_name())) {
			if (O_gTab_Objets[l_cpt].isZoneDep()) {
				if (O_gTab_Objets[l_cpt].ContientPt(i_x, i_y)) {
					return T_TRUE;
				}
			}
		}
	}
	return T_FALSE;
}

void cgb_obj_player_go_to(long i_x, long i_y)
{
	M_gPersoPointDest.x = i_x;
	M_gPersoPointDest.y = i_y;
}

void cgb_obj_player_go_to_obj(char *ip_name)
{
	TPC_Object lp_objet;
	
	lp_objet = cgb_obj_get_ptr_by_name(ip_name);
	if (!lp_objet) return;
	// Aller jusqu' l'objet
	cgb_obj_player_go_to(lp_objet->ptCoord.x + lp_objet->ptHotSpot.x, 
			 lp_objet->ptCoord.y + lp_objet->ptHotSpot.y);

}

void M_getDelta(TPC_Object lp_perso, int *dHor, int *dVer)
{
		if (lp_perso->scale) {
			(*dHor) = M_gPersoPointDest.x
				   - ( lp_perso->ptCoord.x
					  +(long)((lp_perso->ptHotSpot.x)*(lp_perso->scale))
					 );
			(*dVer) = M_gPersoPointDest.y
				   - ( lp_perso->ptCoord.y
					  +(long)((lp_perso->ptHotSpot.y)*(lp_perso->scale))
					 );
		} else {
			(*dHor) = M_gPersoPointDest.x
				   - ( lp_perso->ptCoord.x
					  +lp_perso->ptHotSpot.x
					 );
			(*dVer) = M_gPersoPointDest.y
				   - ( lp_perso->ptCoord.y
					  +lp_perso->ptHotSpot.y
					 );

		}

}

// Retourne T_TRUE si le personnage ne marche pas
T_BOOL cgb_obj_player_is_waiting()
{
	int dHor,dVer;
	TPC_Object lp_perso;
	T_BOOL l_ret;

	lp_perso = cgb_obj_get_ptr_by_name(O_gObjName_Perso);
	M_getDelta(lp_perso, &dHor, &dVer);
	if ((abs(dHor)<30)&&(abs(dVer)<30)) {
		l_ret = T_TRUE;
	} else {
		l_ret = T_FALSE;
	}
	return l_ret;
}

void cgb_obj_player_move()
{
	int cpt,dHor,dVer;
	TPC_Object lp_perso;
	TPC_Res  lp_res;

	lp_perso = cgb_obj_get_ptr_by_name(O_gObjName_Perso);

	for (cpt=0; cpt<=1; cpt++) {
		M_getDelta(lp_perso, &dHor, &dVer);

		if ((abs(dHor)<30)&&(abs(dVer)<30)) {
			lp_perso->ptVit.x = 0;
			lp_perso->ptVit.y = 0;
			lp_res = cgb_res_get_ptr_by_name(M_gResName_Dep_Attente);
			lp_perso->ptAnimCourante = &(lp_res->resAnim);
			A_cpt_mvt=0;
			return;
		}

		if (abs(dHor)>abs(dVer)) {
			// On avance sur les X
			if (dHor>0) {
				lp_perso->ptVit.x = 1;
				lp_perso->ptVit.y = 0;
				//lp_perso->ptCoord.x++;
				lp_res = cgb_res_get_ptr_by_name(M_gResName_Dep_Droit);
				lp_perso->ptAnimCourante = &(lp_res->resAnim);
			} else {
				lp_perso->ptVit.x = -1;
				lp_perso->ptVit.y = 0;
				//lp_perso->ptCoord.x--;
				lp_res = cgb_res_get_ptr_by_name(M_gResName_Dep_Gauche);
				lp_perso->ptAnimCourante = &(lp_res->resAnim);
			}
		} else {
			// On avance sur les Y
			if (dVer>0) {
				lp_perso->ptVit.x = 0;
				lp_perso->ptVit.y = 1;
				//O_gTab_Objets[ObjectId_Perso].ptCoord.y++;
				lp_res = cgb_res_get_ptr_by_name(M_gResName_Dep_Droit);
				lp_perso->ptAnimCourante = &(lp_res->resAnim);
			} else {
				lp_perso->ptVit.x = 0;
				lp_perso->ptVit.y = -1;
				//lp_perso->ptCoord.y--;
				lp_res = cgb_res_get_ptr_by_name(M_gResName_Dep_Gauche);
				lp_perso->ptAnimCourante = &(lp_res->resAnim);
			}
		}
	}
}

void cgb_obj_player_go_to_process(char *ip_name)
{
	cgb_obj_player_go_to_obj(ip_name);
	while (!cgb_obj_player_is_waiting()) {
		M_process_for_n_sec(0);
	}
}