/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Dialogue
 *
 *
 */

/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "M_dialogue.h"
#include "O_objets.h"
#include "S_son.h"
#include "M_engine.h"
#include "O_panneau.h"



TC_dialogue M_gdialogue;


int cgb_dialog_on()
{
	M_gdialogue.etat = Dialogue_on;
	return 0;
}

int cgb_dialog_off()
{
	M_gdialogue.etat = Dialogue_off;
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff1)->AffText("", 0, T_FALSE);
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff2)->AffText("", 0, T_FALSE);
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff3)->AffText("", 0, T_FALSE);
	M_gdialogue.dialog_fct = NULL;
	return 0;
}

int cgb_dialog_is_on()
{
	return (M_gdialogue.etat == Dialogue_on);
}

TC_dialogue::TC_dialogue()
{
	etat = Dialogue_off;
	(dialog_fct) = NULL;

}

/*
void TC_dialogue::dialogue_on()
{
	etat = Dialogue_on;
}

void TC_dialogue::dialogue_off()
{
	etat = Dialogue_off;
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff1)->AffText("", 0, T_FALSE);
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff2)->AffText("", 0, T_FALSE);
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff3)->AffText("", 0, T_FALSE);
	(dialog_fct) = NULL;

}
*/
void TC_dialogue::dialogue_set(char *ip_text1, char *ip_son1,
						   char *ip_text2, char *ip_son2,
						   char *ip_text3, char *ip_son3,
						   void (*ip_fct)(TE_Dialogue))
{
	if (strcmp(ip_text1,"")!=0) {
		cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff1)->isAfficher = 1;
	} else {
		cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff1)->isAfficher = 0;
	}
	if (strcmp(ip_text2,"")!=0) {
		cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff2)->isAfficher = 1;
	} else {
		cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff2)->isAfficher = 0;
	}
	if (strcmp(ip_text3,"")!=0) {
		cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff3)->isAfficher = 1;
	} else {
		cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff3)->isAfficher = 0;
	}
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff1)->AffText(ip_text1, M_dialogue_temps_aff_permanent, T_FALSE);
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff2)->AffText(ip_text2, M_dialogue_temps_aff_permanent, T_FALSE);
	cgb_obj_get_ptr_by_name(O_gObjetName_Panneau_Aff3)->AffText(ip_text3, M_dialogue_temps_aff_permanent, T_FALSE);
	strcpy(son1, ip_son1);
	strcpy(son2, ip_son2);
	strcpy(son3, ip_son3);
	strcpy(resText1, ip_text1);
	strcpy(resText2, ip_text2);
	strcpy(resText3, ip_text3);
	(dialog_fct) = ip_fct;
}

void TC_dialogue::setChoix(char *ip_nomObjetChoix)
{
	TPC_Object lp_objet;
	lp_objet = cgb_obj_get_ptr_by_name(ip_nomObjetChoix);
	if (lp_objet->isName(O_gObjetName_Panneau_Aff1)) {
		if (dialog_fct) { 
			cgb_obj_get_ptr_by_name(O_gObjName_Perso)->AffText(resText1, M_dialogue_temps_aff, T_TRUE);
			S_playWavFromRes(son1);
			M_process_for_n_sec( M_dialogue_temps_aff );
			if (dialog_fct) (*dialog_fct)(Dialogue_1); 
			return;
		}
	}
	if (lp_objet->isName(O_gObjetName_Panneau_Aff2)) { 
		if (dialog_fct) { 
			cgb_obj_get_ptr_by_name(O_gObjName_Perso)->AffText(resText2, M_dialogue_temps_aff, T_TRUE);
			S_playWavFromRes(son2);
			M_process_for_n_sec( M_dialogue_temps_aff );
			if (dialog_fct)  (*dialog_fct)(Dialogue_2); 
			return;
		}
	}
	if (lp_objet->isName(O_gObjetName_Panneau_Aff3)) { 
		if (dialog_fct) { 
			cgb_obj_get_ptr_by_name(O_gObjName_Perso)->AffText(resText3, M_dialogue_temps_aff, T_TRUE);
			S_playWavFromRes(son3);
			M_process_for_n_sec( M_dialogue_temps_aff );
			if (dialog_fct) (*dialog_fct)(Dialogue_3); 
			return;
		}
	}
}
