/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Main
 *
 *
 */

/****** Includes systmes ******/
#ifdef WIN32
#include <windows.h>
#endif
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

/****** Includes applicatifs ******/
#include "R_ressources.h"
#include "A_aff.h"
#include "S_scenario.h"
#include "M_dialogue.h"
#include "O_objets.h"
#include "O_panneau.h"
#include "M_scenes.h"
#include "T_trace.h"
#include "I_input.h"
#include "S_son.h"
#include "M_dep.h"
#include "M_files.h"
#include "M_engine.h"
#include "M_resFile.h"


/****** Variables globales ******/
T_BOOL		M_gbActive;        // is application active?
int			M_g_mode_Windows=1; // est une fentre ? (sinon plein cran)
int			M_g_coco_editor=0;	// Mode editor ?
int			M_gQuitter=0;

T_Name	M_gSceneName_Depart="";
T_Name	M_gSceneName_Perso="";


void M_project_new()
{
	M_file_clear();
	cgb_scenes_clear();
	cgb_obj_clear();
	cgb_res_clear();
}


void cgb_set_scene_depart_name(char *ip_name)
{
	M_name_cpy(M_gSceneName_Depart, ip_name);
}

void cgb_set_scene_perso_name(char *ip_name)
{
	M_name_cpy(M_gSceneName_Perso, ip_name);
}

char *cgb_get_scene_depart_name()
{ return M_gSceneName_Depart; }

char *cgb_get_scene_perso_name()
{ return M_gSceneName_Perso; }


T_Name O_gObjName_Mouse="";
T_Name O_gObjName_Perso="";

void M_set_obj_mouse_name(char *ip_name)
{
	M_name_cpy(O_gObjName_Mouse, ip_name);
}

void M_set_obj_perso_name(char *ip_name)
{
	M_name_cpy(O_gObjName_Perso, ip_name);
}

char * M_get_obj_perso_name()
{
	return (char *)(O_gObjName_Perso);
}


T_Name	O_gSceneName_Pannel="";
T_Name	O_gObjetName_Panneau="";
T_Name	O_gObjetName_PanneauDroit="";
T_Name	O_gObjetName_PanneauGauche="";
T_Name	O_gObjetName_Panneau_Aff1="";
T_Name	O_gObjetName_Panneau_Aff2="";
T_Name	O_gObjetName_Panneau_Aff3="";

void M_setSceneName_Pannel(char *ip_name)
{
	M_name_cpy(O_gSceneName_Pannel, ip_name);
}

void M_setObjetName_Panneau(char *ip_name)
{
	M_name_cpy(O_gObjetName_Panneau, ip_name);
}

void M_setObjetName_PanneauDroit(char *ip_name)
{
	M_name_cpy(O_gObjetName_PanneauDroit, ip_name);
}

void M_setObjetName_PanneauGauche(char *ip_name)
{
	M_name_cpy(O_gObjetName_PanneauGauche, ip_name);
}

void M_setObjetName_Panneau_Aff1(char *ip_name)
{
	M_name_cpy(O_gObjetName_Panneau_Aff1, ip_name);
}

void M_setObjetName_Panneau_Aff2(char *ip_name)
{
	M_name_cpy(O_gObjetName_Panneau_Aff2, ip_name);
}

void M_setObjetName_Panneau_Aff3(char *ip_name)
{
	M_name_cpy(O_gObjetName_Panneau_Aff3, ip_name);
}

T_Name	I_gSceneName_Dialogue="";

void M_setSceneName_Dialogue(char *ip_name)
{
	M_name_cpy(I_gSceneName_Dialogue, ip_name);
}

void M_quitter()
{
	M_doTerminate();
#ifdef USE_SDL
	M_gQuitter = 1;
#else
    PostQuitMessage( 0 );
#endif
}

/* Font resource */
T_Name	A_gResName_Ascii="";

void A_setResName_Ascii(char *ip_name)
{
	M_name_cpy(A_gResName_Ascii, ip_name);
}


/**** Mouse graphical resources ***/
T_Name	I_gResName_Mouse_normal="";
T_Name	I_gResName_Mouse_clickable="";
T_Name	I_gResName_Mouse_go="";

void I_setResName_Mouse_Normal(char *ip_name)
{
	M_name_cpy(I_gResName_Mouse_normal, ip_name);
}

void I_setResName_Mouse_Clickable(char *ip_name)
{
	M_name_cpy(I_gResName_Mouse_clickable, ip_name);
}

void I_setResName_Mouse_Go(char *ip_name)
{
	M_name_cpy(I_gResName_Mouse_go, ip_name);
}

// 
T_Name	M_gResName_Dep_Attente="";
T_Name	M_gResName_Dep_Gauche="";
T_Name	M_gResName_Dep_Droit="";

void I_setResName_Dep_Attente(char *ip_name)
{
	M_name_cpy(M_gResName_Dep_Attente, ip_name);
}

void I_setResName_Dep_Gauche(char *ip_name)
{
	M_name_cpy(M_gResName_Dep_Gauche, ip_name);
}

void I_setResName_Dep_Droit(char *ip_name)
{
	M_name_cpy(M_gResName_Dep_Droit, ip_name);
}
/*************************************************
* Nom	: M_AffFreq
* Desc	: Affiche la frquence d'image
* Arg	: Nant
**************************************************/
void M_AffFreq(int tempAff, int tempMoyen)
{
  static char         msg[255];
  int len;

  if (!tempAff) tempAff=1;
  if (!tempMoyen) tempMoyen=1;
  len = sprintf(msg,"Aff=%dms (moy=%d) f=%d (moy=%d)",tempAff, tempMoyen, 600/tempAff, 600/tempMoyen);
  //printf("%s (x=%d, y=%d)\n", msg, A_gXMouse, A_gYMouse);
  A_gAff.AffText(&(msg[0]), len, T_FALSE);
}



/*************************************************
* Nom	: M_process
* Desc	: Boucle principale du programme
* Arg	: Nant
**************************************************/
int s_LastTickCount=0;
int s_FirstTickCount=0;
int s_NbCount=0;
int s_DureeAff=1;
void M_process( void )
{
	int l_TickCount;
	T_POINT	l_point;
	int l_x, l_y;

	/**** Gestion du panneau ****/
	O_gPanneau.GestionPanneau(A_gXMouse, A_gYMouse);

	/**** Dplacement ****/ 
	cgb_obj_player_move();

    /**** Position souris ***/
	if (M_g_mode_Windows==0) {
#ifdef USE_SDL
		SDL_GetMouseState(&l_x, &l_y); 
		l_point.x = l_x;
		l_point.y = l_y;
#else
		GetCursorPos(&l_point);	// position absolue
#endif
		I_MouseMove(l_point.x, l_point.y, 0);
	}
	/**** Affichage offscreen ****/
	gcb_aff_offscreen();

	/**** Aff offscreen du chrono ***/
	l_TickCount	= I_GetTickCount();
	s_NbCount++;
	if (s_FirstTickCount == 0) s_FirstTickCount = l_TickCount;
	s_DureeAff = (l_TickCount-s_FirstTickCount)/s_NbCount;
	M_AffFreq(l_TickCount - s_LastTickCount, s_DureeAff);
	s_LastTickCount = l_TickCount;

	/**** Affichage ***/
	gcb_aff_screen();

} /* M_process */

/*************************************************
* Nom	: M_process_for_n_msec
* Desc	: Boucle principale du programme pour n milli sec
* Arg	: Nant
**************************************************/
int M_process_for_n_sec( int i_nmsec )
{
	T_DWORD l_TickDebut;
	T_DWORD l_TickFin;
#ifdef WIN32
    MSG     msg;
#endif

	/**** debut ***/
	l_TickDebut = I_GetTickCount(); // millisecondes
	l_TickFin   = l_TickDebut + i_nmsec;
	do {
#ifndef USE_SDL

        if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
        {
            if( !GetMessage( &msg, NULL, 0, 0 ) )
                return msg.wParam;
            TranslateMessage(&msg); 
            DispatchMessage(&msg);
        }
        else if( M_gbActive )
        {
#endif
            M_process();
#ifndef USE_SDL
        }
        else
        {
            // make sure we go to sleep if we have nothing else to do
            WaitMessage();
        }
#endif
		
	} while (I_GetTickCount()<l_TickFin);

	return 0;
} /* M_process_for_n_sec */


/*************************************************
* Nom	: M_doTerminate
* Desc	: Termine l'application.
* Arg	: Nant
**************************************************/
void M_doTerminate()
{
	S_stopCD();
	S_closeCD();
}



/*************************************************
* Nom	: M_WindowProc
* Desc	: Traite les messages windows reus par la fentre
* Arg	: 
**************************************************/
#ifdef WIN32
long FAR PASCAL M_WindowProc( HWND hWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam )
{
	switch( message )
    {
	case MM_WOM_DONE:
		gcd_aff_shake();
	break;

    case WM_ACTIVATEAPP:
        M_gbActive = wParam;
        break;

    case WM_SETCURSOR:
        SetCursor(NULL);
        return T_TRUE;

	case WM_MOUSEMOVE:
		I_MouseMove(LOWORD(lParam), HIWORD(lParam), wParam);
		break;

    case WM_CREATE:
        break;

	case WM_LBUTTONDOWN:
		I_LMouseDown(LOWORD(lParam), HIWORD(lParam));
		break;

	case WM_LBUTTONUP:
		I_LMouseUp(LOWORD(lParam), HIWORD(lParam));
		break;

	case  MM_MCINOTIFY:
		Beep(100,10);
		break;
    
	case WM_KEYDOWN:
        switch( wParam )
        {
        case VK_F1:
			//M_loadFile(NULL);
			break;
        case VK_F2:
			//M_saveFile(NULL);
			break;
        case VK_F3:
			M_debug_tous_objets();
			break;
        case VK_F4:
			S_onKeyPressed(TE_Key_F4);
			break;
        case VK_F5:
			S_onKeyPressed(TE_Key_F5);
			break;
        case VK_F6:
			S_onKeyPressed(TE_Key_F6);
			break;
/*        case VK_F7:
			break;
        case VK_F8:
			break; 
*/
        case VK_F7:
			break;
        case VK_F8:
			break;
        case VK_F11:
			break;
        case VK_F12:
			break;
        case VK_ESCAPE:
			/* si on est en dialogue ou en demo, on sort du mode, sinon on quitte */
			if (cgb_dialog_is_on()) {
				cgb_dialog_off();
			} else {
				PostMessage(hWnd, WM_CLOSE, 0, 0);
			}
            break;
        }
        break;

    case WM_DESTROY:
	    //tstFrame.dDraw.finiObjects();
		T_closeTrace();
		M_doTerminate();
        PostQuitMessage( 0 );
        break;
    }

    return DefWindowProc(hWnd, message, wParam, lParam);

} /* M_WindowProc */
#endif

/*************************************************
* Nom	: M_doInit
* Desc	: Initialise l'application, cr la fentre...
* Arg	: Nant
**************************************************/
#ifdef USE_SDL
T_BOOL M_doInit_SDL( int argc, char *argv[])
{
	Uint8  video_bpp;
	Uint32 videoflags;
	int i;
	SDL_Rect dst;
	int resX=640, resY=480, resColorBit=16;
	char l_bufdrivername[128];

	/* Initialize SDL */
	printf("Init SDL\n");
	if ( SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_CDROM|SDL_INIT_TIMER) < 0 ) {
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		if ( SDL_Init(SDL_INIT_VIDEO|SDL_INIT_CDROM) < 0 ) {
			fprintf(stderr, "Couldn't initialize SDL without AUDIO neither: %s\n",SDL_GetError());
			exit(1);
		}
	}
	atexit(SDL_Quit);

	/* init Son */
	S_audio_init();


//S_playWavFromFile_info("e:\\coconut_save\\res\\wav\\bad.wav", S_channel_BackgroundMusic, 1);
//S_playWavFromFile_info("e:\\coconut\\res\\wav\\Amisoir.wav", S_channel_BackgroundSound, 1);
//S_playWavFromFile_info("e:\\coconut\\res\\wav\\Alarme.wav", S_channel_PonctualSound, 1);

	/* Infos */
	if (SDL_VideoDriverName(l_bufdrivername, 128)) {
		printf("Driver Video : [%s]\n", l_bufdrivername);
	} else {
		printf("No Video Driver....\n");
	}
	if (SDL_AudioDriverName(l_bufdrivername, 128)) {
		printf("Driver Audio : [%s]\n", l_bufdrivername);
	} else {
		printf("No Audio Driver....\n");
	}

	/* Init Windows*/
	printf("Init Param\n");
	video_bpp = 0;
	videoflags = SDL_HWSURFACE;
	while ( argc > 1 ) {
		--argc;
		if ( strcmp(argv[argc-1], "-bpp") == 0 ) {
			video_bpp = atoi(argv[argc]);
			--argc;
		} else
		if ( strcmp(argv[argc], "-warp") == 0 ) {
			videoflags |= SDL_HWPALETTE;
		} else
		if ( strcmp(argv[argc], "-hw") == 0 ) {
			videoflags |= SDL_HWSURFACE;
		} else
		if ( strcmp(argv[argc], "-fullscreen") == 0 ) {
			videoflags |= SDL_FULLSCREEN;
		} else
		if ( strcmp(argv[argc], "-D") == 0 ) {
			videoflags |= SDL_FULLSCREEN;
		} 
	}

	A_gAff.AttachDDWindow(0, 0, resX, resY, resColorBit, videoflags);
	
	return T_TRUE;
}
#else 
T_BOOL M_doInit_DirectX( HINSTANCE hInstance, int nCmdShow)
{

	// Cration de la fentre
	A_gAff.CreateDDWindow(M_g_mode_Windows, M_WindowProc, hInstance, nCmdShow);

	// Cration de la surface DDraw attache.
	int resX=640, resY=480, resColorBit=16;
	A_gAff.AttachDDWindow(M_g_mode_Windows, 0, resX, resY, resColorBit, 0);
	return T_TRUE;
}
#endif

T_BOOL M_doInit( char *ip_configFile )
{
	TPC_Object lp_panneau;

	T_traceFreeMem("debut DoInit");
	// Init CD
	S_initCD();
	//S_stopCD();
	S_playCD(1);

	// Intro
	M_InitResFile("coconut.cre");
	M_loadFile(ip_configFile);
	S_initSceneName();
	S_initResName();
	S_initObjName();

	cgb_scenes_current_set(M_gSceneName_Depart);
	gcb_aff_offscreen();
	gcb_aff_screen();

	lp_panneau = cgb_obj_get_ptr_by_name(O_gObjetName_Panneau);
	O_gPanneau.SetResAnimName(lp_panneau->ResAnimName);
	O_gPanneau.ptCoord.x = lp_panneau->ptCoord.x;
	O_gPanneau.ptCoord.y = lp_panneau->ptCoord.y;
	O_gPanneau.SetSceneName(lp_panneau->SceneName);
	O_gPanneau.isClickable = T_FALSE;
	O_gPanneau.InitPanneau(0, 480);

	// Positionnement de la premire scne
	cgb_scenes_current_set(M_gSceneName_Depart);
	cgb_obj_player_coord_set(500,350);
	cgb_obj_player_go_to(500,350);

	//S_playWavFromFile("c:\\josset\\coconut\\res\\wav\\boing.wav");

	T_traceFreeMem("fin doInit");
    return T_TRUE;
} /* M_doInit */



void M_SDL_Process()
{
	SDL_Event event;
		while ( SDL_PollEvent(&event) ) {
			switch (event.type) {
				case SDL_QUIT:
					M_gQuitter = 1;
					break;
				
				case SDL_MOUSEMOTION:
					I_MouseMove(event.motion.x, event.motion.y, event.motion.state);
					break;

				case SDL_MOUSEBUTTONDOWN:
					I_LMouseDown(event.motion.x, event.motion.y);
					break;
 
				case  SDL_MOUSEBUTTONUP:
					I_LMouseUp(event.motion.x, event.motion.y);
					break;

				case SDL_KEYDOWN:
					switch (event.key.keysym.sym) {
					case SDLK_ESCAPE: 
						M_gQuitter = 1;
						break;
					case SDLK_F1: 
						M_saveFile_BaseRes("coconut.cre");
						break;
					default: break;
					}
				default:
					break;
			}
		}
}

void cgb_scenes_current_set(char *ip_scene)
{
	TPC_Object lp_perso;
	TPC_Scene  lp_scene;

	// Passe en scene active
	lp_scene = cgb_scenes_get_ptr_by_name(ip_scene);
	M_gScene_active = (*lp_scene);

	// Change le scale du perso
	lp_perso = cgb_obj_get_ptr_by_name(M_get_obj_perso_name());
	lp_perso->SetScale(M_gScene_active.scale_perso);

	M_enterScene(ip_scene);

}


char *cgb_scenes_current_get_name()
{
	return (M_gScene_active.name);
}


