/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Moteur
 *	Chargement/Sauvegarde des scnes, objets, ressources
 *
 */
 
/****** Includes systmes ******/
#include <stdio.h>
//#include <dirent.h>
#ifdef WIN32
#include <io.h>
#else
#include <unistd.h>
#endif


#define M_save_baseRes_info_cmd_nbfich      1
#define M_save_baseRes_info_cmd_saveinfo    2
#define M_save_baseRes_info_cmd_savedata    3

#include <sys/stat.h>

/****** Includes applicatifs ******/
#include "M_files.h"
#include "M_resFile.h"
#include "M_scenes.h"
#include "O_objets.h"

// Tableau reprsentant le fichier
#define M_gNbLignesMax 16000
T_String M_gConfigFile[M_gNbLignesMax];
int    M_gNbLignes=0;

// Tri des noms de fichiers
T_String M_gFileName[M_gNbLignesMax];
int    M_gNbNames=0;
char   M_gCurrentConfigFileName[255]="";
char   M_gCurrentDirectoryName[255]="";

void M_file_clear()
{
	M_gNbLignes=0;
	M_gNbNames=0;
}


void M_initFileName()
{
	M_gNbNames=0;
}

int M_getFileName(char *ip_name)
{
	int l_cpt;

	for (l_cpt=0; l_cpt<M_gNbNames; l_cpt++) {
		if (strncmp(M_gFileName[l_cpt], ip_name, STRINGLEN)==0) {
			return l_cpt;
		}
	}
	return -1;
}

int M_addFileName(char *ip_name)
{
	if (M_getFileName(ip_name)== -1) {
		strncpy(M_gFileName[M_gNbNames], ip_name, STRINGLEN);
		M_gNbNames++;
		return 1;
	}
	return 0;
}

char M_gConfigFileName[255]="./coconut.dat";
char G_PathCoconut[255]="e:\\Coconut\\";

int M_addLigneInMem(char *ip_buf)
{
	strncpy(M_gConfigFile[M_gNbLignes], ip_buf, STRINGLEN);	
	M_gNbLignes++;
	if (M_gNbLignes>=M_gNbLignesMax) printf("Pb Taille fichier .dat\n");
	return 0;
}

int M_loadConfigFileInMem(char *ip_name)
{
	
	char l_buf[1024];
	FILE *l_f;
	int l_len;
	int l_len_read;

	// On tente de lire  partir du fichier de ressource global
	M_gNbLignes=0;
	M_getFileFromResFile(ip_name, &l_f, &l_len);
	l_buf[1023]=0;	// Si le fichier n'a pas de retour chariot, on vite les pb.
	l_len_read = 0;
	if (l_f) {
		while ((!feof(l_f))&&(l_len_read<l_len)) {
			fgets( l_buf, 1022, l_f);
			l_len_read += strlen(l_buf);
			M_cleanCRLF(l_buf);
			M_addLigneInMem(l_buf);
		}
		fclose(l_f);
	} else { 

	// On lit le fichier directement
		l_f = fopen(ip_name, "rt");
		if (l_f==0) {
			return -1;
		}
		while (!feof(l_f)) {
			fgets( l_buf, 1022, l_f);
			M_cleanCRLF(l_buf);
			M_addLigneInMem(l_buf);
		}
		fclose(l_f);
	}
	return 0;
}


char s_buf_null[]="";
char s_buf_lastPara[255]="";
int  s_last_para;
int  s_last_param;
int M_getParamStr(char *ip_para, char *ip_param, char *ip_defaut, char *ip_buf, int i_sizebuf)
{
	int  l_deb;
	int  l_num;
	int  l_num2;
	T_String l_str;
	const char *l_ptr;

	// Paragraphe cherch
	strcpy(l_str, "[");
	strcat(l_str, ip_para); 
	strcat(l_str, "]");
	// Peut on acclrer la recherche ?
	// Recherche du para
	if (strcmp(s_buf_lastPara, ip_para)==0) { // Si reste dans le mme paragraphe
		s_last_param++;
		if (strstr(M_gConfigFile[s_last_param], ip_param)) { // C'est peut-tre le parametre suivant qui est demand?
			if (l_ptr = strstr(M_gConfigFile[s_last_param], "=")) {
				strncpy(ip_buf, l_ptr+1, i_sizebuf);
				return 0; 
			}
		}
		l_deb = s_last_para; // On cherche  partir du debut du paragraphe
	} else {
		// On cherche  partir du debut
		l_deb =	0;

		// On regarde le paragraphe suivant : [
		if (strlen(s_buf_lastPara)!=0) { // Si on deja un point de dpart
			for (l_num =  s_last_param; l_num != M_gNbLignes; ++l_num) {
				if (l_ptr = strstr(M_gConfigFile[l_num], "[")) {	// on a trouv le paragraphe suivant
					if (l_ptr = strstr(l_ptr, ip_para)) { // C'est le bon ?
						l_deb =	l_num;
					}
					break; // On arrte de cherche les paragraphe.
				}
			}
		}		

	}
    for (l_num =  l_deb; l_num != M_gNbLignes; ++l_num) {
		if (strncmp(M_gConfigFile[l_num], l_str, STRINGLEN)==0) {			
			// Recherche du param
			//l_str = ip_param; 
			for (l_num2 =  l_num; l_num2 != M_gNbLignes; ++l_num2) {
				if (strstr(M_gConfigFile[l_num2], ip_param)) {
					if (l_ptr = strstr(M_gConfigFile[l_num2], "=")) {
						s_last_para = l_num;
						s_last_param = l_num2;
						strcpy(s_buf_lastPara, ip_para);
						strncpy(ip_buf, l_ptr+1, i_sizebuf);
						return 0; 
					}
				}
			}
		}
	}
	strncpy(ip_buf, ip_defaut, i_sizebuf);
	return 1;
}

int M_getParamInt(char *ip_para, char *ip_param, int i_valDefaut)
{
	int l_ret;
	char l_buf[1024];

	l_ret = M_getParamStr(ip_para, ip_param, "", l_buf, 1023);
	if (strlen(l_buf)==0) {
		l_ret = i_valDefaut;
	} else {
		l_ret = atoi(l_buf);
	}
	return l_ret;
}


void M_set_current_config_file_name(char *ip_name)
{
	int l_cpt;

	/* file name */
	strncpy(M_gCurrentConfigFileName, ip_name, 254);

	/* Working directory */
	strncpy(M_gCurrentDirectoryName, ip_name, 254);
	for (l_cpt=strlen(ip_name); l_cpt>=0; l_cpt--) {
		if ((M_gCurrentDirectoryName[l_cpt]!='/')&&(M_gCurrentDirectoryName[l_cpt]!='\\')) {
			M_gCurrentDirectoryName[l_cpt]=0;
		}
	}
}


int M_loadFile(char *ip_name)
{
	int l_nbScenes;
	int l_cpt;
	char l_bufScene[NAMELEN];
	int l_nbObjets;
	char l_bufObjet[NAMELEN];
	int l_nbRes;
	char l_bufRes[NAMELEN];

    if (ip_name==NULL) {
        ip_name=M_gConfigFileName;
    }

	/* reset tout */
	s_buf_lastPara[0]=0;
	s_last_para=0;
	s_last_param=0;


	M_set_current_config_file_name(ip_name);

	// Chargement du fichier de config
printf("M_loadConfigFileInMem (%s)\n", ip_name);

	M_loadConfigFileInMem(ip_name);
printf("M_loadConfigFileInMem ok\n");
    // Chargement des Scenes (On init de toute faon une scene 0)
	//l_nbScenes = GetPrivateProfileInt("Scenes", "NbScenes", 0, ip_name);
	l_nbScenes = M_getParamInt("Scenes", "NbScenes", 0);
	cgb_scenes_clear();
	for (l_cpt=1; l_cpt<=l_nbScenes; l_cpt++) {
		sprintf(l_bufScene, "Scene%d", l_cpt);
		cgb_scenes_add_from_mem(l_bufScene);
	}

	// Chargement des Objets
	l_nbObjets = M_getParamInt("Objets", "NbObjets", 0);
	cgb_obj_clear();
	for (l_cpt=1; l_cpt<=l_nbObjets; l_cpt++) {
		sprintf(l_bufObjet, "Objet%d", l_cpt);
		cgb_obj_add_from_mem(l_bufObjet);
	}


	// Chargement des Ressources
	l_nbRes = M_getParamInt("Ressources", "NbRessources", 0);
	cgb_res_clear();
	for (l_cpt=1; l_cpt<=l_nbRes; l_cpt++) {
		sprintf(l_bufRes, "Ressource%d", l_cpt);
		cgb_res_add_from_mem(l_bufRes);
	}

	return 1;
}


int M_saveFile_current()
{
	if (M_gCurrentConfigFileName[0]==0) {
		return 1;
	}
	M_saveFile(M_gCurrentConfigFileName);
	return 0;
}



int M_saveFile(char *ip_name)
{
	FILE *l_f;
	int l_cpt;
	int l_cpt_anim;
	TC_RESBITMAP	*l_ptrAnim;

    if (ip_name==NULL) {
        ip_name=M_gConfigFileName;
    }

	// Ouverture du fichier
	l_f = fopen(ip_name,"w");
	if (!l_f) {
		return 0;
	}

	// Sauvegarde des Scenes
	fprintf(l_f, "\n[Scenes]\n");
	fprintf(l_f, "NbScenes=%d\n", M_gNb_scenes-1);
	for (l_cpt=1; l_cpt<M_gNb_scenes; l_cpt++) {
		fprintf(l_f, "\n[Scene%d]\n", l_cpt);
		fprintf(l_f, "Name=%s\n", M_gTab_scene[l_cpt].name);
		fprintf(l_f, "ScalePerso=%3.3f\n", M_gTab_scene[l_cpt].scale_perso);
	}

	// Sauvegarde des Objets
	fprintf(l_f, "\n[Objets]\n");
	fprintf(l_f, "NbObjets=%d\n", O_gNb_objets-1);
	for (l_cpt=1; l_cpt<O_gNb_objets; l_cpt++) {
		fprintf(l_f, "\n[Objet%d]\n", l_cpt);
		fprintf(l_f, "Name=%s\n", O_gTab_Objets[l_cpt].name);
		fprintf(l_f, "AffName=%s\n", O_gTab_Objets[l_cpt].affName);
		fprintf(l_f, "ResAnimName=%s\n", O_gTab_Objets[l_cpt].ResAnimName);
		fprintf(l_f, "ptCoord.x=%d\n", O_gTab_Objets[l_cpt].ptCoord.x);
		fprintf(l_f, "ptCoord.y=%d\n", O_gTab_Objets[l_cpt].ptCoord.y);
		fprintf(l_f, "ptSize.x=%d\n", O_gTab_Objets[l_cpt].ptSize.x);
		fprintf(l_f, "ptSize.y=%d\n", O_gTab_Objets[l_cpt].ptSize.y);
		fprintf(l_f, "ptHotSpot.x=%d\n", O_gTab_Objets[l_cpt].ptHotSpot.x);
		fprintf(l_f, "ptHotSpot.y=%d\n", O_gTab_Objets[l_cpt].ptHotSpot.y);
		fprintf(l_f, "ptText.x=%d\n", O_gTab_Objets[l_cpt].ptText.x);
		fprintf(l_f, "ptText.y=%d\n", O_gTab_Objets[l_cpt].ptText.y);
		fprintf(l_f, "SceneName=%s\n", O_gTab_Objets[l_cpt].SceneName);
		fprintf(l_f, "SceneSuivanteName=%s\n", O_gTab_Objets[l_cpt].SceneSuivanteName);
		fprintf(l_f, "SceneSuivantePoint=%s\n", O_gTab_Objets[l_cpt].SceneSuivantePoint);
		fprintf(l_f, "isClickable=%d\n", O_gTab_Objets[l_cpt].isClickable);
		fprintf(l_f, "isAfficher=%d\n", O_gTab_Objets[l_cpt].isAfficher);
		fprintf(l_f, "isZoneDep=%d\n", O_gTab_Objets[l_cpt].is_ZoneDep);
		fprintf(l_f, "isDragAndDrop=%d\n", O_gTab_Objets[l_cpt].isDragAndDrop);
	}

	// Sauvegarde des Ressources
	fprintf(l_f, "\n[Ressources]\n");
	fprintf(l_f, "NbRessources=%d\n", R_gNb_res-1);
	for (l_cpt=1; l_cpt<R_gNb_res; l_cpt++) {
		fprintf(l_f, "\n[Ressource%d]\n", l_cpt);
		fprintf(l_f, "Name=%s\n", R_gTab_res[l_cpt].name);
		fprintf(l_f, "type=%s\n", R_gTab_resType[R_gTab_res[l_cpt].type].label);
		switch(R_gTab_res[l_cpt].type) {
		case ResType_Anim:
			l_cpt_anim=0;
			l_ptrAnim=&(R_gTab_res[l_cpt].resAnim);
			while (l_ptrAnim) {
				fprintf(l_f, "filePath%d=%s\n", l_cpt_anim, l_ptrAnim->filePath);
				fprintf(l_f, "tempo%d=%d\n", l_cpt_anim, l_ptrAnim->tempo);
				l_cpt_anim++;
				l_ptrAnim = l_ptrAnim->pNext;
			}
			fprintf(l_f, "nbAnim=%d\n", l_cpt_anim);
			break;
		case ResType_Bmp:
			fprintf(l_f, "filePath=%s\n", R_gTab_res[l_cpt].resBmp.filePath);
			break;
		case ResType_AviCD:
			break;
		case ResType_Wav:
			fprintf(l_f, "filePath=%s\n", R_gTab_res[l_cpt].resSon.fileName);
			break;
		case ResType_Mid:
			fprintf(l_f, "filePath=%s\n", R_gTab_res[l_cpt].resSon.fileName);
			break;
		case ResType_PisteCD:
			break;
		case ResType_Text:
			fprintf(l_f, "textBuf=%s\n", R_gTab_res[l_cpt].resText.textBuf);
			fprintf(l_f, "textBufEng=%s\n", R_gTab_res[l_cpt].resText.textBufEng);
			break;
		default:
			break;
		}
	}


	// Fermeture du fichier
	fclose(l_f);
	return 1;
}

int M_saveFile_H(char *ip_name)
{
	FILE *l_f;
	int l_cpt;

    if (ip_name==NULL) {
        return 0;
    }

	// Ouverture du fichier
	l_f = fopen(ip_name,"w");
	if (!l_f) {
		return 0;
	}

    // Entete
	fprintf(l_f, "/**************************/\n");
	fprintf(l_f, "/* Fichier Genere         */\n");
	fprintf(l_f, "/* %s         */\n", ip_name);
	fprintf(l_f, "/**************************/\n");

	// Sauvegarde des Scenes
	fprintf(l_f, "\n/******** Scenes **********/\n");
	fprintf(l_f, "#define C_NbScenes %d\n", M_gNb_scenes);
	for (l_cpt=1; l_cpt<=M_gNb_scenes; l_cpt++) {
        if (strlen(M_gTab_scene[l_cpt].name)>0) {
    		fprintf(l_f, "#define C_Scene_%-30s\t\"%s\"\n", M_gTab_scene[l_cpt].name, M_gTab_scene[l_cpt].name);
        }
	}

	// Sauvegarde des Objets
	fprintf(l_f, "\n/******** Objets ********/\n");
	fprintf(l_f, "#define C_NbObjets %d\n", O_gNb_objets);
	for (l_cpt=1; l_cpt<=O_gNb_objets; l_cpt++) {
        if (strlen(O_gTab_Objets[l_cpt].name)>0) {
    		fprintf(l_f, "#define C_Objet_%-30s\t\"%s\"\n", O_gTab_Objets[l_cpt].name, O_gTab_Objets[l_cpt].name);
        }
	}

	// Sauvegarde des Ressources
	fprintf(l_f, "\n/******** Ressources ********/\n");
	fprintf(l_f, "#define C_NbRessources %d\n", R_gNb_res);
	for (l_cpt=1; l_cpt<=R_gNb_res; l_cpt++) {
        if (strlen(R_gTab_res[l_cpt].name)>0) {
    		fprintf(l_f, "#define C_Res_%-30s\t\"%s\"\n", R_gTab_res[l_cpt].name, R_gTab_res[l_cpt].name);
        }
	}


	// Fermeture du fichier
	fclose(l_f);
	return 1;
}

void M_cpy_basename(char *op_basename, char *ip_fullname)
{
    int l_len;
    int l_cpt;
    int l_pos;

    // Cherche la position du repertoire
    l_len = strlen(ip_fullname);
    l_pos = 0;
    for (l_cpt=l_len; l_cpt>=0; l_cpt--) {
        if (ip_fullname[l_cpt]=='\\') {
            l_pos = l_cpt;
            l_cpt=-1;
        }
    }

    // Recopie
    if (l_pos==0) {
        strcpy(op_basename, ".\\");
    } else {
        strncpy(op_basename, ip_fullname, l_pos);
        op_basename[l_pos] = 0;
        strcat(op_basename, "\\");
    }

}

void M_copy_fich(FILE *i_f, char *ip_repdest, char *ip_fich)
{
    char  l_dest[255];
    char  l_cmd[255];
    char  l_repdest[255];
    //DIR *dir;

    // valide ?
    if (ip_fich[0]==0) return;

    // dest
    strcpy(l_dest, ip_repdest);
    strcat(l_dest, ip_fich);

    // creation du repertoire dest
    M_cpy_basename(l_repdest, l_dest);
	
    //if ((dir = opendir(l_repdest)) == NULL)
	if( (access( l_repdest, 0 )) == -1 )
    {
      sprintf(l_cmd, "mkdir %s", l_repdest);
      system(l_cmd);
    } else {
      //closedir(dir);
    }

    // Copy du fichier
    sprintf(l_cmd, "copy %s\\%s %s", G_PathCoconut, ip_fich, l_dest);
    system(l_cmd);

    // trace
    if (i_f) fprintf(i_f, "%s\n", l_cmd);

}


int M_save_baseRes_info_cmd(FILE *i_f, int i_cmd, const char *ip_fich)
{
    int l_ret;
    struct stat buf;
    int result;
    int l_size;
	FILE *l_f;
	int l_nb;
	char l_buf[1024];

	// Le nom est valide ?
    l_ret = 0;
	if ((ip_fich==0)||(ip_fich[0]==0)) { 
		return l_ret;
	}

	// Le fichier existe ?
    result = stat( ip_fich, &buf );
    if( result != 0 ) {
      printf( "Pb Fichier non accessible (%s) \n", ip_fich);
	  l_ret = 0;
	  return l_ret;
    }
	l_size = buf.st_size;
	// Alors on s'en occupe
	switch(i_cmd) {
		case M_save_baseRes_info_cmd_nbfich:
			// Rien a faire, juste retourner 1
			break;
		case M_save_baseRes_info_cmd_saveinfo:
			// Ecrire la taille , et le nom du fichier
			fprintf(i_f, "%d:%s\n", l_size, ip_fich);
			break;
		case M_save_baseRes_info_cmd_savedata:
			// Ecrire les datas
			l_f = fopen(ip_fich, "rb");
			while (!feof(l_f)) {
				l_nb = fread(l_buf, 1, 1024, l_f);
				fwrite(l_buf, 1, l_nb, i_f);
			}
			fclose(l_f);
			printf(".");
			break;
		default:
			break;
	}
	l_ret = 1;
    return l_ret;
}

int M_save_baseRes_info(FILE *i_f, int i_cmd)
{
    int l_nb;
    int l_cpt;
    
    l_nb=0;
    // fichier dat
    l_nb += M_save_baseRes_info_cmd(i_f, i_cmd, "coconut.dat" );
    // fichiers ressources
	for (l_cpt=0; l_cpt<M_gNbNames; l_cpt++) {
		l_nb += M_save_baseRes_info_cmd(i_f, i_cmd, M_gFileName[l_cpt]);
	}
    return l_nb;
}

int M_save_baseRes_getFileNames()
{
    int l_nb;
    int l_cpt;
    int l_cpt_anim;
	TC_RESBITMAP	*l_ptrAnim;
    
    M_initFileName();
    // fichiers ressources
	for (l_cpt=1; l_cpt<R_gNb_res; l_cpt++) {
		switch(R_gTab_res[l_cpt].type) {
		case ResType_Anim:
			l_cpt_anim=0;
			l_ptrAnim=&(R_gTab_res[l_cpt].resAnim);
			while (l_ptrAnim) {
                M_addFileName(l_ptrAnim->filePath);
				l_cpt_anim++;
				l_ptrAnim = l_ptrAnim->pNext;
			}
			break;
		case ResType_Bmp:
            M_addFileName(R_gTab_res[l_cpt].resBmp.filePath);
			break;
		case ResType_AviCD:
			break;
		case ResType_Wav:
            M_addFileName(R_gTab_res[l_cpt].resSon.fileName);
			break;
		case ResType_Mid:
            M_addFileName(R_gTab_res[l_cpt].resSon.fileName);
			break;
		case ResType_PisteCD:
			break;
		case ResType_Text:
			break;
		default:
			break;
		}
	}
    return l_nb;
}


int M_saveFile_BaseRes(char *ip_name)
{
	FILE *l_f;
    char  l_basename[255];
    int l_nb;
    
    if (ip_name==NULL) {
        return 0;
    }

    // Recuperation du chemin
    M_cpy_basename(l_basename, ip_name);

	// Ouverture du fichier de ressources
	l_f = fopen(ip_name,"wb");
	if (!l_f) {
		return 0;
	}

    // Recopie de l'executable
    M_copy_fich(NULL, l_basename, "coconut.exe");
    M_copy_fich(NULL, l_basename, "coconut.dat");
    M_copy_fich(NULL, l_basename, "go_fenetre.bat");
    M_copy_fich(NULL, l_basename, "go_fullscreen.bat");

	// Recuperation des noms de fichiers valides
	M_save_baseRes_getFileNames();

    // Nombre de fichiers
    l_nb = M_save_baseRes_info(l_f, M_save_baseRes_info_cmd_nbfich);
    fprintf(l_f, "%d\n", l_nb);

    // Infos fichiers
    l_nb = M_save_baseRes_info(l_f, M_save_baseRes_info_cmd_saveinfo);

	fprintf(l_f, M_gResFileSeparator);
    // Datas
    l_nb = M_save_baseRes_info(l_f, M_save_baseRes_info_cmd_savedata);

	// Fermeture du fichier
	fclose(l_f);
	return 1;
}


int M_saveFile_BaseFich(char *ip_name)
{
	FILE *l_f;
	int l_cpt;
	int l_cpt_anim;
	TC_RESBITMAP	*l_ptrAnim;
    char  l_basename[255];

    if (ip_name==NULL) {
        return 0;
    }

    // Recuperation du chemin
    M_cpy_basename(l_basename, ip_name);

	// Ouverture du fichier de log
	l_f = fopen(ip_name,"w");
	if (!l_f) {
		return 0;
	}

    // Recopie de l'executable
    M_copy_fich(l_f, l_basename, "coconut.exe");
    M_copy_fich(l_f, l_basename, "coconut.dat");
    M_copy_fich(l_f, l_basename, "go_fenetre.bat");
    M_copy_fich(l_f, l_basename, "go_fullscreen.bat");

    // Recopie du fichier de config
    fprintf(l_f, "Fichier de config :\n");


	// Recopie des Fichiers de Ressources
	fprintf(l_f, "\n[Ressources]\n");
	fprintf(l_f, "NbRessources=%d\n", R_gNb_res-1);
	for (l_cpt=1; l_cpt<R_gNb_res; l_cpt++) {
		switch(R_gTab_res[l_cpt].type) {
		case ResType_Anim:
			l_cpt_anim=0;
			l_ptrAnim=&(R_gTab_res[l_cpt].resAnim);
			while (l_ptrAnim) {
				fprintf(l_f, "filePathAnim%d=%s\n", l_cpt_anim, l_ptrAnim->filePath);
                M_copy_fich(l_f, l_basename, l_ptrAnim->filePath);
				l_cpt_anim++;
				l_ptrAnim = l_ptrAnim->pNext;
			}
			break;
		case ResType_Bmp:
			fprintf(l_f, "filePathBmp=%s\n", R_gTab_res[l_cpt].resBmp.filePath);
            M_copy_fich(l_f, l_basename, R_gTab_res[l_cpt].resBmp.filePath);
			break;
		case ResType_AviCD:
			break;
		case ResType_Wav:
			fprintf(l_f, "filePathWav=%s\n", R_gTab_res[l_cpt].resSon.fileName);
            M_copy_fich(l_f, l_basename, R_gTab_res[l_cpt].resSon.fileName);
			break;
		case ResType_Mid:
			fprintf(l_f, "filePathMid=%s\n", R_gTab_res[l_cpt].resSon.fileName);
            M_copy_fich(l_f, l_basename, R_gTab_res[l_cpt].resSon.fileName);
			break;
		case ResType_PisteCD:
			break;
		case ResType_Text:
			break;
		default:
			break;
		}
	}


	// Fermeture du fichier
	fclose(l_f);
	return 1;
}


int M_saveFile_BaseExtract(char *ip_name)
{
	return 1;
}
