/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Main
 *
 *
 */

/****** Includes systmes ******/
#ifdef WIN32
#include <windows.h>
#endif
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

/****** Includes applicatifs ******/
#include "R_ressources.h"
#include "A_aff.h"
#include "S_scenario.h"
#include "M_dialogue.h"
#include "O_objets.h"
#include "O_panneau.h"
#include "M_scenes.h"
#include "T_trace.h"
#include "I_input.h"
#include "S_son.h"
#include "M_dep.h"
#include "M_files.h"
#include "M_engine.h"
#include "M_resFile.h"


main(int argc, char *argv[])
{
	char	*l_ptr;
	char	l_configFile[255]="coconut.dat";
	int		l_cpt;
	int l_argc = argc;

	/* traitement */
	///SDL_SetTimer(100, gestTimer);
	/* Wait for a keystroke */
	while ( l_argc > 1 ) {
		--l_argc;
		if ( strcmp(argv[l_argc], "-D") == 0 ) {
			 M_g_mode_Windows=0; 
		} else
		if ( strcmp(argv[l_argc], "-T") == 0 ) {
			 T_initTrace(); 
		} else
		if ( strcmp(argv[l_argc], "-E") == 0 ) {
			 R_setLang(TE_english); 
		} else
		if ( strcmp(argv[l_argc], "-F") == 0 ) {
			 R_setLang(TE_francais); 
		} else
		if ( strncmp(argv[l_argc], "-C", 2) == 0 ) {
			l_ptr=argv[l_argc]+2;
			l_cpt = 0;
			while ((l_ptr)&&(*l_ptr)&&((*l_ptr)!=' ')) {
				l_configFile[l_cpt] = (*l_ptr); 
				l_cpt++;
				l_ptr++;
			}
			l_configFile[l_cpt] = 0;
		} 
	}

    
	if( !M_doInit_SDL( argc, argv ) )
    {
        return T_FALSE;
    }

    if( !M_doInit( l_configFile ) )
    {
        return T_FALSE;
    }
printf("Go\n");

	M_gQuitter = 0;
	while ( !M_gQuitter ) {
		/* 
		/* Check for events */
		M_process();
		M_SDL_Process();


	}


	//SDL_SetTimer(0, NULL);
	
	printf("Termine\n");
	exit(0);
return 0;
}



