/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Main
 *
 *
 */

/****** Includes systmes ******/
#ifdef WIN32
#include <windows.h>
#endif
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

/****** Includes applicatifs ******/
#include "R_ressources.h"
#include "A_aff.h"
#include "S_scenario.h"
#include "M_dialogue.h"
#include "O_objets.h"
#include "O_panneau.h"
#include "M_scenes.h"
#include "T_trace.h"
#include "I_input.h"
#include "S_son.h"
#include "M_dep.h"
#include "M_files.h"
#include "M_engine.h"
#include "M_resFile.h"


#ifndef USE_SDL

/*************************************************
* Nom	: WinMain
* Desc	: Main Windows. Inititalise, reoit les messages...
* Arg	: Nant
**************************************************/
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine, int nCmdShow)
{
    MSG     msg;
	char	*l_ptr;
	char	l_configFile[255]="coconut.dat";
	int		l_cpt;

	// Arguments
    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;
    if(l_ptr=strstr(lpCmdLine,"-D")) { M_g_mode_Windows=0; }
	if(l_ptr=strstr(lpCmdLine,"-T")) { T_initTrace(); }
	if(l_ptr=strstr(lpCmdLine,"-E")) { R_setLang(TE_english);; }
	if(l_ptr=strstr(lpCmdLine,"-F")) { R_setLang(TE_francais);; }
	if(l_ptr=strstr(lpCmdLine,"-C")) { 
		l_ptr+=2;
		l_cpt = 0;
		while ((l_ptr)&&(*l_ptr)&&((*l_ptr)!=' ')) {
			l_configFile[l_cpt] = (*l_ptr); 
			l_cpt++;
			l_ptr++;
		}
		l_configFile[l_cpt] = 0;

	}
	

	T_traceFreeMem("Debut WinMain");
	char *p;

	if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_TIMER) < 0 ) {
		p = SDL_GetError();
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		if ( SDL_Init(SDL_INIT_VIDEO|SDL_INIT_CDROM) < 0 ) {
			fprintf(stderr, "Couldn't initialize SDL without AUDIO neither: %s\n",SDL_GetError());
			exit(1);
		}
	}
	atexit(SDL_Quit);

    if( !M_doInit_DirectX( hInstance, nCmdShow ) )
    {
        return T_FALSE;
    }
    if( !M_doInit(l_configFile ) )
    {
        return T_FALSE;
    }

    while( 1 )
    {
        if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
        {
            if( !GetMessage( &msg, NULL, 0, 0 ) )
                return msg.wParam;
            TranslateMessage(&msg); 
            DispatchMessage(&msg);
        }
        else if( M_gbActive )
        {
            M_process();
        }
        else
        {
            // make sure we go to sleep if we have nothing else to do
            WaitMessage();
        }
    }
	// Fin des traces
	T_closeTrace();
	return T_TRUE;
} /* WinMain */
#endif