/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Moteur
 *	Chargement/Sauvegarde des scnes, objets, ressources dans un fichier de ressource
 *
 */
 
/****** Includes systmes ******/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/****** Includes applicatifs ******/
#include "M_resFile.h"

// Fichier de ressource
char M_gResFileName[128]="coconut.cre";
FILE *M_gResFileB=0;	// Fichier lecture binaire

// Index
#define M_gnbIndexTabEntryMax 1000
TS_index_entry	M_gIndexTab[M_gnbIndexTabEntryMax];
int M_gIndexTabNbEntry=0;

void M_cleanCRLF(char *ip_text)
{
	int l_len;
	int l_cpt;

	l_len = strlen(ip_text);
	for (l_cpt=0; l_cpt<3; l_cpt++) {
		if (l_len>0) { l_len--; }
		if ( ( (*(ip_text+l_len))==10)||((*(ip_text+l_len))==13) ) { 
			(*(ip_text+l_len))=0; 
		}
	}
}


int M_InitResFile(char *ip_name)
{
	int l_nb;
	char l_buf[1024];
	int l_cpt;
	char *l_ptr;
	int l_offset;

	// Ouverture
	strcpy(M_gResFileName, ip_name);
	M_gResFileB	= fopen (ip_name, "rb");
	if ((M_gResFileB==0)) {
		printf("impossible d'ouvrir le fichier de ressources\n");
		return -1;
	}
	// Chargement de l'index
	// Nb de fichiers contenus
	M_gIndexTabNbEntry=0;
	l_buf[1023]=0;	// si le fichier est pourri, on vite les pb...
	fgets(l_buf, 1022, M_gResFileB);
	l_nb = atoi(l_buf);
	if (l_nb==0) {
		printf("Fichier de ressource non valide\n");
	}
	// Lecture de la ligne de chaque description de fichier
	for (l_cpt=0; l_cpt<l_nb; l_cpt++) {
		fgets(l_buf, 1022, M_gResFileB);		
		M_gIndexTab[l_cpt].size = atoi(l_buf);
		l_ptr = strstr(l_buf, ":");
		if (l_ptr==NULL) {
			printf("Fichier de ressource : description fichier (%d) non valide\n", l_cpt);
			return -2;
		} 
		l_ptr++; // on saute le :
		M_cleanCRLF(l_ptr);		
		strncpy(M_gIndexTab[l_cpt].fich, l_ptr, 1024);
		M_gIndexTab[l_cpt].offset = 0; // pour l'instant
	}
	// On doit trouver un marqueur de sparation
	fgets(l_buf, 1022, M_gResFileB);
	if (strncmp(l_buf, M_gResFileSeparator, strlen(M_gResFileSeparator))!=0) {
		printf("Fichier de ressource : Fin de description fichier non trouve\n");
		return -2;
	} 
	// Les datas sont l !!!
	l_offset = ftell(M_gResFileB);
	// On calcule les offsets
	for (l_cpt=0; l_cpt<l_nb; l_cpt++) {
		M_gIndexTab[l_cpt].offset = l_offset;
		l_offset += M_gIndexTab[l_cpt].size;
	}
	M_gIndexTabNbEntry = l_nb;
	return 0;
}

int M_closeResFile(char *ip_name)
{
	fclose (M_gResFileB);
	return 0;
}


int M_getEntryNumInIndexTab(char *ip_name)
{
	int l_cpt;
	for (l_cpt=0; l_cpt<M_gIndexTabNbEntry; l_cpt++) {
		if (strcmp(M_gIndexTab[l_cpt].fich, ip_name)==0) {
			return l_cpt;
		}
	}
	return -1;
}

int M_getFileFromResFile(char *ip_name, FILE **ip_f, int *ip_len)
{
	int l_num;
	int l_ret;

	l_num = M_getEntryNumInIndexTab(ip_name);
	if (l_num == -1) {
		(*ip_f)	= NULL;
		(*ip_len)=0;
		l_ret = -1;
	} else {
		(*ip_f)	= fopen(M_gResFileName, "rb");
		fseek((*ip_f), M_gIndexTab[l_num].offset, 0);
		(*ip_len) = M_gIndexTab[l_num].size;
		l_ret = 0;
	}
	return l_ret;
}


int M_getPtrFromResFile(char *ip_name, char **ip_ptr, int *ip_len)
{
	int l_num;
	int l_ret;

	l_num = M_getEntryNumInIndexTab(ip_name);
	if (l_num == -1) {
		(*ip_ptr)	= NULL;
		(*ip_len)=0;
		l_ret = -1;
	} else {
		(*ip_ptr) = (char *)malloc(M_gIndexTab[l_num].size);
		fseek(M_gResFileB, M_gIndexTab[l_num].offset-2, 0);
		fread((*ip_ptr), M_gIndexTab[l_num].size, 1, M_gResFileB);
		(*ip_len)=M_gIndexTab[l_num].size;
		l_ret = 0;
	}
	//printf("getPtrFromResFile num=%d len=%d offset=%d [%c%c%c%c]\n", l_num, (*ip_len), M_gIndexTab[l_num].offset-2, 
	//	(*ip_ptr)[0], (*ip_ptr)[1], (*ip_ptr)[2], (*ip_ptr)[3]);

	return l_ret;
}

