/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Scnes
 *
 *
 */

/****** Includes systmes ******/
#include <stdlib.h>
#include <string.h>

/****** Includes applicatifs ******/
#include "M_scenes.h"
#include "A_aff.h"
#include "O_objets.h"
#include "M_dep.h"
#include "S_son.h"
#include "S_scenario.h"
#include "M_files.h"
#include "M_engine.h"

TC_SCENE	M_gTab_scene[Nb_scenesMax];
int			M_gNb_scenes=0;
TC_SCENE	M_gScene_active;



TPC_Scene cgb_scenes_get_ptr_by_index(int i_index)
{
	return &(M_gTab_scene[i_index]);
}

int cgb_scenes_get_count()
{
	return M_gNb_scenes;
}

TC_SCENE::TC_SCENE()
{
	strcpy(name, "");
	scale_perso = 0;
}

void TC_SCENE::clear()
{
	strcpy(name, "");
}

void TC_SCENE::setScalePerso(float i_scale)
{
	scale_perso = i_scale;
}


int cgb_scenes_get_index_by_name(char *ip_name)
{
	int l_cpt;

	for (l_cpt=0; l_cpt<M_gNb_scenes; l_cpt++) {
		if (strcmp(M_gTab_scene[l_cpt].name, ip_name)==0) {
			return l_cpt;
		}
	}
	return 0;
}

TPC_Scene cgb_scenes_get_ptr_by_name(char *ip_name)
{
	int l_cpt;

	l_cpt = cgb_scenes_get_index_by_name(ip_name);
	return &(M_gTab_scene[l_cpt]);
}


void TC_SCENE::setName(char *ip_name)
{
	strcpy(name, ip_name);
}


T_BOOL TC_SCENE::isName(char *ip_name)
{
	T_BOOL l_ret;
	if (strcmp(name, ip_name)==0) {
		l_ret = T_TRUE;
	} else {
		l_ret = T_FALSE;
	}
	return l_ret;
}


int cgb_scenes_clear()
{
	int l_cpt;

	for (l_cpt=0; l_cpt<Nb_scenesMax; l_cpt++) {
		M_gTab_scene[l_cpt].clear();
	}
	M_gNb_scenes=0;
	return 0;
}

int cgb_scenes_add(char *ip_name, float i_scalePerso)
{
    if (M_gNb_scenes==0) { M_gNb_scenes=1; }
	M_gTab_scene[M_gNb_scenes].setName(ip_name);
	M_gTab_scene[M_gNb_scenes].setScalePerso(i_scalePerso);
	M_gNb_scenes++;
	return 0;
}
int  cgb_scenes_ren(char *ip_name_old, char *ip_name_new)
{
	int l_cpt;
	l_cpt = cgb_scenes_get_index_by_name(ip_name_old);
	M_gTab_scene[l_cpt].setName(ip_name_new);
	return 0;
}

int cgb_scenes_del(char *ip_name)
{
    int l_index;
    int l_cpt;

    l_index = cgb_scenes_get_index_by_name(ip_name);
    if (l_index==0)  { return 0; }
    for (l_cpt=l_index; l_cpt<(M_gNb_scenes-1); l_cpt++) {
        M_gTab_scene[l_cpt] = M_gTab_scene[l_cpt+1];
    }
    M_gNb_scenes--;
	return 1;
}

/*

int cgb_scenes_add_from_file(char *ip_bufScene, char *ip_fileName)
{
	char l_name[NAMELEN];
	char l_buf[NAMELEN];
	float l_scale;
	int l_ret;

	l_ret = GetPrivateProfileString(ip_bufScene, "Name", "", l_name, NAMELEN, ip_fileName);
	l_ret = GetPrivateProfileString(ip_bufScene, "ScalePerso", "", l_buf, NAMELEN, ip_fileName);
	l_scale = (float)atof(l_buf);
	cgb_scenes_add(l_name, l_scale);
	return 0;
}
*/

int cgb_scenes_add_from_mem(char *ip_bufScene)
{
	char l_name[NAMELEN];
	char l_buf[NAMELEN];
	float l_scale;
	int l_ret;

	l_ret = M_getParamStr(ip_bufScene, "Name", "", l_name, NAMELEN);
	l_ret = M_getParamStr(ip_bufScene, "ScalePerso", "", l_buf, NAMELEN);
	l_scale = (float)atof(l_buf);
	cgb_scenes_add(l_name, l_scale);
	return 0;
}


