/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Affichage du panneau droit droulant
 *
 *
 */
/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "O_panneau.h"
#include "M_dialogue.h"

/****** Variables globales ******/
TC_Panneau O_gPanneau;

void TC_Panneau::InitPanneau(long i_xOuvert, long i_xFerme)
{
	xPanneauFerme = i_xFerme;
	if (i_xOuvert== 0) {
		i_xOuvert = ptCoord.y; // Ouvert dans l'editeur
	}
	xPanneauOuvert= i_xOuvert;
	etatOuverture = EtatPanneau_Ferme;
	ptCoord.y = i_xFerme;
	vitPanneau = 4;
	premObjetAff = 1;
}

void TC_Panneau::GestionPanneau(long i_xMouse, long i_yMouse)
{
	if (i_yMouse>(xPanneauFerme-15)) {
		if (etatOuverture != EtatPanneau_Ouvert) {
			etatOuverture = EtatPanneau_Ouvrant;
		}
	}

	if (i_yMouse<xPanneauOuvert) {
		if (etatOuverture != EtatPanneau_Ferme) {
			etatOuverture = EtatPanneau_Fermant;
		}
	}

	switch (etatOuverture)
	{
	case EtatPanneau_Ouvert: break;
	case EtatPanneau_Ferme: break;
	case EtatPanneau_Ouvrant: 
		ptCoord.y-=vitPanneau;
		if (ptCoord.y<=xPanneauOuvert) {
			ptCoord.y = xPanneauOuvert;
			etatOuverture = EtatPanneau_Ouvert;
		}
		break;
	case EtatPanneau_Fermant: 
		ptCoord.y+=vitPanneau;
		if (ptCoord.y>=xPanneauFerme) {
			ptCoord.y = xPanneauFerme;
			etatOuverture = EtatPanneau_Ferme;
		}
		break;
	}
	if (cgb_dialog_is_on()) {
		etatOuverture = EtatPanneau_Ouvert;
		ptCoord.y = xPanneauOuvert;
	}
		
}
