/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Ressources
 *
 *
 */

/****** Includes systmes ******/
#include <sys/stat.h>
#include <string.h>

/****** Includes applicatifs ******/
#include "R_ressources.h"
#include "A_aff.h"
#include "M_files.h"

TS_label R_gTab_resType[]={ "Null","Anim", "Bmp", "AviCD",
"Wav", "Mid", "PisteCD", "Text" , R_LastLabel};

TC_Res	R_gTab_res[Nb_resMax];
int		R_gNb_res=0;



int R_getResTypeFromLabel(char *ip_label)
{
	int l_cpt;
	int l_type;

	l_cpt=0;
	while (strcmp(R_gTab_resType[l_cpt].label, R_LastLabel)!=0) {
		if (strcmp(R_gTab_resType[l_cpt].label, ip_label)==0) {
			l_type = (TE_ResType)l_cpt;
			return l_type;
		}
		l_cpt++;
	}
	return 0;
}

int  cgb_res_clear()
{
	int l_cpt;

	for (l_cpt=0; l_cpt<Nb_resMax; l_cpt++) {
		R_gTab_res[l_cpt].Clear();
	}
	R_gNb_res=0;
	return 0;
}

int cgb_res_add(char *ip_name, char *ip_type)
{
    if (R_gNb_res == 0) { R_gNb_res = 1; }
	R_gTab_res[R_gNb_res].SetName(ip_name);
	R_gTab_res[R_gNb_res].SetType(ip_type);
	R_gNb_res++;
	return 0;
}

int cgb_res_ren(char *ip_name_old, char *ip_name_new)
{
	int l_cpt;
	l_cpt = cgb_res_get_index_by_name(ip_name_old);
	R_gTab_res[l_cpt].SetName(ip_name_new);
	return 0;
}

int cgb_res_del(char *ip_name)
{
    int l_index;
    int l_cpt;

    l_index = cgb_res_get_index_by_name(ip_name);
    if (l_index==0)  { return 0; }
    for (l_cpt=l_index; l_cpt<(R_gNb_res-1); l_cpt++) {
        R_gTab_res[l_cpt] = R_gTab_res[l_cpt+1];
    }
    R_gNb_res--;
	return 0;
}

int cgb_res_bmp_add(char *ip_name, char *ip_fileName)
{
    if (R_gNb_res == 0) { R_gNb_res = 1; }
	R_gTab_res[R_gNb_res].SetName(ip_name);
	R_gTab_res[R_gNb_res].SetType("Bmp");
	R_gTab_res[R_gNb_res].resAnim.SetBitmapFromWholeFile( 0, ip_fileName);
	R_gNb_res++;
	return 0;
}

int cgb_res_text_add(char *ip_name, char *ip_text, char *ip_textEng)
{
    if (R_gNb_res == 0) { R_gNb_res = 1; }
	R_gTab_res[R_gNb_res].SetName(ip_name);
	R_gTab_res[R_gNb_res].SetType("Text");
	R_gTab_res[R_gNb_res].resText.SetText(ip_text);
	R_gTab_res[R_gNb_res].resText.SetTextEng(ip_textEng);
	R_gNb_res++;
	return 0;
}

int cgb_res_anim_add(char *ip_name)
{
    if (R_gNb_res == 0) { R_gNb_res = 1; }
	R_gTab_res[R_gNb_res].SetName(ip_name);
	R_gTab_res[R_gNb_res].SetType("Anim");
	R_gNb_res++;
	return 0;
}

int cgb_res_wav_add(char *ip_name, char *ip_fileName)
{
    if (R_gNb_res == 0) { R_gNb_res = 1; }
	R_gTab_res[R_gNb_res].SetName(ip_name);
	R_gTab_res[R_gNb_res].SetType("Wav");
	R_gTab_res[R_gNb_res].resSon.SetFileName(ip_fileName);
	R_gNb_res++;
	return 0;
}

int cgb_res_mid_add(char *ip_name, char *ip_fileName)
{
    if (R_gNb_res == 0) { R_gNb_res = 1; }
	R_gTab_res[R_gNb_res].SetName(ip_name);
	R_gTab_res[R_gNb_res].SetType("Mid");
	R_gTab_res[R_gNb_res].resSon.SetFileName(ip_fileName);
	R_gNb_res++;
	return 0;
}


int cgb_res_get_index_by_name(char *ip_name)
{
	int l_cpt;
	for (l_cpt=0; l_cpt<R_gNb_res ;l_cpt++) {
		if (R_gTab_res[l_cpt].isName(ip_name)) {
			return l_cpt;
		}
	}
	return 0;
}

TPC_Res cgb_res_get_ptr_by_name(char *ip_name)
{
	int l_cpt;
	for (l_cpt=0; l_cpt<R_gNb_res ;l_cpt++) {
		if (R_gTab_res[l_cpt].isName(ip_name)) {
			return &(R_gTab_res[l_cpt]);
		}
	}
	return &(R_gTab_res[0]);
}

int cgb_res_anim_get_index_by_name(char *ip_name)
{
	int l_cpt;
	l_cpt = cgb_res_get_index_by_name(ip_name);
	return l_cpt;
}

int R_addAnimInResAnim(char *ip_name, int i_pos, char *ip_fileName, int i_tempo )
{
	int l_anim;

	l_anim = cgb_res_anim_get_index_by_name(ip_name);
	if (l_anim) {
		R_gTab_res[l_anim].resAnim.SetBitmapFromWholeFile( i_pos, ip_fileName);
		R_gTab_res[l_anim].resAnim.SetTempo(i_pos,i_tempo);
		return 0;
	} else {
		return 1;
	}
}
/*
int  cgb_res_add_from_file(char *ip_bufRes, char *ip_fileName)
{
	char l_bufName[NAMELEN];
	char l_bufType[NAMELEN];
	int  l_ret;
	int  l_type;
	int  l_nbAnim;
	char l_champ[NAMELEN];
	int  l_cpt;
	char l_bufFilePath[NAMELEN];
	int  l_tempo;
	char l_bufText[resTextLenMax];

	l_ret = GetPrivateProfileString(ip_bufRes, "Name", "", l_bufName, NAMELEN, ip_fileName);
	l_ret = GetPrivateProfileString(ip_bufRes, "Type", "", l_bufType, NAMELEN, ip_fileName);
	
	l_type = R_getResTypeFromLabel(l_bufType);
	switch (l_type) {
		case ResType_Anim: 
			R_addResAnim(l_bufName);
			l_nbAnim = GetPrivateProfileInt(ip_bufRes, "nbAnim", 0, ip_fileName);
			for (l_cpt=0; l_cpt<l_nbAnim; l_cpt++) {
				sprintf(l_champ, "filePath%d", l_cpt);
				l_ret = GetPrivateProfileString(ip_bufRes, l_champ, "", l_bufFilePath, NAMELEN, ip_fileName);
				sprintf(l_champ, "tempo%d", l_cpt);
				l_tempo = GetPrivateProfileInt(ip_bufRes, l_champ, 0, ip_fileName);
				R_addAnimInResAnim(l_bufName, l_cpt, l_bufFilePath, l_tempo);
			}
			break;
		case ResType_Bmp:
			l_ret = GetPrivateProfileString(ip_bufRes, "filePath", "", l_bufFilePath, NAMELEN, ip_fileName);
			R_addResBmp(l_bufName, l_bufFilePath);
			break;
		case ResType_AviCD:
			R_addRes(l_bufName, l_bufType);
			break;
		case ResType_Wav:
			l_ret = GetPrivateProfileString(ip_bufRes, "filePath", "", l_bufFilePath, NAMELEN, ip_fileName);
			R_addResWav(l_bufName, l_bufFilePath);
			break;
		case ResType_Mid:
			l_ret = GetPrivateProfileString(ip_bufRes, "filePath", "", l_bufFilePath, NAMELEN, ip_fileName);
			R_addResMid(l_bufName, l_bufFilePath);
			break;
		case ResType_PisteCD:
			R_addRes(l_bufName, l_bufType);
			break;
		case ResType_Text:
			l_ret = GetPrivateProfileString(ip_bufRes, "textBuf", "", l_bufText, resTextLenMax, ip_fileName);
			R_addResText(l_bufName, l_bufText);
			break;
		default:
			R_addRes(l_bufName, l_bufType);
			break;
	}


	return 0;
}
*/

int  cgb_res_add_from_mem(char *ip_bufRes)
{
	char l_bufName[NAMELEN];
	char l_bufType[NAMELEN];
	int  l_ret;
	int  l_type;
	int  l_nbAnim;
	char l_champ[NAMELEN];
	int  l_cpt;
	char l_bufFilePath[NAMELEN];
	int  l_tempo;
	char l_bufText[resTextLenMax];
	char l_bufText2[resTextLenMax];

	l_ret = M_getParamStr(ip_bufRes, "Name", "", l_bufName, NAMELEN);
	l_ret = M_getParamStr(ip_bufRes, "type", "", l_bufType, NAMELEN);
	
	l_type = R_getResTypeFromLabel(l_bufType);
	switch (l_type) {
		case ResType_Anim: 
			cgb_res_anim_add(l_bufName);
			l_nbAnim = M_getParamInt(ip_bufRes, "nbAnim", 0);
			for (l_cpt=0; l_cpt<l_nbAnim; l_cpt++) {
				sprintf(l_champ, "filePath%d", l_cpt);
				l_ret = M_getParamStr(ip_bufRes, l_champ, "", l_bufFilePath, NAMELEN);
				sprintf(l_champ, "tempo%d", l_cpt);
				l_tempo = M_getParamInt(ip_bufRes, l_champ, 0);
				R_addAnimInResAnim(l_bufName, l_cpt, l_bufFilePath, l_tempo);
			}
			break;
		case ResType_Bmp:
			l_ret = M_getParamStr(ip_bufRes, "filePath", "", l_bufFilePath, NAMELEN);
			cgb_res_bmp_add(l_bufName, l_bufFilePath);
			break;
		case ResType_AviCD:
			cgb_res_add(l_bufName, l_bufType);
			break;
		case ResType_Wav:
			l_ret = M_getParamStr(ip_bufRes, "filePath", "", l_bufFilePath, NAMELEN);
			cgb_res_wav_add(l_bufName, l_bufFilePath);
			break;
		case ResType_Mid:
			l_ret = M_getParamStr(ip_bufRes, "filePath", "", l_bufFilePath, NAMELEN);
			cgb_res_mid_add(l_bufName, l_bufFilePath);
			break;
		case ResType_PisteCD:
			cgb_res_add(l_bufName, l_bufType);
			break;
		case ResType_Text:
			l_ret = M_getParamStr(ip_bufRes, "textBuf", "", l_bufText, resTextLenMax);
			l_ret = M_getParamStr(ip_bufRes, "textBufEng", "", l_bufText2, resTextLenMax);
			cgb_res_text_add(l_bufName, l_bufText, l_bufText2);
			break;
		default:
			cgb_res_add(l_bufName, l_bufType);
			break;
	}


	return 0;
}


int TC_Res::isName(char *ip_name)
{
	int l_ret;
	int l_res;

	l_res = strcmp(name, ip_name);
	if (l_res) {
		l_ret = 0;
	} else {
		l_ret = 1;
	}
	return l_ret;
}

int TC_Res::Clear()
{
	SetName("");
	resAnim.SetBitmapFromWholeFile( 0, "");
	resText.SetText("");;

	return 0;
}

int TC_Res::SetName(char *ip_name)
{
	strcpy(name, ip_name);
	return 0;
}

int TC_Res::SetType(char *ip_type)
{
	int l_ret;

	type = (TE_ResType)R_getResTypeFromLabel(ip_type);
	if (type) {
		l_ret = 0;
	} else {
		l_ret = 1;
	}
	return l_ret;;
}

int TC_Res::GetName(char *op_name)
{
	strcpy(op_name, name);
	return 0;
}


int TC_Res::GetType(char *op_type)
{
	strcpy(op_type, R_gTab_resType[type].label);
	return 0;
}

T_BOOL TC_Res::isTypeAnim()
{
    T_BOOL l_ret;
    if (type == ResType_Anim) {
        l_ret = T_TRUE;
    } else  {
        l_ret = T_FALSE;
    }
    return l_ret;
}

T_BOOL TC_Res::isTypeText()
{
    T_BOOL l_ret;
    if (type == ResType_Text) {
        l_ret = T_TRUE;
    } else  {
        l_ret = T_FALSE;
    }
    return l_ret;
}

T_BOOL TC_Res::isTypeWav()
{    T_BOOL l_ret;
    if (type == ResType_Wav) {
        l_ret = T_TRUE;
    } else  {
        l_ret = T_FALSE;
    }
    return l_ret;
}

T_BOOL TC_Res::isTypeMid()
{
    T_BOOL l_ret;
    if (type == ResType_Mid) {
        l_ret = T_TRUE;
    } else  {
        l_ret = T_FALSE;
    }
    return l_ret;
}

T_BOOL TC_Res::isTypePisteCD()
{
    T_BOOL l_ret;
    if (type == ResType_PisteCD) {
        l_ret = T_TRUE;
    } else  {
        l_ret = T_FALSE;
    }
    return l_ret;
}

T_BOOL TC_Res::isTypeSon()
{
    T_BOOL l_ret;
    if (   (type == ResType_Wav)
         ||(type == ResType_Mid)
         ||(type == ResType_PisteCD) )  {
        l_ret = T_TRUE;
    } else  {
        l_ret = T_FALSE;
    }
    return l_ret;
}



