/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Ressources Anims
 *
 *
 */

/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "A_aff.h"
#include "R_ressources_anims.h"
#include "M_resFile.h"
#include <string.h>



TC_RESBITMAP::TC_RESBITMAP()
{
	pNext=NULL;
	tempo=0;
	dwColor=0;
	dwTrans=T_DDBLTFAST_SRCCOLORKEY;
	//dwTrans=DDBLTFAST_NOCOLORKEY;

	lpSurface=NULL;

}

T_BOOL  TC_RESBITMAP::isTransparent()
{
    T_BOOL l_ret;
    if (dwTrans==T_DDBLTFAST_SRCCOLORKEY) {
        l_ret = T_TRUE;
    } else {
        l_ret = T_FALSE;
    }
    return l_ret;
}

TC_RESBITMAP::~TC_RESBITMAP()
{
}

void TC_RESBITMAP::SetNext(TC_RESBITMAP* ip_pNext)
{
	pNext=ip_pNext;
}

void TC_RESBITMAP::FreeSurface()
{

#ifdef USE_SDL
    if( lpSurface != NULL )
    {
        SDL_FreeSurface(lpSurface);
        lpSurface = NULL;
    }
#else
    if( lpSurface != NULL )
    {
        lpSurface->Release();
        lpSurface = NULL;
    }
#endif

}


void TC_RESBITMAP::SetSurface(TP_DD ip_DD, TP_DDSurface ip_Source, T_RECT i_recZone, T_BOOL isTransparentKey/*=TRUE*/)
{
#ifdef USE_SDL
	SDL_Rect	dst;
	Uint32 flags;
	int width;
	int height;
	int depth;
	Uint32 Rmask=0;
	Uint32 Gmask=0;
	Uint32 Bmask=0;
	Uint32 Amask=0;

	// Allocation de la surface
	flags = SDL_SWSURFACE;
	depth = ip_Source->format->BitsPerPixel;
	width = ip_Source->w;
	height = ip_Source->h;
	//lpSurface = SDL_AllocSurface (flags, width, height, depth, Rmask, Gmask, Bmask, Amask);

	// Recopie de la surface
	dst.x = 0;
	dst.y = 0;
	dst.w = ip_Source->w;
	dst.h = ip_Source->h;

	//SDL_BlitSurface(ip_Source, NULL, lpSurface, NULL);
	
	//lpSurface = SDL_ConvertSurface(ip_Source, A_gAff.lpDDSBack->format, 0);
	lpSurface = SDL_DisplayFormat(ip_Source);

	//if (isTransparentKey) {
	//SDL_SetColorKey(fond, SDL_SRCCOLORKEY, *(Uint32 *)fond);
			SDL_SetColorKey(lpSurface, SDL_SRCCOLORKEY, 
				SDL_MapRGB(lpSurface->format, 255, 0, 255)
				//*(Uint32 *)(lpSurface->pixels)
				);
			//SDL_SetAlpha(lpSurface, SDL_SRCALPHA, 128);
	//}
	recRect.left=0;
	recRect.top=0;
	recRect.right=i_recZone.right-i_recZone.left;
	recRect.bottom=i_recZone.bottom-i_recZone.top;


#else

    DDSURFACEDESC       ddsd;
    HRESULT             ddrval;

	if (lpSurface) FreeSurface();

	// Allocation de la surface
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT |DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    ddsd.dwWidth = i_recZone.right-i_recZone.left+1;
    ddsd.dwHeight = i_recZone.bottom-i_recZone.top+1;
    ddrval = ip_DD->CreateSurface( &ddsd, &lpSurface, NULL );

	// set color Key, methode souple: recherche la couleur dans la palette.
	// 255.0.255 = violet
    DDSetColorKey(lpSurface, RGB(255,0,255));

	// set color Key, methode dure: donne la couleur en dur.
	// DDCOLORKEY          ddck;
	// ddck.dwColorSpaceLowValue = 0xff;
	// ddck.dwColorSpaceHighValue = 0xff;
	// lpSurface->SetColorKey( DDCKEY_SRCBLT, &ddck );


	// Recopie de l'image
	if (isTransparentKey)
		dwTrans=DDBLTFAST_SRCCOLORKEY;
	else
		dwTrans=DDBLTFAST_NOCOLORKEY;
	recRect.left=0;
	recRect.top=0;
	recRect.right=i_recZone.right-i_recZone.left;
	recRect.bottom=i_recZone.bottom-i_recZone.top;
    while( 1 )
    {
        ddrval = lpSurface->BltFast( 0, 0, ip_Source, &i_recZone, DDBLTFAST_NOCOLORKEY);

        if( ddrval == DD_OK )
        {
            break;
        }
        if( ddrval == DDERR_SURFACELOST )
        {
			ddrval = ip_Source->Restore();
            if( ddrval != DD_OK )
            {
                return;
            }
			ddrval = lpSurface->Restore();
            if( ddrval != DD_OK )
            {
                return;
            }
        }
        if( ddrval != DDERR_WASSTILLDRAWING )
        {
            return;
        }
    }
#endif
}

#include "SDL.h"
void TC_RESBITMAP::SetSurfaceDXFromSDL(TP_DD ip_DD, SDL_Surface *ip_Source, T_RECT i_recZone, T_BOOL isTransparentKey/*=TRUE*/)
{
#ifdef USE_SDL
	SDL_Rect	dst;
	Uint32 flags;
	int width;
	int height;
	int depth;
	Uint32 Rmask=0;
	Uint32 Gmask=0;
	Uint32 Bmask=0;
	Uint32 Amask=0;

	// Allocation de la surface
	flags = SDL_SWSURFACE;
	depth = ip_Source->format->BitsPerPixel;
	width = ip_Source->w;
	height = ip_Source->h;
	//lpSurface = SDL_AllocSurface (flags, width, height, depth, Rmask, Gmask, Bmask, Amask);

	// Recopie de la surface
	dst.x = 0;
	dst.y = 0;
	dst.w = ip_Source->w;
	dst.h = ip_Source->h;

	//SDL_BlitSurface(ip_Source, NULL, lpSurface, NULL);
	
	//lpSurface = SDL_ConvertSurface(ip_Source, A_gAff.lpDDSBack->format, 0);
	lpSurface = SDL_DisplayFormat(ip_Source);

	//if (isTransparentKey) {
	//SDL_SetColorKey(fond, SDL_SRCCOLORKEY, *(Uint32 *)fond);
			SDL_SetColorKey(lpSurface, SDL_SRCCOLORKEY, 
				SDL_MapRGB(lpSurface->format, 255, 0, 255)
				//*(Uint32 *)(lpSurface->pixels)
				);
			//SDL_SetAlpha(lpSurface, SDL_SRCALPHA, 128);
	//}
	recRect.left=0;
	recRect.top=0;
	recRect.right=i_recZone.right-i_recZone.left;
	recRect.bottom=i_recZone.bottom-i_recZone.top;


#else

    DDSURFACEDESC       ddsd;
    HRESULT             ddrval;
	T_RECT DestRect={0,0,300,0} ;
	T_DWORD dwFlags=DDLOCK_WAIT;
	HRESULT ret,ret2;
	T_DWORD x,y;
	char *ptr_c_src;
	char *ptr_c_dst;
	WORD *ptr_w_src; // SDL
	WORD *ptr_w_dst; // DX
	int l_bpp;
	unsigned int l_x, l_y;
    SDL_Surface *lp_Source;
	SDL_PixelFormat l_fmt;


	//if (ip_Dest) FreeSurface();

	// Allocation de la surface
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT |DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    ddsd.dwWidth = i_recZone.right-i_recZone.left;
    ddsd.dwHeight = i_recZone.bottom-i_recZone.top;
    ddrval = ip_DD->CreateSurface( &ddsd, &lpSurface, NULL );
	if (ddrval != DD_OK) {
		return;
	}
	// set color Key, methode souple: recherche la couleur dans la palette.
	// 255.0.255 = violet
    DDSetColorKey(lpSurface, RGB(255,0,255));

	// set color Key, methode dure: donne la couleur en dur.
	// DDCOLORKEY          ddck;
	// ddck.dwColorSpaceLowValue = 0xff;
	// ddck.dwColorSpaceHighValue = 0xff;
	// lpSurface->SetColorKey( DDCKEY_SRCBLT, &ddck );





	// Recopie de l'image
	if (isTransparentKey)
		dwTrans=DDBLTFAST_SRCCOLORKEY;
	else
		dwTrans=DDBLTFAST_NOCOLORKEY;
	recRect.left=0;
	recRect.top=0;
	recRect.right=i_recZone.right-i_recZone.left;
	recRect.bottom=i_recZone.bottom-i_recZone.top;




	/*** Aff test d'acces direct ***/

    ddsd.dwSize = sizeof(ddsd);

    while ((ret2 = lpSurface->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;

	 
	// Conversion format SDL
	l_fmt.palette = NULL;
	l_fmt.BitsPerPixel = 16;
	l_fmt.BytesPerPixel = 2;
	l_fmt.Rmask = ddsd.ddpfPixelFormat.dwRBitMask; //0x00007C00;
	l_fmt.Gmask = ddsd.ddpfPixelFormat.dwGBitMask; //0x000003E0;
	l_fmt.Bmask = ddsd.ddpfPixelFormat.dwBBitMask; //0x0000001F;

	lp_Source = SDL_ConvertSurface(ip_Source, &l_fmt, SDL_SWSURFACE); 
	//lp_Source = SDL_DisplayFormat(ip_Source); 

		
		
	switch(ret2) {
	case DD_OK:
		// ddsd.dwHeight : Hauteur
		// ddsd.dwWidth  : Largeur
		// ddsd.lPitch   : distance mmoire entre deux lignes
		l_bpp = 2;
		ptr_c_src = (char *)(lp_Source->pixels);
		ptr_c_dst = (char *)(ddsd.lpSurface);

		for (x=0; x<(lp_Source->w); x++) {
			for (y=0; y<(lp_Source->h); y++) {
				// Pixel sur 16 bits
				ptr_w_src  = (WORD *)(ptr_c_src+(x*l_bpp)+(y*(lp_Source->pitch)));
				ptr_w_dst  = (WORD *)(ptr_c_dst+(x*l_bpp)+(y*(ddsd.lPitch)));


				(*ptr_w_dst) = (*ptr_w_src);
			}
		}

		break;
	case DDERR_INVALIDOBJECT :
		ret=DD_OK;
		break;
	case DDERR_INVALIDPARAMS: 
		ret=DD_OK;
		break;
	case DDERR_OUTOFMEMORY :
		ret=DD_OK;
		break;
	case DDERR_SURFACEBUSY: 
		ret=DD_OK;
		break;
	case DDERR_SURFACELOST:
		ret=DD_OK;
		break;
	case DDERR_WASSTILLDRAWING: 
		ret=DD_OK;
		break;
	default:
		ret=DD_OK;
		break;
	}
	lpSurface->Unlock(NULL);
	if (ret2==DD_OK) {
		ret=DD_OK;
	}
#endif
}


void TC_RESBITMAP::AffOffScreen(TP_DDSurface ip_Dest, int i_x, int i_y, T_RECT *ip_rectSrc, float i_scale, int i_scroll_x, int i_scroll_y)
{
	T_RECT		l_rectSrc;
	T_RECT		l_rectSrcScroll;
	T_RECT		l_rectDest;
#ifdef USE_SDL
	SDL_Rect	l_dst;
	SDL_Rect	l_src;
#else
    HRESULT     ddrval;
#endif

	// La surface est charge ?
	if (!lpSurface) {
		if (filePath[0]!=0)  {
			LoadBitmapFromWholeFile(&A_gAff, 0, filePath);
		}
	}
	if (!lpSurface) {
		return;
	}

	// Gestion des dbordements
	l_rectSrc.left   = ip_rectSrc->left;
	l_rectSrc.top    = ip_rectSrc->top;
	l_rectSrc.right  = ip_rectSrc->right;
	l_rectSrc.bottom = ip_rectSrc->bottom;

	if (i_x<0)	{
		l_rectSrc.left -=i_x;
		if (l_rectSrc.left>l_rectSrc.right) l_rectSrc.left=l_rectSrc.right;
		i_x=0;
	}
	if (i_x>640) i_x=640;
	if (i_x+(l_rectSrc.right-l_rectSrc.left)>640) {
		l_rectSrc.right= (640 -i_x) +l_rectSrc.left;
	}
	if (i_y<0)	 {
		l_rectSrc.top -=i_y;
		if (l_rectSrc.top>l_rectSrc.bottom) l_rectSrc.top=l_rectSrc.bottom;
		i_y=0;
	}
	if (i_y>480) i_y=480;
	if (i_y+(l_rectSrc.bottom-l_rectSrc.top)>480) {
		l_rectSrc.bottom= (480 -i_y) +l_rectSrc.top;
	}

	//
	// Gestion du scale
	//
	if (i_scale) {
		l_rectDest.left   = i_x;
		l_rectDest.top    = i_y;
		l_rectDest.right  = i_x+ (long)((ip_rectSrc->right-ip_rectSrc->left)*i_scale);
		l_rectDest.bottom = i_y+ (long)((ip_rectSrc->bottom-ip_rectSrc->top)*i_scale);
	}

	// Copy
    while( 1 )
    {
		// Si il faut dformer la surface  afficher
        if (i_scale) {
#ifdef USE_SDL
				l_dst.x = (short)l_rectDest.left;
				l_dst.y = (short)l_rectDest.top;
				l_dst.w = (short)(l_rectDest.right-l_rectDest.left);
				l_dst.h = (short)(l_rectDest.bottom-l_rectDest.top);
				l_src.x = (short)l_rectSrc.left;
				l_src.y = (short)l_rectSrc.top;
				l_src.w = (short)(l_rectSrc.right-l_rectSrc.left);
				l_src.h = (short)(l_rectSrc.bottom-l_rectSrc.top);
				SDL_Surface *l_srf;

				l_srf = sge_rotate_scaled_surface(lpSurface, 0, i_scale, 0);

				l_dst.x = (short)l_rectDest.left;
				l_dst.y = (short)l_rectDest.top;
				l_dst.w = (short)(l_srf->w);
				l_dst.h = (short)(l_srf->h);

				SDL_BlitSurface(l_srf, NULL, ip_Dest, &l_dst);
				SDL_FreeSurface(l_srf);
#else
				//ddrval = ip_Dest->Blt( &l_rectDest, lpSurface, &l_rectSrc, dwTrans, NULL);
				ddrval = ip_Dest->Blt( &l_rectDest, lpSurface, &l_rectSrc, DDBLT_KEYSRC , NULL);
#endif
		} else {
			// Si il faut grer du scrolling interne
			if (i_scroll_x||i_scroll_y) {
				i_scroll_x = (i_scroll_x%(l_rectSrc.right-l_rectSrc.left));
				i_scroll_y = (i_scroll_y%(l_rectSrc.bottom-l_rectSrc.top));
				l_rectSrcScroll.left   = l_rectSrc.left+i_scroll_x;
				l_rectSrcScroll.right  = l_rectSrc.right;
				l_rectSrcScroll.top    = l_rectSrc.top+i_scroll_y;
				l_rectSrcScroll.bottom = l_rectSrc.bottom;
#ifdef USE_SDL
				l_dst.x = (short)i_x;
				l_dst.y = (short)i_y;
				l_dst.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_dst.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				l_src.x = (short)l_rectSrcScroll.left;
				l_src.y = (short)l_rectSrcScroll.top;
				l_src.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_src.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				SDL_BlitSurface(lpSurface, &l_src, ip_Dest, &l_dst);
#else
				ddrval = ip_Dest->BltFast( i_x, i_y, lpSurface, &l_rectSrcScroll, dwTrans);
#endif
				l_rectSrcScroll.left   = l_rectSrc.left+i_scroll_x;
				l_rectSrcScroll.right  = l_rectSrc.right;
				l_rectSrcScroll.top    = l_rectSrc.top;
				l_rectSrcScroll.bottom = l_rectSrc.top+i_scroll_y;
#ifdef USE_SDL
				l_dst.x = (short)i_x;
				l_dst.y = (short)i_y+l_rectSrc.bottom-i_scroll_y;
				l_dst.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_dst.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				l_src.x = (short)l_rectSrcScroll.left;
				l_src.y = (short)l_rectSrcScroll.top;
				l_src.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_src.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				SDL_BlitSurface(lpSurface, &l_src, ip_Dest, &l_dst);
#else
				ddrval = ip_Dest->BltFast( i_x, i_y+l_rectSrc.bottom-i_scroll_y, lpSurface, &l_rectSrcScroll, dwTrans);
#endif
				l_rectSrcScroll.left   = l_rectSrc.left;
				l_rectSrcScroll.right  = l_rectSrc.left+i_scroll_x;
				l_rectSrcScroll.top    = l_rectSrc.top+i_scroll_y;
				l_rectSrcScroll.bottom = l_rectSrc.bottom;
#ifdef USE_SDL
				l_dst.x = (short)i_x+l_rectSrc.right-i_scroll_x;
				l_dst.y = (short)i_y;
				l_dst.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_dst.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				l_src.x = (short)l_rectSrcScroll.left;
				l_src.y = (short)l_rectSrcScroll.top;
				l_src.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_src.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				SDL_BlitSurface(lpSurface, &l_src, ip_Dest, &l_dst);
#else
				ddrval = ip_Dest->BltFast( i_x+l_rectSrc.right-i_scroll_x, i_y, lpSurface, &l_rectSrcScroll, dwTrans);
#endif
				l_rectSrcScroll.left   = l_rectSrc.left;
				l_rectSrcScroll.right  = l_rectSrc.left+i_scroll_x;
				l_rectSrcScroll.top    = l_rectSrc.top;
				l_rectSrcScroll.bottom = l_rectSrc.top+i_scroll_y;
#ifdef USE_SDL
				l_dst.x = (short)i_x+l_rectSrc.right-i_scroll_x;
				l_dst.y = (short)i_y+l_rectSrc.bottom-i_scroll_y;
				l_dst.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_dst.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				l_src.x = (short)l_rectSrcScroll.left;
				l_src.y = (short)l_rectSrcScroll.top;
				l_src.w = (short)(l_rectSrcScroll.right-l_rectSrcScroll.left);
				l_src.h = (short)(l_rectSrcScroll.bottom-l_rectSrcScroll.top);
				SDL_BlitSurface(lpSurface, &l_src, ip_Dest, &l_dst);
#else
				ddrval = ip_Dest->BltFast( i_x+l_rectSrc.right-i_scroll_x, i_y+l_rectSrc.bottom-i_scroll_y, lpSurface, &l_rectSrcScroll, dwTrans);
#endif
			} else {
			// Le cas simple, ou il suffit d'afficher en respectant le blit des bords
#ifdef USE_SDL
				l_dst.x = (short)i_x;
				l_dst.y = (short)i_y;
				l_dst.w = (short)(l_rectSrc.right-l_rectSrc.left);
				l_dst.h = (short)(l_rectSrc.bottom-l_rectSrc.top);

				l_src.x = (short)l_rectSrc.left;
				l_src.y = (short)l_rectSrc.top;
				l_src.w = (short)(l_rectSrc.right-l_rectSrc.left);
				l_src.h = (short)(l_rectSrc.bottom-l_rectSrc.top);
				//SDL_BlitSurface(lpSurface, &l_src, ip_Dest, &l_dst);
				//l_dst.x = 0;
				//l_dst.y = 0;
				//l_dst.w = lpSurface->w;
				//l_dst.h = lpSurface->h;
				//SDL_SetClipping(SDL_Surface *surface, int top, int left, int bottom, int right); 
				SDL_BlitSurface(lpSurface, &l_src, ip_Dest, &l_dst);
#else
				ddrval = ip_Dest->BltFast( i_x, i_y, lpSurface, &l_rectSrc, dwTrans);
#endif
			}
		}

#ifdef USE_SDL
		break;
#else
		if( ddrval == DD_OK )
        {
            break;
        }
        if( ddrval == DDERR_SURFACELOST )
        {
			ddrval = ip_Dest->Restore();
            if( ddrval != DD_OK )
            {
                return;
            }
			ddrval = lpSurface->Restore();
            if( ddrval != DD_OK )
            {
                return;
            }
        }
        if( ddrval != DDERR_WASSTILLDRAWING )
        {
            return;
        }
#endif
    }
    return;
}

void TC_RESBITMAP::AffOffScreen(TP_DDSurface ip_Dest, int i_x, int i_y, float i_scale, int i_scroll_x, int i_scroll_y)
{
	AffOffScreen( ip_Dest, i_x, i_y, &recRect, i_scale, i_scroll_x, i_scroll_y);
}


void TC_RESBITMAP::AffOffScreen(TP_DDSurface ip_Dest, T_POINT i_ptCoord, float i_scale, int i_scroll_x, int i_scroll_y)
{
	AffOffScreen(ip_Dest, i_ptCoord.x, i_ptCoord.y, &recRect, i_scale, i_scroll_x, i_scroll_y);
}


T_BOOL TC_RESBITMAP::SetBitmapFromWholeFile(int i_position, char *ip_filename)
{
	TPC_RESBITMAP	lp_resbitmap;

	// Position
	lp_resbitmap = this;
	while (i_position>0) {
		if (!(lp_resbitmap->pNext)) {
			lp_resbitmap->pNext = new (TC_RESBITMAP);
		}
		lp_resbitmap = lp_resbitmap->pNext;
		i_position--;
	}

	// lecture du fichier
	/* mmorise le path de la ressource */
	strcpy(lp_resbitmap->filePath, ip_filename);
	return T_TRUE;
}

#define SDL_LoadBMP_FromMem(ptr, size)	SDL_LoadBMP_RW(SDL_RWFromMem(ptr, size), 0)


T_BOOL TC_RESBITMAP::LoadBitmapFromWholeFile(TPC_DDRAW pdDraw, int i_position, char *ip_filename)
{
	int				iIsTransparentKey;
	T_BOOL			bIsTransparentKey=T_FALSE;
	T_RECT			rect;
	int				l_width, l_height;
	TPC_RESBITMAP	lp_resbitmap;
	char			*l_ptr;
	int				l_size;
	SDL_Surface		*lp_one;
	
	// Position
	lp_resbitmap = this;
	while (i_position>0) {
		if (!(lp_resbitmap->pNext)) {
			lp_resbitmap->pNext = new (TC_RESBITMAP);
		}
		lp_resbitmap = lp_resbitmap->pNext;
		i_position--;
	}

	// lecture du fichier
	/* mmorise le path de la ressource */
	strcpy(lp_resbitmap->filePath, ip_filename);

	iIsTransparentKey=1;
	if (iIsTransparentKey==1)
		bIsTransparentKey=T_TRUE;
	else
		bIsTransparentKey=T_FALSE;

	// On tente de charger l'immage du fichier de ressource global
	M_getPtrFromResFile(ip_filename, &l_ptr, &l_size);
	if (l_ptr) {
		lp_one = SDL_LoadBMP_FromMem(l_ptr, l_size);
	} else {
	// On tente avec un vrai fichier
		lp_one = SDL_LoadBMP(ip_filename);
	}
	if (!(lp_one)) {
		fprintf(stderr, "Pb chargement fichier [%s](%s)\n", ip_filename, SDL_GetError());
		return T_FALSE;
	}

		// Zone de l'image  rcuprer
	rect.left = 0;
	rect.right = lp_one->w;
	rect.top= 0 ;
	rect.bottom = lp_one->h;

#ifdef USE_SDL
	lp_resbitmap->SetSurface(pdDraw->lpDD, lp_one, rect,  bIsTransparentKey);
#else
	
	lp_resbitmap->SetSurfaceDXFromSDL(pdDraw->lpDD, lp_one, rect,  bIsTransparentKey);
#endif
	SDL_FreeSurface(lp_one);
	lp_one=NULL;
	return T_TRUE;

}


T_BOOL TC_RESBITMAP::LoadBitmapFromPartOfFile(TPC_DDRAW pdDraw, char *ip_filename)
{
	return T_TRUE;
}


void TC_RESBITMAP::SetTempo(int i_position, T_DWORD i_tempo)
{
	TPC_RESBITMAP	lp_resbitmap;

	// Position
	lp_resbitmap = this;
	while (i_position>0) {
		if (!(lp_resbitmap->pNext)) {
			lp_resbitmap->pNext = new (TC_RESBITMAP);
		}
		lp_resbitmap = lp_resbitmap->pNext;
		i_position--;
	}

	// Set
	lp_resbitmap->tempo = i_tempo;
}

// retourne le nombre de suivant
int TC_RESBITMAP::GetNbNext()
{
	TPC_RESBITMAP	lp_resbitmap;
    int l_ret;

    l_ret=0;
	// Position
	lp_resbitmap = this;
	while (lp_resbitmap =(lp_resbitmap->pNext)) {
        l_ret++;
	}
    return l_ret;
}

// retourne un pointeur sur le nime suivant
TPC_RESBITMAP TC_RESBITMAP::GetNNext(int i_n)
{
	TPC_RESBITMAP	lp_resbitmap;
    int l_cpt;

	// Position
    l_cpt = i_n;
	lp_resbitmap = this;
	while ((l_cpt>0) && (lp_resbitmap)) {
        lp_resbitmap =(lp_resbitmap->pNext);
        l_cpt--;
	}
    return lp_resbitmap;
}

int TC_RESBITMAP::AddNewResBitmapAtPosN(int i_n)
{
    TPC_RESBITMAP	lp_resbitmap_AvantN;
    TPC_RESBITMAP	lp_resbitmap_N;
    TPC_RESBITMAP	lp_resbitmap_New;

    if (i_n<=0) {return 1;} // On ne se supprime pas !!
    // Recuperation des pointeurs
    lp_resbitmap_AvantN = GetNNext(i_n-1);
    lp_resbitmap_N = lp_resbitmap_AvantN->pNext;
    // Creation
    lp_resbitmap_New = new TC_RESBITMAP();
    if (!lp_resbitmap_New) {return 2;} // Pb allocation
    lp_resbitmap_New->pNext = lp_resbitmap_N;
    lp_resbitmap_AvantN->pNext = lp_resbitmap_New;
    return 0;
}

int TC_RESBITMAP::DelResBitmapAtPosN(int i_n)
{
    TPC_RESBITMAP	lp_resbitmap_AvantN;
    TPC_RESBITMAP	lp_resbitmap_N;

    if (i_n<=0) {return 1;} // On ne se supprime pas !!
    // Recuperation des pointeurs
    lp_resbitmap_AvantN = GetNNext(i_n-1);
    if (!lp_resbitmap_AvantN) {return 1; } // Il en faut un avant !!
    lp_resbitmap_N = lp_resbitmap_AvantN->pNext; // Voila la victime...
    // Suppression
    lp_resbitmap_AvantN->pNext = lp_resbitmap_N->pNext;
    delete (lp_resbitmap_N);
    return 0;
}
