/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Ressources Bmp
 *
 *
 */

/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "R_ressources_bmp.h"



TC_RESBMP::TC_RESBMP()
{
#ifdef WIN32
	hmem_bmi = 0;
	hmem_bit = 0;
#endif
}

TC_RESBMP::~TC_RESBMP()
{
#ifdef WIN32
	if (hmem_bmi) GlobalFree(hmem_bmi);
	if (hmem_bit) GlobalFree(hmem_bit);
#endif
}

#ifdef WIN32

char TC_RESBMP::GetPixel(long i_x, long i_y)
{
	long	l_cpt;
	char	l_c;

	// Lock des pointeurs.
	lpbmi = (BITMAPINFO *)GlobalLock(hmem_bmi); 
	lpvBits = (char *)GlobalLock(hmem_bit); 
	
	// Recherche du point
	/***
	int x,y,l;
	unsigned char c;
	for (y=0; y<lpbmi->bmiHeader.biHeight; y++)
		for (x=0; x<lpbmi->bmiHeader.biWidth; x++) {
			l = (y*(lpbmi->bmiHeader.biWidth)) +x;
			c = *(lpvBits+ l);
		}
	***/
	l_cpt = i_x+(abs(lpbmi->bmiHeader.biHeight-i_y))*(lpbmi->bmiHeader.biWidth);
	if (lpvBits) {
		l_c = *(lpvBits+ l_cpt);
	} else  {
		l_c = 0;
	}

	// unlock des pointeurs.
	GlobalUnlock(hmem_bmi); 
	GlobalUnlock(hmem_bit); 

	return l_c;
}

BOOL TC_RESBMP::LoadBmpFromFile(char *ip_filename)
{
	HANDLE	hfbm;
	BITMAPFILEHEADER	bmfh;
	BITMAPINFOHEADER	bmih;
	T_DWORD	dwRead;

	if (!ip_filename) return T_FALSE;
	/* mmorise le path de la ressource */
	strcpy(filePath, ip_filename);

	/* Retrieve a handle identifying the file. */ 
	hfbm = CreateFile(ip_filename, GENERIC_READ, 
		FILE_SHARE_READ, (LPSECURITY_ATTRIBUTES) NULL, 
		OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, 
		(HANDLE) NULL); 

	/* Retrieve the BITMAPFILEHEADER structure. */ 

	ReadFile(hfbm, &bmfh, sizeof(BITMAPFILEHEADER), 
	 &dwRead, (LPOVERLAPPED)NULL); 

	/* Retrieve the BITMAPFILEHEADER structure. */ 

	ReadFile(hfbm, &bmih, sizeof(BITMAPINFOHEADER), 
	 &dwRead, (LPOVERLAPPED)NULL); 

	/* Allocate memory for the BITMAPINFO structure. */ 

	hmem_bmi = GlobalAlloc(GHND, 
	 sizeof(BITMAPINFOHEADER) + 
	 ((1<<bmih.biBitCount) * sizeof(RGBQUAD))); 

	lpbmi = (BITMAPINFO *)GlobalLock(hmem_bmi); 

	/* 
	* Load BITMAPINFOHEADER into the BITMAPINFO 
	* structure. 
	*/ 

	lpbmi->bmiHeader.biSize = bmih.biSize; 
	lpbmi->bmiHeader.biWidth = bmih.biWidth; 
	lpbmi->bmiHeader.biHeight = bmih.biHeight; 
	lpbmi->bmiHeader.biPlanes = bmih.biPlanes; 
	lpbmi->bmiHeader.biBitCount = bmih.biBitCount; 
	lpbmi->bmiHeader.biCompression = bmih.biCompression; 
	lpbmi->bmiHeader.biSizeImage = bmih.biSizeImage; 
	lpbmi->bmiHeader.biXPelsPerMeter = bmih.biXPelsPerMeter; 
	lpbmi->bmiHeader.biYPelsPerMeter = bmih.biYPelsPerMeter; 
	lpbmi->bmiHeader.biClrUsed = bmih.biClrUsed; 
	lpbmi->bmiHeader.biClrImportant = bmih.biClrImportant; 

	/* 
	* Retrieve the color table. 
	* 1 << bmih.biBitCount == 2 ^ bmih.biBitCount 
	*/ 

	ReadFile(hfbm, lpbmi->bmiColors, 
	 ((1<<bmih.biBitCount) * sizeof(RGBQUAD)), 
	 &dwRead, (LPOVERLAPPED) NULL); 

	/* 
	* Allocate memory for the required number of 
	* bytes. 
	*/ 

	hmem_bit = GlobalAlloc(GHND, 
	 (bmfh.bfSize - bmfh.bfOffBits)); 

	lpvBits = (char *)GlobalLock(hmem_bit); 

	/* Retrieve the bitmap data. */ 

	ReadFile(hfbm, lpvBits, 
	 (bmfh.bfSize - bmfh.bfOffBits), 
	 &dwRead, (LPOVERLAPPED) NULL); 

	/* 
	* Create a bitmap from the data stored in the 
	* .BMP file. 
	*/ 
/*
	hbm = CreateDIBitmap(hdc, &bmih, 
	 CBM_INIT, lpvBits, 
	 lpbmi, DIB_RGB_COLORS); 
*/
	/* 
	* Unlock the global memory objects and 
	* close the .BMP file. 
	*/ 

	GlobalUnlock(hmem_bmi); 
	GlobalUnlock(hmem_bit); 
	CloseHandle(hfbm); 
	return T_TRUE;
}


#endif