/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Ressources Text
 *
 *
 */
/****** Includes systmes ******/
#include <stdio.h>
#include <string.h>

/****** Includes applicatifs ******/
#include "R_ressources_text.h"

TE_lang	R_gLang = TE_english;//TE_francais;

void R_setLang(TE_lang i_lang)
{
	R_gLang = i_lang;
}

char*  TC_RESTEXT::GetText()
{
	char *lp_buf;

	if (R_gLang==TE_english) {
		lp_buf = textBufEng;
	} else {
		lp_buf = textBuf;
	}
	return lp_buf;
}

int  TC_RESTEXT::GetTextLen()
{
	int l_len;

	if (R_gLang==TE_english) {
		l_len = textLenEng;
	} else {
		l_len = textLen;
	}
	return l_len;
}


void TC_RESTEXT::SetText(char* ip_text)
{
	char l_buf;

	// Pointeur null !
	if (ip_text==NULL) {
		*textBuf=0;
		textLen=0;
		return;
	}

	// Trop long
	textLen =strlen(ip_text);
	if (textLen>=resTextLenMax) {
		textLen=(resTextLenMax-1);
		l_buf = *(ip_text+textLen);
		*(ip_text+textLen) = 0;
		strcpy(textBuf, ip_text);
		*(ip_text+textLen) = l_buf;
	}

	// Texte normal !!!!!
	strcpy(textBuf, ip_text);
}

void TC_RESTEXT::SetTextEng(char* ip_text)
{
	char l_buf;

	// Pointeur null !
	if (ip_text==NULL) {
		*textBufEng=0;
		textLenEng=0;
		return;
	}

	// Trop long
	textLenEng =strlen(ip_text);
	if (textLenEng>=resTextLenMax) {
		textLenEng=(resTextLenMax-1);
		l_buf = *(ip_text+textLenEng);
		*(ip_text+textLenEng) = 0;
		strcpy(textBufEng, ip_text);
		*(ip_text+textLenEng) = l_buf;
	}

	// Texte normal !!!!!
	strcpy(textBufEng, ip_text);
}



void TC_RESSON::SetFileName(char* ip_fileName)
{
    if (ip_fileName) {
        strcpy(fileName, ip_fileName);
    }
}
