/*
 *
 *  ==  Coconut ==
 *  2D Adventure Game Engine
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */

/*
 *
 *  Coconut
 *  Trace
 *
 *
 */
/****** Includes systmes ******/
#include <stdio.h>
#ifdef WIN32
#include <windows.h>
#endif
/****** Includes applicatifs ******/
#include "T_trace.h"

FILE *T_gFile=NULL;

void T_initTrace()
{
	T_gFile = fopen("\\coconut.tra","w");
}

void T_trace(char *filename, int line, int level, char *msg)
{
	if (T_gFile) {
		fprintf(T_gFile, "%s\n", msg);
	}
}

void T_closeTrace()
{
	if (T_gFile) {
		fclose(T_gFile);
	}
}

void T_traceFreeMem(char *ip_msg)
{
#ifdef WIN32
	MEMORYSTATUS	l_memStatus;

	if (T_gFile) {
		GlobalMemoryStatus(&l_memStatus);
		fprintf(T_gFile, "----> Bilan mmoire %s ---\n",ip_msg);
		fprintf(T_gFile, "MemoryLoad=%d%%\n",		l_memStatus.dwMemoryLoad);
		fprintf(T_gFile, "FreePhys      =%d / %d Mo\n",	l_memStatus.dwAvailPhys/(1024*1024), l_memStatus.dwTotalPhys/(1024*1024));
		fprintf(T_gFile, "FreePageFile  =%d / %d Mo\n",	l_memStatus.dwAvailPageFile/(1024*1024), l_memStatus.dwTotalPageFile/(1024*1024));
		fprintf(T_gFile, "FreeVirtual   =%d / %d Mo\n",	l_memStatus.dwAvailVirtual/(1024*1024), l_memStatus.dwTotalVirtual/(1024*1024));
	}
#endif
}
