
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>



extern "C" {
#include "callbacks.h"
#include "interface.h"
#include "support.h"
}


#include "M_scenes.h"
#include "O_objets.h"

extern GtkWidget *w_main;
extern GtkWidget *w_aff;
extern GtkWidget *w_about;
extern GtkWidget *w_layers;
extern GtkWidget *w_obj;
extern GtkWidget *w_scenes;

////////////////////////////////////////////////////
int g_obj_aff_scene_only=1; //0: All, 1:Scene active
void aff_obj_list()
{
	GtkCList *cl_obj;
	int l_cpt;
	gchar *l_tab[128];


	cl_obj = (GtkCList *)lookup_widget(w_obj, "cl_obj");

	if (cl_obj) {
		// freeze the list
		gtk_clist_freeze(cl_obj);
		// clear the list
		gtk_clist_clear(cl_obj);
		// Add and fill rows
		for (l_cpt=1; l_cpt<O_gNb_objets; l_cpt++) {
			if (  (O_gTab_Objets[l_cpt].isSceneName(cgb_scenes_current_get_name())) 
				|| (!g_obj_aff_scene_only))
			{
				l_tab[0] = (gchar *)&(O_gTab_Objets[l_cpt].name);
				gtk_clist_append( cl_obj, l_tab );
			}
		}

		// redraw the list
		gtk_clist_thaw(cl_obj);
	}
}


////////////////////////////////////////////////////
GtkWidget *file_selector;
void set_load_filename(GtkFileSelection *selector, gpointer user_data) 
{
	gchar *selected_filename;
    selected_filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector));
	printf("load name=[%s]\n", selected_filename);
	//if (NCC_set_bandwidth_data_from_file(selected_filename)) {
	//	w_aff_data();
	//}
}


void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    gtk_main_quit();
//    return(FALSE);
}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   /* Create the selector */
    
    file_selector = gtk_file_selection_new("Please select the file to open.");
    
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
                            "clicked", GTK_SIGNAL_FUNC (set_load_filename), NULL);
                            
    /* Ensure that the dialog box is destroyed when the user clicks a button. */
    
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector));

    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->cancel_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector));
    
    /* Display that dialog */  
    gtk_widget_show (file_selector);

}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_close1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_exit (0);
}


void
on_show_resources1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_show_objects1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_show_scene1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_add1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_delete1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cl_scenes_select_row                (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	GtkWidget* lp_name;
	GtkWidget* lp_scale;
	char l_buf[128];
	
	lp_name = lookup_widget(w_scenes, "e_scene_name");
	gtk_entry_set_text(GTK_ENTRY(lp_name), M_gTab_scene[row+1].name);

	lp_scale = lookup_widget(w_scenes, "e_scene_scale");
	sprintf(l_buf, "%1.2f", M_gTab_scene[row+1].scale_perso);
	gtk_entry_set_text(GTK_ENTRY(lp_scale), l_buf);

	cgb_scenes_current_set(M_gTab_scene[row+1].name);
	aff_obj_list();
}

void
on_cl_obj_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	GtkWidget* lp_name;
	GtkWidget* lp_scene;
	GtkWidget* lp_res_name;
	GtkWidget* lp_x;
	GtkWidget* lp_y;
	GtkWidget* lp_w;
	GtkWidget* lp_h;
	GtkWidget* lp_hot_x;
	GtkWidget* lp_hot_y;
	GtkWidget* lp_click;
	GtkWidget* lp_next_scene;
	GtkWidget* lp_next_point;
	GtkWidget* lp_drag;
	GtkWidget* lp_visible;
	GtkWidget* lp_dep;

	char l_buf[128];
	
	lp_name = lookup_widget(w_obj, "e_obj_name");
	gtk_entry_set_text(GTK_ENTRY(lp_name), O_gTab_Objets[row+1].name);

	lp_scene = lookup_widget(w_obj, "e_obj_scene");
	gtk_entry_set_text(GTK_ENTRY(lp_scene), O_gTab_Objets[row+1].SceneName);

	lp_res_name = lookup_widget(w_obj, "e_obj_res_name");
	gtk_entry_set_text(GTK_ENTRY(lp_res_name), O_gTab_Objets[row+1].ResAnimName);

	lp_x = lookup_widget(w_obj, "e_obj_x");
	sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptCoordInit.x);
	gtk_entry_set_text(GTK_ENTRY(lp_x), l_buf);

	lp_y = lookup_widget(w_obj, "e_obj_y");
	sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptCoordInit.y);
	gtk_entry_set_text(GTK_ENTRY(lp_y), l_buf);


	lp_w = lookup_widget(w_obj, "e_obj_w");
	sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptSize.x);
	gtk_entry_set_text(GTK_ENTRY(lp_w), l_buf);

	lp_h = lookup_widget(w_obj, "e_obj_h");
	sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptSize.y);
	gtk_entry_set_text(GTK_ENTRY(lp_h), l_buf);

	lp_hot_x = lookup_widget(w_obj, "e_obj_hot_x");
	sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptHotSpot.x);
	gtk_entry_set_text(GTK_ENTRY(lp_hot_x), l_buf);

	lp_hot_y = lookup_widget(w_obj, "e_obj_hot_y");
	sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptHotSpot.y);
	gtk_entry_set_text(GTK_ENTRY(lp_hot_y), l_buf);

	lp_click = lookup_widget(w_obj, "cb_obj_click");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_click), O_gTab_Objets[row+1].isClickable);

	lp_next_scene = lookup_widget(w_obj, "e_obj_next_scene");
	gtk_entry_set_text(GTK_ENTRY(lp_next_scene), O_gTab_Objets[row+1].SceneSuivanteName);

	lp_next_point = lookup_widget(w_obj, "e_obj_next_point");
	gtk_entry_set_text(GTK_ENTRY(lp_next_point), O_gTab_Objets[row+1].SceneSuivantePoint);

	lp_drag = lookup_widget(w_obj, "cb_obj_drag");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_drag), O_gTab_Objets[row+1].isDragAndDrop);

	lp_visible = lookup_widget(w_obj, "cb_obj_visible");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_visible), O_gTab_Objets[row+1].isAfficher);

	lp_dep = lookup_widget(w_obj, "cb_obj_dep");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_dep), O_gTab_Objets[row+1].is_ZoneDep);

	
}


void
on_rb_obj_scene_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(togglebutton))) {
		g_obj_aff_scene_only=1;
		aff_obj_list();
	}
}


void
on_rb_obj_all_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(togglebutton))) {
		g_obj_aff_scene_only=0;
		aff_obj_list();
	}

}



void
on_e_obj_aff_name_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
}


void
on_generate_h_header1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
}

