
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>



extern "C" {
#include "callbacks.h"
#include "interface.h"
#include "support.h"
}
#include "coco_ed_callbacks.h"


#include "M_scenes.h"
#include "O_objets.h"
#include "M_files.h"
#include "M_engine.h"


GtkWidget *w_main;

void show_main()
{
	if (!w_main) {
		w_main = create_w_main ();
	}
	gtk_widget_set_uposition(w_main, 1, 1);
	aff_main_list();
	gtk_widget_show (w_main);
}


void aff_main_list()
{
	GtkCList *cl_win;
	int l_cpt;
	gchar l_tab_name[4][64]= {
		"Project options",
		"Scenes",
		"Objects",
		"Resources" };
	gchar *l_tab[128];


	cl_win = (GtkCList *)lookup_widget(w_main, "cl_win");

	if (cl_win) {
		// freeze the list
		gtk_clist_freeze(cl_win);
		// clear the list
		gtk_clist_clear(cl_win);
		// Add and fill rows
		l_tab[0] = (gchar *)&(l_tab_name[0]);
		gtk_clist_append( cl_win, l_tab );
		l_tab[0] = (gchar *)&(l_tab_name[1]);
		gtk_clist_append( cl_win, l_tab );
		l_tab[0] = (gchar *)&(l_tab_name[2]);
		gtk_clist_append( cl_win, l_tab );
		l_tab[0] = (gchar *)&(l_tab_name[3]);
		gtk_clist_append( cl_win, l_tab );
		// redraw the list
		gtk_clist_thaw(cl_win);
	}
}

void
on_cl_win_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	switch(row) {
	case 0: show_project(); break;
	case 1: show_scene(); break;
	case 2: show_obj(); break;
	case 3: show_res(); break;
	default: break;
	}


}

////////////////////////////////////////////////////

////////////////////////////////////////////////
//
// Fcts
//
void main_new()
{
	M_project_new();
	show_scene();
	show_obj();
	show_res();

}

GtkWidget *file_selector;
void set_load_filename(GtkFileSelection *selector, gpointer user_data) 
{
	gchar *selected_filename;
    selected_filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector));
	printf("load name=[%s]\n", selected_filename);
	//if (NCC_set_bandwidth_data_from_file(selected_filename)) {
	//	w_aff_data();
	//}
	M_loadFile(selected_filename);
	show_scene();
	show_obj();
	show_res();

}

void main_open() 
{
   /* Create the selector */
    file_selector = gtk_file_selection_new("Please select the file to open.");
    gtk_file_selection_complete(GTK_FILE_SELECTION(file_selector), "*.dat");
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
                            "clicked", GTK_SIGNAL_FUNC (set_load_filename), NULL);
    /* Ensure that the dialog box is destroyed when the user clicks a button. */
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector));
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->cancel_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector));
    /* Display that dialog */  
    gtk_widget_show (file_selector);

}

void main_save()
{
	M_saveFile_current();
}

GtkWidget *file_selector_save;
void set_save_filename(GtkFileSelection *selector, gpointer user_data) 
{
	gchar *selected_filename;
    selected_filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector_save));
	printf("save name=[%s]\n", selected_filename);
	//if (NCC_set_bandwidth_data_from_file(selected_filename)) {
	//	w_aff_data();
	//}
	M_saveFile(selected_filename);

}


void main_save_as()
{
   /* Create the selector */   
    file_selector_save = gtk_file_selection_new("Please choose a the file name to save as.");   
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(file_selector_save)->ok_button),
                            "clicked", GTK_SIGNAL_FUNC (set_save_filename), NULL);
                            
    /* Ensure that the dialog box is destroyed when the user clicks a button. */ 
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector_save)->ok_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector_save));
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector_save)->cancel_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector_save)); 
    /* Display that dialog */  
    gtk_widget_show (file_selector_save);

}

void main_quit()
{
	gtk_exit (0);
}

void main_gen_h()
{
}

void main_gen_cre()
{
}

void main_run()
{
}

////////////////////////////////////////////////
//
// Menus
//

void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    main_new();
}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	main_open();
}

void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	main_save();
}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	main_save_as();
}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	main_quit();
}


void
on_show_project1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	show_project();
}


void
on_show_resources1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	show_res();

}


void
on_show_objects1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	show_obj();
}


void
on_show_scene1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	show_scene();
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	show_about();
}



void
on_generate_h_header1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	main_gen_h();

}


void
on_generate_cre_resource_file1_activate
                                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	main_gen_cre();
}


void
on_run_coconut1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    main_run();
}


////////////////////////////////////////////////
//
// Buttons
//
void
on_b_main_new_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
    main_new();
}


void
on_b_main_open_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	main_open();
}


void
on_b_main_save_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	main_save();
}


void
on_b_main_gen_h_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	main_gen_h();
}


void
on_b_main_gen_cre_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	main_gen_cre();
}

////////////////////////////////////////////////
//
// Windows
//
void
on_w_main_destroy                    (GtkObject       *object,
                                        gpointer         user_data)
{
    main_quit();
}


