
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>



extern "C" {
#include "callbacks.h"
#include "interface.h"
#include "support.h"
}
#include "coco_ed_callbacks.h"

#include "M_scenes.h"
#include "O_objets.h"
#include "M_engine.h"

GtkWidget *w_obj;
int g_obj_row=-1;
gchar g_obj_name[255]="";
int g_obj_update=0;


void show_obj()
{
	if (!w_obj) {
		w_obj = create_w_obj ();
	}
	gtk_widget_set_uposition(w_obj, 600, 1);
	aff_obj_list();
	gtk_widget_show (w_obj);
}

gchar *obj_get_current_name()
{
	GtkCList *cl_obj;
	gchar *lp_text;

	if (g_obj_row<0) {
		strcpy(g_obj_name,"");
	} else {
		cl_obj = (GtkCList *)lookup_widget(w_obj, "cl_obj");
		if (gtk_clist_get_text (cl_obj, g_obj_row, 0, &lp_text)) {
			strcpy(g_obj_name, lp_text);
		} else {
			strcpy(g_obj_name,"");
		}

	}
	return g_obj_name;
}

////////////////////////////////////////////////////
int g_obj_aff_scene_only=1; //0: All, 1:Scene active
void aff_obj_list()
{
	GtkCList *cl_obj;
	int l_cpt;
	gchar *l_tab[128];


	g_obj_update=1;
	cl_obj = (GtkCList *)lookup_widget(w_obj, "cl_obj");

	if (cl_obj) {
		// freeze the list
		gtk_clist_freeze(cl_obj);
		// clear the list
		gtk_clist_clear(cl_obj);
		// Add and fill rows
		for (l_cpt=1; l_cpt<O_gNb_objets; l_cpt++) {
			if (  (O_gTab_Objets[l_cpt].isSceneName(cgb_scenes_current_get_name())) 
				|| (!g_obj_aff_scene_only))
			{
				l_tab[0] = (gchar *)&(O_gTab_Objets[l_cpt].name);
				gtk_clist_append( cl_obj, l_tab );
				gtk_clist_set_row_data (cl_obj, l_cpt, (gchar *)&(O_gTab_Objets[l_cpt].name));
			}
		}

		// redraw the list
		gtk_clist_thaw(cl_obj);
	}
	g_obj_row=-1;
	g_obj_update=0;
}




void
on_cl_obj_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	GtkWidget* lp_name;
	GtkWidget* lp_scene;
	GtkWidget* lp_res_name;
	GtkWidget* lp_x;
	GtkWidget* lp_y;
	GtkWidget* lp_w;
	GtkWidget* lp_h;
	GtkWidget* lp_hot_x;
	GtkWidget* lp_hot_y;
	GtkWidget* lp_click;
	GtkWidget* lp_next_scene;
	GtkWidget* lp_next_point;
	GtkWidget* lp_drag;
	GtkWidget* lp_visible;
	GtkWidget* lp_dep;
	gchar *lp_text;
	char l_buf[128];
	int l_ret;

	g_obj_update=1;
	g_obj_row=row;
	l_ret = gtk_clist_get_text (clist, row, column, &lp_text);
	if (l_ret) {

		row = cgb_obj_get_index_by_name(lp_text)-1;

		lp_name = lookup_widget(w_obj, "e_obj_aff_name");
		gtk_entry_set_text(GTK_ENTRY(lp_name), O_gTab_Objets[row+1].affName);

		lp_scene = lookup_widget(w_obj, "e_obj_scene");
		gtk_entry_set_text(GTK_ENTRY(lp_scene), O_gTab_Objets[row+1].SceneName);

		lp_res_name = lookup_widget(w_obj, "e_obj_res_name");
		gtk_entry_set_text(GTK_ENTRY(lp_res_name), O_gTab_Objets[row+1].ResAnimName);

		lp_x = lookup_widget(w_obj, "e_obj_x");
		sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptCoordInit.x);
		gtk_entry_set_text(GTK_ENTRY(lp_x), l_buf);

		lp_y = lookup_widget(w_obj, "e_obj_y");
		sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptCoordInit.y);
		gtk_entry_set_text(GTK_ENTRY(lp_y), l_buf);


		lp_w = lookup_widget(w_obj, "e_obj_w");
		sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptSize.x);
		gtk_entry_set_text(GTK_ENTRY(lp_w), l_buf);

		lp_h = lookup_widget(w_obj, "e_obj_h");
		sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptSize.y);
		gtk_entry_set_text(GTK_ENTRY(lp_h), l_buf);

		lp_hot_x = lookup_widget(w_obj, "e_obj_hot_x");
		sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptHotSpot.x);
		gtk_entry_set_text(GTK_ENTRY(lp_hot_x), l_buf);

		lp_hot_y = lookup_widget(w_obj, "e_obj_hot_y");
		sprintf(l_buf, "%d", O_gTab_Objets[row+1].ptHotSpot.y);
		gtk_entry_set_text(GTK_ENTRY(lp_hot_y), l_buf);

		lp_click = lookup_widget(w_obj, "cb_obj_click");
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_click), O_gTab_Objets[row+1].isClickable);

		lp_next_scene = lookup_widget(w_obj, "e_obj_next_scene");
		gtk_entry_set_text(GTK_ENTRY(lp_next_scene), O_gTab_Objets[row+1].SceneSuivanteName);

		lp_next_point = lookup_widget(w_obj, "e_obj_next_point");
		gtk_entry_set_text(GTK_ENTRY(lp_next_point), O_gTab_Objets[row+1].SceneSuivantePoint);

		lp_drag = lookup_widget(w_obj, "cb_obj_drag");
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_drag), O_gTab_Objets[row+1].isDragAndDrop);

		lp_visible = lookup_widget(w_obj, "cb_obj_visible");
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_visible), O_gTab_Objets[row+1].isAfficher);

		lp_dep = lookup_widget(w_obj, "cb_obj_dep");
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lp_dep), O_gTab_Objets[row+1].is_ZoneDep);

		// select it in editor window
		cgb_obj_set_selected_name(O_gTab_Objets[row+1].name);
	}
	g_obj_update=0;
}

void
on_cl_obj_unselect_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

	g_obj_row=-1;
}

void
on_rb_obj_scene_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(togglebutton))) {
		g_obj_aff_scene_only=1;
		aff_obj_list();
	}
}


void
on_rb_obj_all_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(togglebutton))) {
		g_obj_aff_scene_only=0;
		aff_obj_list();
	}

}






////////////////////////////////////////////////
//
// Fcts
//
void obj_add_b_ok_handler(GtkFileSelection *selector, gpointer user_data) 
{
	GtkWidget* lp_e_add_name;
	gchar *lp_buf;
	TC_Object *lp_obj;
	gchar *lp_scene_name;

	lp_e_add_name = lookup_widget(w_action, "e_add_name");
	lp_buf = gtk_entry_get_text(GTK_ENTRY(lp_e_add_name));
	if ((!lp_buf)||(*lp_buf==0)) { return; }
	printf("Add obj %s\n", lp_buf);
	cgb_obj_add_default(lp_buf);
	// Set it in current scene
	lp_obj = cgb_obj_get_ptr_by_name(lp_buf);
	lp_scene_name = scene_get_current_name();
	printf("current scene=%s\n", lp_scene_name);
	if (lp_obj&&lp_scene_name) {
		lp_obj->SetSceneName(lp_scene_name);
	}
	aff_obj_list();
}

void obj_add()
{
	action_create_window("Enter a Name for the new Object", (void *)obj_add_b_ok_handler);
}

void obj_ren_b_ok_handler(GtkFileSelection *selector, gpointer user_data) 
{
	GtkWidget* lp_e_add_name;
	gchar *lp_buf;

	lp_e_add_name = lookup_widget(w_action, "e_add_name");
	lp_buf = gtk_entry_get_text(GTK_ENTRY(lp_e_add_name));
	if ((!lp_buf)||(*lp_buf==0)) { return; }
	printf("Ren obj %s\n", lp_buf);
	cgb_obj_ren(obj_get_current_name(), lp_buf);
	aff_obj_list();
}

void obj_ren()
{
	static gchar s_buf[255];
	GtkWidget* lp_cl_scenes;

	// Get selected scene
	if (g_obj_row<0) {
		return;
	}

	// Get new name
	action_create_window("Enter a new object Name", (void *)obj_ren_b_ok_handler);
}

void obj_del()
{
	char l_buf[255];

	// Get selected scene
	if (g_obj_row<0) {
		return;
	}
	
	strcpy(l_buf, obj_get_current_name());
	cgb_obj_del(l_buf);
	printf("Object %s deleted\n", l_buf);
	aff_obj_list();

}


////////////////////////////////////////////////
//
// Menus
//

void
on_add_object1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	obj_add();
}


void
on_rename_object1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	obj_ren();

}


void
on_delete_object1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	obj_del();
}


////////////////////////////////////////////////
//
// Buttons
//
void
on_b_obj_add_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	obj_add();
}


void
on_b_obj_ren_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	obj_ren();
}


void
on_b_obj_del_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	obj_del();
}

////////////////////////////////////////////////
//
// Editor feedback
//

void obj_clicked_in_editor(TE_ObjectId i_ObjetDebutClick)
{
	GtkCList *cl_obj;
	int l_cpt;
	int l_row;
	gchar *lp_text;

	cl_obj = (GtkCList *)lookup_widget(w_obj, "cl_obj");
	l_row=-1;
	l_cpt=0;
	while ((l_row<0)&&(gtk_clist_get_text (cl_obj, l_cpt, 0, &lp_text))) {
		if (strcmp(O_gTab_Objets[i_ObjetDebutClick].name, lp_text)==0) {
			l_row = l_cpt;
		}
		l_cpt++;
	}
	gtk_clist_select_row (cl_obj,l_row,0);
	gtk_clist_moveto (cl_obj,l_row,0, 0, 0);
}

////////////////////////////////////////////////
//
// A Value has been modified
//
void
obj_update_value ()
{
	GtkWidget* lp_name;
	GtkWidget* lp_scene;
	GtkWidget* lp_res_name;
	GtkWidget* lp_x;
	GtkWidget* lp_y;
	GtkWidget* lp_w;
	GtkWidget* lp_h;
	GtkWidget* lp_hot_x;
	GtkWidget* lp_hot_y;
	GtkWidget* lp_click;
	GtkWidget* lp_next_scene;
	GtkWidget* lp_next_point;
	GtkWidget* lp_drag;
	GtkWidget* lp_visible;
	GtkWidget* lp_dep;
	gchar *lp_text;
	char l_buf[128];
	int l_ret;
	TPC_Object lp_obj;

	/* Get object */
	if (!g_obj_update) {
		lp_obj = cgb_obj_get_ptr_by_name(obj_get_current_name());
		if (lp_obj) {

			lp_name = lookup_widget(w_obj, "e_obj_aff_name");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_name));
			strcpy(lp_obj->affName, lp_text);

			lp_scene = lookup_widget(w_obj, "e_obj_scene");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_scene));
			strcpy(lp_obj->SceneName, lp_text);

			lp_res_name = lookup_widget(w_obj, "e_obj_res_name");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_res_name));
			strcpy(lp_obj->ResAnimName, lp_text);

			lp_x = lookup_widget(w_obj, "e_obj_x");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_x));
			lp_obj->ptCoordInit.x = atoi(lp_text);

			lp_y = lookup_widget(w_obj, "e_obj_y");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_y));
			lp_obj->ptCoordInit.y = atoi(lp_text);

			lp_w = lookup_widget(w_obj, "e_obj_w");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_w));
			lp_obj->ptSize.x = atoi(lp_text);

			lp_h = lookup_widget(w_obj, "e_obj_h");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_h));
			lp_obj->ptSize.y = atoi(lp_text);

			lp_hot_x = lookup_widget(w_obj, "e_obj_hot_x");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_hot_x));
			lp_obj->ptHotSpot.x = atoi(lp_text);

			lp_hot_y = lookup_widget(w_obj, "e_obj_hot_y");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_hot_y));
			lp_obj->ptHotSpot.y = atoi(lp_text);

			lp_click = lookup_widget(w_obj, "cb_obj_click");
			lp_obj->isClickable = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(lp_click));
			

			lp_next_scene = lookup_widget(w_obj, "e_obj_next_scene");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_next_scene));
			strcpy(lp_obj->SceneSuivanteName, lp_text);

			lp_next_point = lookup_widget(w_obj, "e_obj_next_point");
			lp_text = gtk_entry_get_text(GTK_ENTRY(lp_next_point));
			strcpy(lp_obj->SceneSuivantePoint, lp_text);

			lp_drag = lookup_widget(w_obj, "cb_obj_drag");
			lp_obj->isDragAndDrop = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(lp_drag));

			lp_visible = lookup_widget(w_obj, "cb_obj_visible");
			lp_obj->isAfficher = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(lp_visible));

			lp_dep = lookup_widget(w_obj, "cb_obj_dep");
			lp_obj->is_ZoneDep = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(lp_dep));
		}
	}
}


void
on_e_obj_aff_name_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_scene_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_res_name_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	TPC_Object lp_obj;

	obj_update_value ();
	/* Get object, and force resource refresh */
	if (!g_obj_update) {
		lp_obj = cgb_obj_get_ptr_by_name(obj_get_current_name());
		if (lp_obj) {
			lp_obj->ptAnimCourante = NULL;
			lp_obj->PtImageAnimCourante = NULL;
		}
	}

}


void
on_e_obj_x_changed                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_y_changed                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_w_changed                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_h_changed                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_hot_x_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_hot_y_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_cb_obj_click_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_cb_obj_drag_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_cb_obj_visible_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_next_scene_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_e_obj_next_point_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_cb_obj_dep_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	obj_update_value ();

}


void
on_w_obj_destroy                    (GtkObject       *object,
                                        gpointer         user_data)
{
	w_obj = NULL;
}





