
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>



extern "C" {
#include "callbacks.h"
#include "interface.h"
#include "support.h"
}
#include "coco_ed_callbacks.h"


#include "R_ressources.h"
#include "O_objets.h"

GtkWidget *w_res;
int g_res_row=-1;
int g_res_row_anim=-1;
int g_res_update=0;
gchar g_res_name[255]="";
gchar g_res_name_anim[255]="";

void show_res()
{
	if (!w_res) {
		w_res = create_w_res ();
	}
	gtk_widget_set_uposition(w_res, 1, 300);
	aff_res_list();
	gtk_widget_show (w_res);
 
}

gchar *res_get_current_name()
{
	GtkCList *cl_res;
	gchar *lp_text;

	if (g_res_row<0) {
		strcpy(g_res_name,"");
	} else {
		cl_res = (GtkCList *)lookup_widget(w_res, "cl_res");
		if (gtk_clist_get_text (cl_res, g_res_row, 0, &lp_text)) {
			strcpy(g_res_name, lp_text);
		} else {
			strcpy(g_res_name,"");
		}

	}
	return g_res_name;
}


void aff_res_list()
{
	GtkCList *cl_res;
	int l_cpt;
	gchar *l_tab[128];

	g_res_update=1;
	cl_res = (GtkCList *)lookup_widget(w_res, "cl_res");

	if (cl_res) {
		// freeze the list
		gtk_clist_freeze(cl_res);
		// clear the list
		gtk_clist_clear(cl_res);
		// Add and fill rows
		for (l_cpt=1; l_cpt<R_gNb_res; l_cpt++) {
				l_tab[0] = (gchar *)&(R_gTab_res[l_cpt].name);
				gtk_clist_append( cl_res, l_tab );
		}

		// redraw the list
		gtk_clist_thaw(cl_res);
	}
	g_res_row=-1;
	g_res_update=0;
}

void aff_res_anim_list(int i_num)
{
	GtkCList *cl_res_anim;
	int l_cpt;
	gchar *l_tab[128];
	TC_RESBITMAP *lp_resbit;

	g_res_update=1;
	cl_res_anim = (GtkCList *)lookup_widget(w_res, "cl_res_anim");

	if (cl_res_anim) {
		// freeze the list
		gtk_clist_freeze(cl_res_anim);
		// clear the list
		gtk_clist_clear(cl_res_anim);
		// Add and fill rows
		lp_resbit = &(R_gTab_res[i_num].resAnim);
		while (lp_resbit) {
				l_tab[0] = (gchar *)&(lp_resbit->filePath);
				gtk_clist_append( cl_res_anim, l_tab );
				lp_resbit = lp_resbit->pNext;
		}

		// redraw the list
		gtk_clist_thaw(cl_res_anim);
	}
	g_res_update=0;

}

void
on_cl_res_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	GtkWidget* lp_om_res_type;
	GtkWidget* lp_nb_res;

	GtkWidget* lp_cl_res_anim;

	GtkWidget* lp_t_res_text_french;
	GtkWidget* lp_t_res_text_english;

	GtkWidget* lp_e_res_wav;

	char l_buf[128];
	int l_pos;

	g_res_update=1;
	lp_om_res_type = lookup_widget(w_res, "om_res_type");
	switch(R_gTab_res[row+1].type) {
	case 	ResType_Null: break;
	case 	ResType_Bmp: break;
	case 	ResType_AviCD: break;
	case 	ResType_Mid: break;
	case 	ResType_PisteCD: break;
	case 	ResType_Anim:
		gtk_option_menu_set_history (GTK_OPTION_MENU(lp_om_res_type), 0);
		break;
	case 	ResType_Wav: 
		gtk_option_menu_set_history (GTK_OPTION_MENU(lp_om_res_type), 2);
		break;

	case 	ResType_Text: 
		gtk_option_menu_set_history (GTK_OPTION_MENU(lp_om_res_type), 1);
		break;
	}
	aff_res_anim_list(row+1);

	lp_e_res_wav = lookup_widget(w_res, "e_res_wav");
	gtk_entry_set_text (GTK_ENTRY(lp_e_res_wav), R_gTab_res[row+1].resSon.fileName);

	lp_t_res_text_french = lookup_widget(w_res, "t_res_text_french");
	gtk_editable_delete_text(GTK_EDITABLE(lp_t_res_text_french), 0, -1);
	l_pos = 0;
	gtk_editable_insert_text(GTK_EDITABLE(lp_t_res_text_french), R_gTab_res[row+1].resText.textBuf,
		strlen(R_gTab_res[row+1].resText.textBuf), &l_pos);

	lp_t_res_text_english = lookup_widget(w_res, "t_res_text_english");
	gtk_editable_delete_text(GTK_EDITABLE(lp_t_res_text_english), 0, -1);
	l_pos = 0;
	gtk_editable_insert_text(GTK_EDITABLE(lp_t_res_text_english), R_gTab_res[row+1].resText.textBufEng,
		strlen(R_gTab_res[row+1].resText.textBufEng), &l_pos);

	g_res_row=row;
	g_res_update=0;
}

void
on_cl_res_unselect_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	g_res_row=-1;
}





////////////////////////////////////////////////
//
// Fcts
//
void res_add_b_ok_handler(GtkFileSelection *selector, gpointer user_data) 
{
	GtkWidget* lp_e_add_name;
	gchar *lp_buf;

	lp_e_add_name = lookup_widget(w_action, "e_add_name");
	lp_buf = gtk_entry_get_text(GTK_ENTRY(lp_e_add_name));
	if ((!lp_buf)||(*lp_buf==0)) { return; }
	printf("Add res %s\n", lp_buf);
	cgb_res_add(lp_buf, "");
	aff_res_list();
}

void res_add()
{
	action_create_window("Enter a Name for the new Resource", (void *)res_add_b_ok_handler);
}

void res_ren_b_ok_handler(GtkFileSelection *selector, gpointer user_data) 
{
	GtkWidget* lp_e_add_name;
	gchar *lp_buf;

	lp_e_add_name = lookup_widget(w_action, "e_add_name");
	lp_buf = gtk_entry_get_text(GTK_ENTRY(lp_e_add_name));
	if ((!lp_buf)||(*lp_buf==0)) { return; }
	printf("Ren res %s\n", lp_buf);
	cgb_res_ren(R_gTab_res[g_res_row+1].name, lp_buf);
	aff_res_list();
}

void res_ren()
{
	// Get selected scene
	if (g_res_row<0) {
		return;
	}

	// Get new name
	action_create_window("Enter a new resource Name", (void *)res_ren_b_ok_handler);
}

void res_del()
{
	char l_buf[255];

	// Get selected scene
	if (g_res_row<0) {
		return;
	}
	
	strcpy(l_buf, R_gTab_res[g_res_row+1].name);
	cgb_res_del(l_buf);
	printf("Resource %s deleted\n", l_buf);
	aff_res_list();

}



////////////////////////////////////////////////
//
// Menus
//
void
on_add_resource1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	res_add();
}


void
on_rename_resource1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	res_ren();

}


void
on_delete_resource1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	res_del();

}

////////////////////////////////////////////////
//
// Buttons
//

void
on_b_res_add_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	res_add();

}


void
on_b_res_ren_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	res_ren();

}


void
on_b_res_del_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	res_del();

}

////////////////////////////////////////////////
//
// Windows
//

void
on_w_res_destroy                    (GtkObject       *object,
                                        gpointer         user_data)
{
	w_res = NULL;
}


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///
//
// A Value has been modified
//
void
res_update_value ()
{
	GtkWidget* lp_om_res_type;
	GtkWidget* lp_nb_res;
	GtkWidget* lp_cl_res_anim;
	GtkWidget* lp_t_res_text_french;
	GtkWidget* lp_t_res_text_english;
	GtkWidget* lp_e_res_wav;
	char l_buf[128];
	int l_pos;
	TPC_Res lp_res;
	char *lp_text;

	/* Get resource */
	if (!g_res_update) {
		lp_res = cgb_res_get_ptr_by_name(res_get_current_name());
		if (lp_res) {
			lp_om_res_type = lookup_widget(w_res, "om_res_type");

			switch(gtk_option_menu_get_history (GTK_OPTION_MENU(lp_om_res_type))) { 
			case 0:
				lp_res->type = ResType_Anim;
				break;
			case 2: 
				lp_res->type = ResType_Wav;
				break;

			case 1: 
				lp_res->type = ResType_Text;
				break;
			default: 
				lp_res->type = ResType_Null;
				break;
			}

			lp_e_res_wav = lookup_widget(w_res, "e_res_wav");
			lp_text = gtk_entry_get_text (GTK_ENTRY(lp_e_res_wav));
			strncpy(lp_res->resSon.fileName, lp_text, resTextLenMax);


			lp_t_res_text_french = lookup_widget(w_res, "t_res_text_french");
			lp_text = gtk_editable_get_chars(GTK_EDITABLE(lp_t_res_text_french), 0, -1);
			strncpy(lp_res->resText.textBuf, lp_text, resTextLenMax);
			g_free(lp_text);

			lp_t_res_text_english = lookup_widget(w_res, "t_res_text_english");
			lp_text = gtk_editable_get_chars(GTK_EDITABLE(lp_t_res_text_english), 0, -1);
			strncpy(lp_res->resText.textBufEng, lp_text, resTextLenMax);
			g_free(lp_text);
		}
	}
}

void
on_om_res_type_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	res_update_value ();
}




void
on_t_res_text_french_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
	res_update_value ();
}


void
on_t_res_text_english_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
	res_update_value ();
}


void
on_e_res_wav_changed                   (GtkEditable     *editable,
                                        gpointer         user_data)
{
	res_update_value ();
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///
//
// Img File Management
//

void
on_cl_res_anim_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	int l_ret;
	GtkWidget* lp_e_res_anim_file;
	GtkWidget* lp_e_res_anim_tempo;
	int l_pos;
	TPC_Res lp_res;
	TPC_RESBITMAP lp_res_anim;
	char l_buf[64];

	g_res_update=1;
	g_res_row_anim=row;

	/* Get selected pos */
	l_pos = g_res_row_anim;

	/* Get resource ptr*/
	lp_res = cgb_res_get_ptr_by_name(res_get_current_name());
	if (lp_res) {
	    lp_res_anim =  lp_res->resAnim.GetNNext(l_pos);
	}

	if (lp_res_anim) {
		lp_e_res_anim_file = lookup_widget(w_res, "e_res_anim_file");
		gtk_entry_set_text (GTK_ENTRY(lp_e_res_anim_file), lp_res_anim->filePath);

		lp_e_res_anim_tempo = lookup_widget(w_res, "e_res_anim_tempo");
		sprintf(l_buf, "%d", lp_res_anim->tempo);
		gtk_entry_set_text (GTK_ENTRY(lp_e_res_anim_tempo), l_buf);
	}
	g_res_update=0;
}

void
on_cl_res_anim_unselect_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	g_res_row_anim=-1;
}


void
on_b_res_anim_add_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	int l_pos;
	TPC_Res lp_res;
	TPC_RESBITMAP lp_res_anim;
	char *lp_text;

	/* Get selected pos */
	l_pos = g_res_row_anim;
	if (l_pos<=0) { 
		l_pos=1; 
	} else {
		l_pos++;
	}

	/* Get resource ptr*/
	if (!g_res_update) {
		lp_res = cgb_res_get_ptr_by_name(res_get_current_name());
		if (lp_res) {
			/* Add image */
			lp_res->resAnim.AddNewResBitmapAtPosN(l_pos);
		    lp_res_anim =  lp_res->resAnim.GetNNext(l_pos);
			lp_res_anim->filePath[0]=0;
			cgb_obj_warning_resource_update(res_get_current_name());
			aff_res_anim_list(g_res_row+1);
		}
	}
}


void
on_b_res_anim_del_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	int l_pos;
	TPC_Res lp_res;
	TPC_RESBITMAP lp_res_anim;
	char *lp_text;

	/* Get selected pos */
	l_pos = g_res_row_anim;
	if (l_pos<=0) { return; }

	/* Get resource ptr*/
	if (!g_res_update) {
		lp_res = cgb_res_get_ptr_by_name(res_get_current_name());
		if (lp_res) {
			/* Add image */
			lp_res->resAnim.DelResBitmapAtPosN(l_pos);
			cgb_obj_warning_resource_update(res_get_current_name());
			aff_res_anim_list(g_res_row+1);
		}
	}
}


void
on_e_res_anim_file_changed             (GtkEditable     *editable,
                                        gpointer         user_data)
{
	int l_pos;
	TPC_Res lp_res;
	TPC_RESBITMAP lp_res_anim;
	GtkWidget* lp_e_res_anim_file;
	char *lp_text;

	/* Get selected pos */
	l_pos = g_res_row_anim;
	if (l_pos<0) { return; }

	/* Get resource ptr*/
	if (!g_res_update) {
		lp_res = cgb_res_get_ptr_by_name(res_get_current_name());
		if (lp_res) {
		    lp_res_anim =  lp_res->resAnim.GetNNext(l_pos);
			if (lp_res_anim) {
				lp_e_res_anim_file = lookup_widget(w_res, "e_res_anim_file");
				lp_text = gtk_entry_get_text (GTK_ENTRY(lp_e_res_anim_file));
				strncpy(lp_res_anim->filePath, lp_text, PATHLEN);
				cgb_obj_warning_resource_update(res_get_current_name());
				aff_res_anim_list(g_res_row+1);
			}
		}
	}
}


void
on_e_res_anim_tempo_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
	int l_pos;
	TPC_Res lp_res;
	TPC_RESBITMAP lp_res_anim;
	GtkWidget* lp_e_res_anim_file;
	char *lp_text;

	/* Get selected pos */
	l_pos = g_res_row_anim;
	if (l_pos<0) { return; }

	/* Get resource ptr*/
	if (!g_res_update) {
		lp_res = cgb_res_get_ptr_by_name(res_get_current_name());
		if (lp_res) {
		    lp_res_anim =  lp_res->resAnim.GetNNext(l_pos);
			if (lp_res_anim) {
				lp_e_res_anim_file = lookup_widget(w_res, "e_res_anim_file");
				lp_text = gtk_entry_get_text (GTK_ENTRY(lp_e_res_anim_file));
				lp_res_anim->tempo = atoi(lp_text);
			}
		}
	}

}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///
//
// Img File choice
//

GtkWidget *file_selector_img;
void res_set_select_filename(GtkFileSelection *selector, gpointer user_data) 
{
	gchar *selected_filename;
	GtkWidget* lp_e_res_anim_file;

    selected_filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector_img));
	printf("select name=[%s]\n", selected_filename);

	/* set name */
	lp_e_res_anim_file = lookup_widget(w_res, "e_res_anim_file");
	gtk_entry_set_text (GTK_ENTRY(lp_e_res_anim_file), selected_filename);
}

void res_anim_file_select() 
{
   /* Create the selector */
    file_selector_img = gtk_file_selection_new("Please select the image filename.");
    gtk_file_selection_complete(GTK_FILE_SELECTION(file_selector_img), "");
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(file_selector_img)->ok_button),
                            "clicked", GTK_SIGNAL_FUNC (res_set_select_filename), NULL);
    /* Ensure that the dialog box is destroyed when the user clicks a button. */
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector_img)->ok_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector_img));
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector_img)->cancel_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           GTK_OBJECT(file_selector_img));
    /* Display that dialog */  
    gtk_widget_show (file_selector_img);

}

void
on_b_res_anim_file_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	int l_pos;

	/* Get selected pos */
	l_pos = g_res_row_anim;
	if (l_pos<0) { return; }

	res_anim_file_select();
}

