
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>



extern "C" {
#include "callbacks.h"
#include "interface.h"
#include "support.h"
}
#include "coco_ed_callbacks.h"


#include "M_scenes.h"
#include "O_objets.h"
#include "M_engine.h"

GtkWidget *w_scenes=NULL;
int g_scene_row=-1;
gchar g_scene_name[255]="";


void show_scene()
{
	if (!w_scenes) {
		w_scenes = create_w_scenes ();
	}
	gtk_widget_set_uposition(w_scenes, 300, 1);
	aff_scene_list();
	gtk_widget_show (w_scenes);
}


gchar *scene_get_current_name()
{
	GtkCList *cl_scenes;
	gchar *lp_text;
	if (g_scene_row<0) {
		strcpy(g_scene_name,"");
	} else {
		cl_scenes = (GtkCList *)lookup_widget(w_scenes, "cl_scenes");
		if (gtk_clist_get_text (cl_scenes, g_scene_row, 0, &lp_text)) {
			strcpy(g_scene_name, lp_text);
		} else {
			strcpy(g_scene_name,"");
		}

	}
	return g_scene_name;
}

void aff_scene_list()
{
	GtkCList *cl_scenes;
	int l_cpt;
	gchar *l_tab[128];


	cl_scenes = (GtkCList *)lookup_widget(w_scenes, "cl_scenes");

	if (cl_scenes) {
		// freeze the list
		gtk_clist_freeze(cl_scenes);
		// clear the list
		gtk_clist_clear(cl_scenes);
		// Set header text
		//gtk_clist_set_column_title( cl_lab_to_spot, 0, "Label" );
		//for (l_cpt=0; l_cpt<M_gNb_scenes; l_cpt++) {
		//	sprintf(l_buf, "Spot %d", l_cpt);
		//	gtk_clist_set_column_title( cl_lab_to_spot, l_cpt+1, l_buf );
		//}
		//for (l_cpt=0; l_cpt<32; l_cpt++) { l_tab[l_cpt]=NULL; }

		// Add and fill rows
		for (l_cpt=1; l_cpt<M_gNb_scenes; l_cpt++) {
			l_tab[0] = (gchar *)&(M_gTab_scene[l_cpt].name);
			gtk_clist_append( cl_scenes, l_tab );
		}
		// redraw the list
		gtk_clist_thaw(cl_scenes);
	}
	g_scene_row=-1;
}



void
on_cl_scenes_select_row                (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	GtkWidget* lp_name;
	GtkWidget* lp_scale;
	char l_buf[128];
	
	lp_name = lookup_widget(w_scenes, "e_scene_name");
	gtk_entry_set_text(GTK_ENTRY(lp_name), M_gTab_scene[row+1].name);

	lp_scale = lookup_widget(w_scenes, "e_scene_scale");
	sprintf(l_buf, "%1.2f", M_gTab_scene[row+1].scale_perso);
	gtk_entry_set_text(GTK_ENTRY(lp_scale), l_buf);

	cgb_scenes_current_set(M_gTab_scene[row+1].name);
	aff_obj_list();
	g_scene_row = row;
}

void
on_cl_scenes_unselect_row                (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	g_scene_row = -1;
}

////////////////////////////////////////////////
//
// Fcts
//
void scene_add_b_ok_handler(GtkFileSelection *selector, gpointer user_data) 
{
	GtkWidget* lp_e_add_name;
	gchar *lp_buf;

	lp_e_add_name = lookup_widget(w_action, "e_add_name");
	lp_buf = gtk_entry_get_text(GTK_ENTRY(lp_e_add_name));
	if ((!lp_buf)||(*lp_buf==0)) { return; }
	printf("Add scene %s\n", lp_buf);
	cgb_scenes_add(lp_buf, 1.0);
	aff_scene_list();
}

void scene_add()
{
	action_create_window("Enter a Name for the new Scene", (void *)scene_add_b_ok_handler);
}

void scene_ren_b_ok_handler(GtkFileSelection *selector, gpointer user_data) 
{
	GtkWidget* lp_e_add_name;
	gchar *lp_buf;

	lp_e_add_name = lookup_widget(w_action, "e_add_name");
	lp_buf = gtk_entry_get_text(GTK_ENTRY(lp_e_add_name));
	if ((!lp_buf)||(*lp_buf==0)) { return; }
	printf("Ren scene %s\n", lp_buf);
	cgb_scenes_ren(M_gTab_scene[g_scene_row+1].name, lp_buf);
	aff_scene_list();
}

void scene_ren()
{
	static gchar s_buf[255];
	GtkWidget* lp_cl_scenes;

	// Get selected scene
	if (g_scene_row<0) {
		return;
	}

	// Get new name
	action_create_window("Enter a new scene Name", (void *)scene_ren_b_ok_handler);
}

void scene_del()
{
	char l_buf[255];

	// Get selected scene
	if (g_scene_row<0) {
		return;
	}
	
	strcpy(l_buf, M_gTab_scene[g_scene_row+1].name);
	cgb_scenes_del(l_buf);
	printf("Scene %s deleted\n", l_buf);
	aff_scene_list();

}



////////////////////////////////////////////////
//
// Menus
//
void
on_add_scene1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	scene_add();
}


void
on_rename_scene1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	scene_ren();
}


void
on_delete_scene1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	scene_del();
}

////////////////////////////////////////////////
//
// Buttons
//

void
on_b_scene_add_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	scene_add();
}


void
on_b_scene_ren_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	scene_ren();

}


void
on_b_scene_del_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	scene_del();
}


void
on_w_scenes_destroy                    (GtkObject       *object,
                                        gpointer         user_data)
{
	w_scenes = NULL;
}
