/*
 *
 *  ==  Coconut : "Welcome in the Coconut Island" ==
 *  2D Adventure Game Scenario
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */
/*
 *
 *  Coconut
 *  Dialogue biond_parachute
 *
 *
 */

/****** Includes systmes ******/
/****** Includes applicatifs ******/

#include "coco_res.h"
#include "O_objets.h"
#include "D_biond_parachute.h"
#include "M_engine.h"
#include "S_son.h"
#include "S_biond_parachute.h"



void D_biond_parachute_go()
{
		cgb_dialog_on();
		D_biond_parachute_1();
}

void D_biond_parachute_end()
{
	cgb_dialog_off();

}

/********************************/
void D_biond_parachute_1()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_1, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_1);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_1_1,C_Res_RS_D_biond_parachute_1_1,
					C_Res_RT_D_biond_parachute_1_2,C_Res_RS_D_biond_parachute_1_2,
					C_Res_RT_D_biond_parachute_1_3,C_Res_RS_D_biond_parachute_1_3,
					D_biond_parachute_1_rep);
}


void D_biond_parachute_1_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		D_biond_parachute_1();
		break;
	case Dialogue_3:
		D_biond_parachute_2();
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_2()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_2, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_2);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_2_1,C_Res_RS_D_biond_parachute_2_1,
					C_Res_RT_D_biond_parachute_2_2,C_Res_RS_D_biond_parachute_2_2,
					C_Res_RT_D_biond_parachute_2_3,C_Res_RS_D_biond_parachute_2_3,
					D_biond_parachute_2_rep);
}


void D_biond_parachute_2_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_3();
		break;
	case Dialogue_2:
		D_biond_parachute_4();
		break;
	case Dialogue_3:
		D_biond_parachute_5();
		break;
	default:
		break;
	}
}


/********************************/
void D_biond_parachute_3()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_3, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_3);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_3_1,C_Res_RS_D_biond_parachute_3_1,
					C_Res_RT_D_biond_parachute_3_2,C_Res_RS_D_biond_parachute_3_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_3_rep);
}


void D_biond_parachute_3_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_6();
		break;
	case Dialogue_2:
		D_biond_parachute_7();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_4()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_4, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_4);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_4_1,C_Res_RS_D_biond_parachute_4_1,
					C_Res_RT_D_biond_parachute_4_2,C_Res_RS_D_biond_parachute_4_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_4_rep);
}


void D_biond_parachute_4_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_8();
		break;
	case Dialogue_2:
		D_biond_parachute_9();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_5()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_5, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_5);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_5_1,C_Res_RS_D_biond_parachute_5_1,
					C_Res_RT_D_biond_parachute_5_2,C_Res_RS_D_biond_parachute_5_2,
					C_Res_RT_D_biond_parachute_5_3,C_Res_RS_D_biond_parachute_5_3,
					D_biond_parachute_5_rep);
}


void D_biond_parachute_5_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		D_biond_parachute_end();
		break;
	case Dialogue_3:
		D_biond_parachute_9();
		break;
	default:
		break;
	}
}


/********************************/
void D_biond_parachute_6()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_6, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_6);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_6_1,C_Res_RS_D_biond_parachute_6_1,
					C_Res_RT_D_biond_parachute_6_2,C_Res_RS_D_biond_parachute_6_2,
					C_Res_RT_D_biond_parachute_6_3,C_Res_RS_D_biond_parachute_6_3,
					D_biond_parachute_6_rep);
}


void D_biond_parachute_6_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_11();
		break;
	case Dialogue_2:
		D_biond_parachute_12();
		break;
	case Dialogue_3:
		D_biond_parachute_5();
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_7()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_7, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_7);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_7_1,C_Res_RS_D_biond_parachute_7_1,
					C_Res_RT_D_biond_parachute_7_2,C_Res_RS_D_biond_parachute_7_2,
					C_Res_RT_D_biond_parachute_7_3,C_Res_RS_D_biond_parachute_7_3,
					D_biond_parachute_7_rep);
}


void D_biond_parachute_7_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_5();
		break;
	case Dialogue_2:
		D_biond_parachute_14();
		break;
	case Dialogue_3:
		D_biond_parachute_end();
		break;
	default:
		break;
	}
}




/********************************/
void D_biond_parachute_8()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_8, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_8);
		M_process_for_n_sec( M_dialogue_temps_aff );
		// Si on a le matelas, on le propose
		if (cgb_obj_get_ptr_by_name(C_Objet_O_panneau_matelas)->isAfficher == T_TRUE) {
			M_gdialogue.dialogue_set( 
						C_Res_RT_D_biond_parachute_8_1,C_Res_RS_D_biond_parachute_8_1,
						C_Res_RT_D_biond_parachute_8_2,C_Res_RS_D_biond_parachute_8_2,
						C_Res_RT_D_biond_parachute_8_3,C_Res_RS_D_biond_parachute_8_3,
						D_biond_parachute_8_rep);
		} else {
			M_gdialogue.dialogue_set( 
						C_Res_RT_D_biond_parachute_8_1,C_Res_RS_D_biond_parachute_8_1,
						C_Res_RT_D_biond_parachute_8_2,C_Res_RS_D_biond_parachute_8_2,
						C_Res_RT_D_NULL,C_Res_RS_NULL,
						D_biond_parachute_8_rep);
		}
}


void D_biond_parachute_8_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_15();
		break;
	case Dialogue_2:
		D_biond_parachute_end();
		break;
	case Dialogue_3:
		D_biond_parachute_16();
		break;
	default:
		break;
	}
}


/********************************/
void D_biond_parachute_9()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_9, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_9);
		D_biond_parachute_end();
}


/********************************/
void D_biond_parachute_10()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_10, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_10);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_10_1,C_Res_RS_D_biond_parachute_10_1,
					C_Res_RT_D_biond_parachute_10_2,C_Res_RS_D_biond_parachute_10_2,
					C_Res_RT_D_biond_parachute_10_3,C_Res_RS_D_biond_parachute_10_3,
					D_biond_parachute_10_rep);
}


void D_biond_parachute_10_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		D_biond_parachute_17();
		break;
	case Dialogue_3:
		D_biond_parachute_18();
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_11()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_11, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_11);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_11_1,C_Res_RS_D_biond_parachute_11_1,
					C_Res_RT_D_biond_parachute_11_2,C_Res_RS_D_biond_parachute_11_2,
					C_Res_RT_D_biond_parachute_11_3,C_Res_RS_D_biond_parachute_11_3,
					D_biond_parachute_11_rep);
}


void D_biond_parachute_11_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_19();
		break;
	case Dialogue_2:
		D_biond_parachute_20();
		break;
	case Dialogue_3:
		D_biond_parachute_5();
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_12()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_12, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_12);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_12_1,C_Res_RS_D_biond_parachute_12_1,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_12_rep);
}


void D_biond_parachute_12_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}


/********************************/
void D_biond_parachute_14()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_14, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_14);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_14_1,C_Res_RS_D_biond_parachute_14_1,
					C_Res_RT_D_biond_parachute_14_2,C_Res_RS_D_biond_parachute_14_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_14_rep);
}


void D_biond_parachute_14_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_22();
		break;
	case Dialogue_2:
		D_biond_parachute_24();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_15()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_15, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_15);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_15_1,C_Res_RS_D_biond_parachute_15_1,
					C_Res_RT_D_biond_parachute_15_2,C_Res_RS_D_biond_parachute_15_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_15_rep);
}


void D_biond_parachute_15_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		D_biond_parachute_end();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_16()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_16, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_16);
		M_process_for_n_sec( M_dialogue_temps_aff );
		D_biond_parachute_end();
		M_biond_parachute_donne_matelas();
}


/********************************/
void D_biond_parachute_17()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_rdv_bar, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_rdv_bar);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_17_1,C_Res_RS_D_biond_parachute_17_1,
					C_Res_RT_D_biond_parachute_17_2,C_Res_RS_D_biond_parachute_17_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_17_rep);
}


void D_biond_parachute_17_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		D_biond_parachute_end();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_18()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_18, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_18);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_18_1,C_Res_RS_D_biond_parachute_18_1,
					C_Res_RT_D_biond_parachute_18_2,C_Res_RS_D_biond_parachute_18_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_18_rep);
}


void D_biond_parachute_18_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		D_biond_parachute_23();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_biond_parachute_19()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_19, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_19);
		D_biond_parachute_end();
}
/********************************/
void D_biond_parachute_20()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_20, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_20);
		D_biond_parachute_end();
}

/********************************/
void D_biond_parachute_22()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_22, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_22);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_22_1,C_Res_RS_D_biond_parachute_22_1,
					C_Res_RT_D_biond_parachute_22_2,C_Res_RS_D_biond_parachute_22_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_22_rep);
}


void D_biond_parachute_22_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_24();
		break;
	case Dialogue_2:
		D_biond_parachute_25();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}


/********************************/
void D_biond_parachute_23()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_23, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_23);
		M_process_for_n_sec( M_dialogue_temps_aff );
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_biond_parachute_23_1,C_Res_RS_D_biond_parachute_23_1,
					C_Res_RT_D_biond_parachute_23_2,C_Res_RS_D_biond_parachute_23_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_biond_parachute_23_rep);
}


void D_biond_parachute_23_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_biond_parachute_end();
		break;
	case Dialogue_2:
		D_biond_parachute_18();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}


/********************************/
void D_biond_parachute_24()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_24, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_24);
		D_biond_parachute_end();
}

/********************************/
void D_biond_parachute_25()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->AffText(
					C_Res_RT_D_biond_parachute_25, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_biond_parachute_25);
		D_biond_parachute_end();
}


