/*
 *
 *  ==  Coconut : "Welcome in the Coconut Island" ==
 *  2D Adventure Game Scenario
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */
/*
 *
 *  Coconut
 *  Dialogue texan
 *
 *
 */

/****** Includes systmes ******/
/****** Includes applicatifs ******/

#include "coco_res.h"
#include "O_objets.h"
#include "D_texan.h"
#include "M_engine.h"
#include "S_son.h"
#include "S_texan.h"



void D_texan_go()
{
		cgb_dialog_on();
		D_texan_1();
}

void D_texan_end()
{
	cgb_dialog_off();

}

/********************************/
void D_texan_1()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_1, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_1);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		if (cgb_obj_get_ptr_by_name(C_Objet_O_panneau_goutte_huile)->isAfficher) {
			M_gdialogue.dialogue_set( 
						C_Res_RT_D_texan_1_1,C_Res_RS_D_texan_1_1,
						C_Res_RT_D_texan_1_2,C_Res_RS_D_texan_1_2,
						C_Res_RT_D_texan_1_3b,C_Res_RS_D_texan_1_3b,
						D_texan_1_rep);

		} else {
			M_gdialogue.dialogue_set( 
						C_Res_RT_D_texan_1_1,C_Res_RS_D_texan_1_1,
						C_Res_RT_D_texan_1_2,C_Res_RS_D_texan_1_2,
						C_Res_RT_D_texan_1_3,C_Res_RS_D_texan_1_3,
						D_texan_1_rep);
		}
}

void D_texan_1_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_2();
		break;
	case Dialogue_2:
		D_texan_3();
		break;
	case Dialogue_3:
		if (cgb_obj_get_ptr_by_name(C_Objet_O_panneau_goutte_huile)->isAfficher) {
			D_texan_16();
		} else {
			D_texan_4();
		}
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_2()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_2, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_2);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_2_1,C_Res_RS_D_texan_2_1,
					C_Res_RT_D_texan_2_2,C_Res_RS_D_texan_2_2,
					C_Res_RT_D_texan_2_3,C_Res_RS_D_texan_2_3,
					D_texan_2_rep);
}


void D_texan_2_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_5();
		break;
	case Dialogue_2:
		D_texan_5();
		break;
	case Dialogue_3:
		D_texan_6();
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_3()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_3, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_3);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_3_1,C_Res_RS_D_texan_3_1,
					C_Res_RT_D_texan_3_2,C_Res_RS_D_texan_3_2,
					C_Res_RT_D_texan_3_3,C_Res_RS_D_texan_3_3,
					D_texan_3_rep);
}


void D_texan_3_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_7();
		break;
	case Dialogue_2:
		D_texan_8();
		break;
	case Dialogue_3:
		D_texan_end();
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_4()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_4, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_4);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_4_1,C_Res_RS_D_texan_4_1,
					C_Res_RT_D_texan_4_2,C_Res_RS_D_texan_4_2,
					C_Res_RT_D_texan_4_3,C_Res_RS_D_texan_4_3,
					D_texan_4_rep);
}


void D_texan_4_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_9();
		break;
	case Dialogue_2:
		D_texan_10();
		break;
	case Dialogue_3:
		D_texan_11();
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_5()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_5, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_5);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_5_1,C_Res_RS_D_texan_5_1,
					C_Res_RT_D_texan_5_2,C_Res_RS_D_texan_5_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_texan_5_rep);
}


void D_texan_5_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_12();
		break;
	case Dialogue_2:
		D_texan_13();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_6()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_6, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_6);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_6_1,C_Res_RS_D_texan_6_1,
					C_Res_RT_D_texan_6_2,C_Res_RS_D_texan_6_2,
					C_Res_RT_D_texan_6_3,C_Res_RS_D_texan_6_3,
					D_texan_6_rep);
}


void D_texan_6_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_14();
		break;
	case Dialogue_2:
		D_texan_13();
		break;
	case Dialogue_3:
		D_texan_7();
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_7()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_7, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_7);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_7_1,C_Res_RS_D_texan_7_1,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_texan_7_rep);
}


void D_texan_7_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_15();
		break;
	case Dialogue_2:
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}


/********************************/
void D_texan_8()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_8, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_8);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_8_1,C_Res_RS_D_texan_8_1,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_texan_8_rep);
}


void D_texan_8_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_end();
		break;
	case Dialogue_2:
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_9()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_9, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_9);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		D_texan_end();
}

/********************************/
void D_texan_10()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_10, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_10);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		D_texan_end();
}

/********************************/
void D_texan_11()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_11, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_11);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		D_texan_end();
}

/********************************/
void D_texan_12()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_12, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_12);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_12_1,C_Res_RS_D_texan_12_1,
					C_Res_RT_D_texan_12_2,C_Res_RS_D_texan_12_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_texan_12_rep);
}


void D_texan_12_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_13();
		break;
	case Dialogue_2:
		D_texan_13();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_13()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_13, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_13);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		D_texan_end();
}


/********************************/
void D_texan_14()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_14, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_14);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		D_texan_end();
}


/********************************/
void D_texan_15()
{
		cgb_dialog_on();
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_15, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_15);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_15_1,C_Res_RS_D_texan_15_1,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_texan_15_rep);
}


void D_texan_15_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_end();
		break;
	case Dialogue_2:
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}

/********************************/
void D_texan_16()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_16, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_16);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		M_gdialogue.dialogue_set( 
					C_Res_RT_D_texan_16_1,C_Res_RS_D_texan_16_1,
					C_Res_RT_D_texan_16_2,C_Res_RS_D_texan_16_2,
					C_Res_RT_D_NULL,C_Res_RS_NULL,
					D_texan_16_rep);
}


void D_texan_16_rep(TE_Dialogue i_choix)
{
	switch(i_choix) {
	case Dialogue_1:
		D_texan_13();
		break;
	case Dialogue_2:
		D_texan_17();
		break;
	case Dialogue_3:
		break;
	default:
		break;
	}
}


/********************************/
void D_texan_17()
{
		D_texan_end();
		M_texan_fonce_petrole();
}

/********************************/
void D_texan_18()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->AffText(
					C_Res_RT_D_texan_18, M_dialogue_temps_aff, T_TRUE);
		S_playWavFromRes(C_Res_RS_D_texan_18);
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan_parle);
		M_process_for_n_sec( M_dialogue_temps_aff );
		cgb_obj_get_ptr_by_name(C_Objet_O_texan)->SetAnimCourantebyName(C_Res_R_texan);
		D_texan_end();
}

