/*
 *
 *  ==  Coconut : "Welcome in the Coconut Island" ==
 *  2D Adventure Game Scenario
 *
 *  Copyright (C) 2000 Sebastien Josset
 *  sebastien.josset@free.fr
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 */
/*
 *
 *  Coconut
 *  Scenario
 *
 *
 */

/****** Includes systmes ******/
/****** Includes applicatifs ******/
#include "S_scenario.h"
#include "M_dep.h"
#include "A_text.h"
#include "A_aff.h"
#include "S_son.h"
#include "coco_res.h"
#include "M_engine.h"
#include "M_dialogue.h"
#include "O_panneau.h"
#include "D_sorcier.h"
#include "D_texan.h"
#include "S_texan.h"
#include "D_peone.h"
#include "D_biond_parachute.h"
#include "D_barman.h"
#include "S_biond_parachute.h"
#include "D_biond_bar.h"
#include "D_scout_biere.h"
#include "S_scout_biere.h"
#include "D_scout_WC.h"
#include "I_input.h"


/// Valeurs
typedef enum { E_voiture_parking, E_voiture_arbre, E_huile, E_derrick } TE_voiture;
TE_voiture l_etat_voiture = E_voiture_parking;

typedef enum { E_lift_num_1, E_lift_num_2, E_lift_num_3 } TE_lift_num;
TE_lift_num g_lift_num = E_lift_num_1;

int f_barman_donne_chambre=0;
int f_matelas_pris=0;
int f_tiroir_ouvert=0;
int f_tiroir_capote_pris=0;
int f_tiroir_playboy_pris=0;

void M_quitter();
void M_dialogue_1(TE_Dialogue i_choix);

void M_debug_tous_objets()
{
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_goutte_huile)->SetisAfficher(T_TRUE);

}

int S_initSceneName()
{
	M_setSceneName_Dialogue(C_Scene_S_Dialogue);
	M_setSceneName_Pannel(C_Scene_SceneId_Panneau);
	cgb_set_scene_depart_name(C_Scene_SceneId_Depart);
	cgb_set_scene_perso_name(C_Scene_SceneId_Perso);
	return 0;
}

int S_initResName()
{
	// Ressources cursor
	I_setResName_Mouse_Normal(C_Res_ResId_Mouse);
	I_setResName_Mouse_Clickable(C_Res_R_Mouse_Click);
	I_setResName_Mouse_Go(C_Res_RA_Mouse_Go);
	// Deplacement perso
	I_setResName_Dep_Attente(C_Res_ResId_DepAttente);
	I_setResName_Dep_Gauche(C_Res_ResId_DepGauche);
	I_setResName_Dep_Droit(C_Res_ResId_DepDroite);
	// Fonte
	A_setResName_Ascii(C_Res_ResId_Ascii);
	return 0;
}

int S_initObjName()
{
	// Cursor
	M_set_obj_mouse_name(C_Objet_ObjectId_Mouse);
	// Panneau
	M_setObjetName_PanneauDroit(C_Objet_O_Panneau_Droit);
	M_setObjetName_PanneauGauche(C_Objet_O_Panneau_Gauche);
	M_setObjetName_Panneau(C_Objet_ObjectId_Bureau_droit);
	M_setObjetName_Panneau_Aff1(C_Objet_O_paneau_select_1);
	M_setObjetName_Panneau_Aff2(C_Objet_O_paneau_select_2);
	M_setObjetName_Panneau_Aff3(C_Objet_O_paneau_select_3);

	// Perso
	M_set_obj_perso_name(C_Objet_ObjectId_Perso);

	return 0;
}

int S_onKeyPressed(TE_Key i_key)
{
        switch( i_key )
        {
        case TE_Key_F1:
			//M_loadFile(NULL);
			break;
        case TE_Key_F2:
			//M_saveFile(NULL);
			break;
        case TE_Key_F3:
			M_debug_tous_objets();
			break;
        case TE_Key_F4:
			cgb_scenes_current_set(C_Scene_SceneId_Hotel);
			S_onKeyPressed(TE_Key_F4);
			break;
        case TE_Key_F5:
			cgb_scenes_current_set(C_Scene_SceneId_Hall);
			S_onKeyPressed(TE_Key_F5);
			break;
        case TE_Key_F6:
			cgb_scenes_current_set(C_Scene_S_chambre);
			S_onKeyPressed(TE_Key_F6);
			break;
/*        case TE_Key_F7:
			cgb_scenes_current_set(SceneId_Derrick);
			break;
        case TE_Key_F8:
			cgb_scenes_current_set(SceneId_Treuil);
			break; 
*/
        case TE_Key_F7:
			break;
        case TE_Key_F8:
			break;
        case TE_Key_F11:
			/*
			if ((M_gScene_active-1)>SceneId_Null) {
				cgb_scenes_current_set((TE_SceneId)(M_gScene_active-1));
			}
			*/
			break;
        case TE_Key_F12:
			/*
			if ((M_gScene_active+1)<SceneIdMax) {
				cgb_scenes_current_set((TE_SceneId)(M_gScene_active+1));
			}
			*/
			break;
        case TE_Key_ESC:
			/* si on est en dialogue ou en demo, on sort du mode, sinon on quitte */
			if (cgb_dialog_is_on()) {
				cgb_dialog_off();
			} else {
				//PostMessage(hWnd, WM_CLOSE, 0, 0);
			}
            break;
        }	return 0;
}

void M_Action(TE_ObjectId i_Objet)
{
	TC_Object *l_obj;
	static int l_flag=1;

	/*** Changement de scenes ***/
	l_obj = &(O_gTab_Objets[i_Objet]);
	if (l_obj->isChgtScene()) {
		cgb_scenes_current_set(l_obj->SceneSuivanteName);
		if (strlen(l_obj->SceneSuivantePoint)!=0) {
			l_obj = cgb_obj_get_ptr_by_name(l_obj->SceneSuivantePoint);
			if ((l_obj->ptCoord.x!=0) && (l_obj->ptCoord.y!=0)) {
				cgb_obj_player_coord_set(l_obj->ptCoord.x, l_obj->ptCoord.y);
				cgb_obj_player_go_to(l_obj->ptCoord.x, l_obj->ptCoord.y);
			}
		}
		return;
	}

	//
	// Affichage des objets dans la liste 
	///
	if (l_obj->isName(C_Objet_O_Panneau_Gauche)) {
		if (O_gPanneau.premObjetAff>1) {
			O_gPanneau.premObjetAff--;
		}
	}
	if (l_obj->isName(C_Objet_O_Panneau_Droit)) {
		O_gPanneau.premObjetAff++;
	}

	//////////////////////////////////////////////// Debut des actions

	//
	// Quitter
	//
	if (l_obj->isName(C_Objet_Objet_Exit)) {
		M_quitter();
	}



	// On veut entrer dans la case
	if (l_obj->isName(C_Objet_O_village_vers_PC)) {
		cgb_obj_get_ptr_by_name(C_Objet_O_sorcier)->AffText(C_Res_RT_village_pas_entrer, M_dialogue_temps_aff, T_TRUE);
	}


	//
	// On tire la corde de l'ascenseur
	//
	// 1 : Balcon
	// 2 : Chambre (seulement si f_barman_donne_chambre==1)
	// 3 : Toit
	if (l_obj->isName(C_Objet_O_bar_corde)) {
		cgb_obj_get_ptr_by_name(C_Objet_O_bar_corde)->SetAnimCourantebyName(C_Res_R_lift_corde_tire);
		switch (g_lift_num) {
		case E_lift_num_3:
			cgb_obj_get_ptr_by_name(C_Objet_O_lift_num)->SetAnimCourantebyName(C_Res_R_lift_num_1);
			g_lift_num = E_lift_num_1;
			break;
		case E_lift_num_1:
			if (f_barman_donne_chambre==1) {
				cgb_obj_get_ptr_by_name(C_Objet_O_lift_num)->SetAnimCourantebyName(C_Res_R_lift_num_2);
				g_lift_num = E_lift_num_2;
			} else {
				cgb_obj_get_ptr_by_name(C_Objet_O_lift_num)->SetAnimCourantebyName(C_Res_R_lift_num_3);
				g_lift_num = E_lift_num_3;
			}
			break;
		case E_lift_num_2:
			cgb_obj_get_ptr_by_name(C_Objet_O_lift_num)->SetAnimCourantebyName(C_Res_R_lift_num_3);
			g_lift_num = E_lift_num_3;
			break;
		default:
			cgb_obj_get_ptr_by_name(C_Objet_O_lift_num)->SetAnimCourantebyName(C_Res_R_lift_num_1);
			g_lift_num = E_lift_num_1;
		}
		M_process_for_n_sec(1000);
		cgb_obj_get_ptr_by_name(C_Objet_O_bar_corde)->SetAnimCourantebyName(C_Res_R_lift_corde);

	}	

	//
	// On monte dans l'ascenseur
	//
	if (l_obj->isName(C_Objet_O_lift_fond_1)) {
		// On y va
		cgb_obj_player_go_to_process(C_Objet_O_pt_lift_1);
		// On passe en position 2
		cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_lift_2);
		cgb_obj_player_go_to_obj(C_Objet_O_pt_lift_2);
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_1)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_1)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_1)->SetisAfficher(T_FALSE);		

		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_2)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_2)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_2)->SetisAfficher(T_TRUE);						M_process_for_n_sec(1000);
		M_process_for_n_sec(300);

		// On passe en position 3
		cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_lift_3);
		cgb_obj_player_go_to_obj(C_Objet_O_pt_lift_3);
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_2)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_2)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_2)->SetisAfficher(T_FALSE);		

		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_3)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_3)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_3)->SetisAfficher(T_TRUE);		
		M_process_for_n_sec(300);

		// On change de scene
		// 1 : Balcon
		// 2 : Chambre (seulement si f_barman_donne_chambre==1)
		// 3 : Toit
		switch (g_lift_num) {
		case E_lift_num_1:
			cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_balcon_droit);
			cgb_obj_player_go_to_obj(C_Objet_O_pt_balcon_droit);
			cgb_scenes_current_set(C_Scene_S_balcon);
			break;
		case E_lift_num_2:
			cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_chambre_gauche);
			cgb_obj_player_go_to_obj(C_Objet_O_pt_chambre_gauche);
			cgb_scenes_current_set(C_Scene_S_chambre);
			break;
		case E_lift_num_3:
			cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_toit_porte);
			cgb_obj_player_go_to_obj(C_Objet_O_pt_toit_porte);
			cgb_scenes_current_set(C_Scene_SceneId_Toit);
			break;
		default:
			cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_toit_porte);
			cgb_obj_player_go_to_obj(C_Objet_O_pt_toit_porte);
			cgb_scenes_current_set(C_Scene_SceneId_Toit);
			break;
		}
	}

	//
	// On descend par l'ascenseur
	//
	if ((l_obj->isName(C_Objet_ObjectId_Toit_VersHall))) {
		// On y va
		cgb_obj_player_go_to_process(C_Objet_O_pt_toit_porte);
	}
	if ((l_obj->isName(C_Objet_O_chambre_vers_hall))) {
		// On y va
		cgb_obj_player_go_to_process(C_Objet_O_pt_chambre_porte);
	}
	if ((l_obj->isName(C_Objet_O_balcon_vers_hall))) {
		// On y va
		cgb_obj_player_go_to_process(C_Objet_O_pt_balcon_porte);
	}

	if (
		  (l_obj->isName(C_Objet_ObjectId_Toit_VersHall)) 
		||(l_obj->isName(C_Objet_O_chambre_vers_hall))
		||(l_obj->isName(C_Objet_O_balcon_vers_hall))
		) {

		// On change de scene
		cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_lift_3);
		cgb_obj_player_go_to_obj(C_Objet_O_pt_lift_3);
		cgb_scenes_current_set(C_Scene_SceneId_Hall);
		M_process_for_n_sec(300);

		// On passe en position 2
		cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_lift_2);
		cgb_obj_player_go_to_obj(C_Objet_O_pt_lift_2);
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_3)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_3)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_3)->SetisAfficher(T_FALSE);		

		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_2)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_2)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_2)->SetisAfficher(T_TRUE);						M_process_for_n_sec(1000);
		M_process_for_n_sec(300);

		// On passe en position 1
		cgb_obj_player_coord_cpy_by_name(C_Objet_O_pt_lift_1);
		cgb_obj_player_go_to_obj(C_Objet_O_pt_lift_1);
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_2)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_2)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_2)->SetisAfficher(T_FALSE);		

		cgb_obj_get_ptr_by_name(C_Objet_O_lift_arriere_1)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_fond_1)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_lift_avant_1)->SetisAfficher(T_TRUE);		

	}

	//
	// Recuperation des clefs
	//
	if (l_obj->isName(C_Objet_O_clef_voiture)) {
		cgb_obj_get_ptr_by_name(C_Objet_O_clef_voiture)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_clef_voiture)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_ObjectId_Perso)->AffText(C_Res_RT_TrouveClef, 2000, T_TRUE);

		//cgb_obj_get_ptr_by_name(C_Objet_O_panneau_anguilles)->SetisAfficher(T_TRUE);		
		//cgb_obj_get_ptr_by_name(C_Objet_O_panneau_canne)->SetisAfficher(T_TRUE);
	
	}
	

	//
	// Discussion avec le sorcier
	//
	if (l_obj->isName(C_Objet_O_sorcier)) {
		D_sorcier_go();
	}

	//
	// Discussion avec le parachutiste
	//
	if (l_obj->isName(C_Objet_O_parachutiste)) {
		D_biond_parachute_go();
	}

	//
	// Discussion avec le barman
	//
	if (l_obj->isName(C_Objet_O_bar_serveur)) {
		f_barman_donne_chambre=1;
		D_barman_go();
	}

	//
	// Discussion avec le viond dans le bar
	//
	if (l_obj->isName(C_Objet_O_bar_biond)) {
		D_biond_bar_go();
	}
	
	//
	// Discussion avec le peone de la piscine
	//
	if (l_obj->isName(C_Objet_O_peone_creuse)) {
		D_peone_go();
	}

	//
	// Discussion avec le scout du balcon
	//
	if (l_obj->isName(C_Objet_O_scout_balcon_wait)) {
		D_scout_biere_go();
	}

	//
	// Discussion avec le scout des WC
	//
	if (l_obj->isName(C_Objet_O_WC_scout)) {
		D_scout_WC_go();
	}

	//
	// On touche la voiture encastre
	//
	if (l_obj->isName(C_Objet_O_voiture_crash)) {
		if (l_flag) {
			S_playWavFromRes(C_Res_RS_Prout);
			l_flag=0;
		} else {
			S_playWavFromFile(C_Res_RS_Prout);
			l_flag=1;
		}
	}

	//
	// On prend le matelas
	//
	if (l_obj->isName(C_Objet_O_lit)) {
		if (f_matelas_pris==0) {
			cgb_obj_get_ptr_by_name(C_Objet_O_lit_sansMatelas)->SetisAfficher(T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_panneau_matelas)->SetisAfficher(T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_lit)->SetisAfficher(T_FALSE);
			f_matelas_pris=1;
		}
	}


	//
	// On ouvre/ferme le tiroir
	//
	if (l_obj->isName(C_Objet_O_tiroir_ferme)) {
		if (f_tiroir_ouvert==0) {
			cgb_obj_get_ptr_by_name(C_Objet_O_titroir_ouvert)->SetisAfficher(T_TRUE);
			if (f_tiroir_capote_pris==0) {
				cgb_obj_get_ptr_by_name(C_Objet_O_titroir_capote)->SetisAfficher(T_TRUE);
			}
			if (f_tiroir_playboy_pris==0) {
				cgb_obj_get_ptr_by_name(C_Objet_O_titroir_playboy)->SetisAfficher(T_TRUE);
			}
			f_tiroir_ouvert=1;
		} else {
			cgb_obj_get_ptr_by_name(C_Objet_O_titroir_ouvert)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_titroir_capote)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_titroir_playboy)->SetisAfficher(T_FALSE);
			f_tiroir_ouvert=0;
		}
	}

	// on prend les capoteq
	if (l_obj->isName(C_Objet_O_titroir_capote)) {
		f_tiroir_capote_pris=1;
		cgb_obj_get_ptr_by_name(C_Objet_O_titroir_capote)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_capote)->SetisAfficher(T_TRUE);
	}

	// on prend le playboy
	if (l_obj->isName(C_Objet_O_titroir_playboy)) {
		f_tiroir_playboy_pris=1;
		cgb_obj_get_ptr_by_name(C_Objet_O_titroir_playboy)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_playboy)->SetisAfficher(T_TRUE);
	}

	// on prend la lampe torche
	if (l_obj->isName(C_Objet_O_lampePoche)) {
		cgb_obj_get_ptr_by_name(C_Objet_O_lampePoche)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_lampePoche)->SetisAfficher(T_TRUE);
		// Du coup Biond se vautre dans l'arbre
		cgb_obj_get_ptr_by_name(C_Objet_O_parachutiste)->SetisAfficher(T_TRUE);
	}

	//
	// Robinson
	//
	if (l_obj->isName(C_Objet_O_robinson)) {
			// discours normal
			S_playWavFromRes(C_Res_RS_boujour_voiture);
			l_obj->AffText(C_Res_RT_Hello, 2000, T_TRUE);

	}

	//
	// On touche la tache d'huile
	//
	if (l_obj->isName(C_Objet_O_tache_huile)) {
		cgb_obj_get_ptr_by_name(C_Objet_ObjectId_Perso)->AffText(C_Res_RT_DeLHuile, 2000, T_TRUE);
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_goutte_huile)->SetisAfficher(T_TRUE);

	}

	//
	// On touche la roue
	//
	if (l_obj->isName(C_Objet_O_boulon)) {
		cgb_obj_get_ptr_by_name(C_Objet_O_pannel_boulon)->SetisAfficher(T_TRUE);
		cgb_obj_get_ptr_by_name(C_Objet_O_boulon)->SetisAfficher(T_FALSE);

	}

	//
	// Le texan
	//
	if (l_obj->isName(C_Objet_O_texan)) {
		/*
		if (l_etat_voiture == E_huile) {
			// Du ptrole ?
			S_playWavFromRes(C_Res_RS_DuPetrole);
			l_obj->AffText(C_Res_RT_DuPetrole, 2000, T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_tache_huile)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_derrick)->SetisAfficher(T_TRUE);
			l_etat_voiture = E_derrick;
		} else {
			// discours normal
			S_playWavFromRes(C_Res_RS_hello_petrole);
			l_obj->AffText(C_Res_RT_Hello, 2000, T_TRUE);
		}
		*/
		D_texan_go();
	}

	//
	// On touche le derrick
	//
	if (l_obj->isName(C_Objet_O_derrick)) {
		gcd_aff_shake();
	}


	//
	// Le beau militaire barre le passage
	//
	if ( (l_obj->isName(C_Objet_O_garde))) {
		S_playWavFromRes(C_Res_RS_PassePas);
		l_obj->AffText(C_Res_RT_OnPassePas, 2000, T_TRUE);
		cgb_dialog_on();
		M_gdialogue.dialogue_set( C_Res_RT_Hello, C_Res_RS_Hello,
						C_Res_RT_Hello, C_Res_RS_Hello,
						C_Res_RT_Hello, C_Res_RS_Hello,
						M_dialogue_1);
	}

	//
	// On veut entrer dans l'atelier
	//
	if (l_obj->isName(C_Objet_ObjectId_Treuil_VersAtelier)) {
		S_playWavFromRes(C_Res_RS_PassePas);
		cgb_obj_get_ptr_by_name(C_Objet_O_garde)->AffText(C_Res_RT_OnPassePas, 2000, T_TRUE);
	}

	//
	// On pique les poissons
	//
	if (l_obj->isName(C_Objet_O_seau)) {
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_anguilles)->SetisAfficher(T_TRUE);		
	}


}

void M_UtiliseSur(TE_ObjectId i_ObjetUtil, TE_ObjectId i_ObjetSur)
{
	TC_Object *l_objUtil;
	TC_Object *l_objSur;


	/*** Recuperation des pointeurs ***/
	l_objUtil = &(O_gTab_Objets[i_ObjetUtil]);
	l_objSur = &(O_gTab_Objets[i_ObjetSur]);

	//
	// Demarrer la voiture
	//
	if (  (l_objUtil->isName(C_Objet_O_panneau_clef_voiture)) 
		&&(l_objSur->isName(C_Objet_O_voiture_arret)) ) {
		// La voiture dmarre
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_clef_voiture)->SetisAfficher(T_FALSE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_voiture_arret)->ptVit.x = 10;
		// Pause de 5 seconde
		M_process_for_n_sec(2000);
		// Et elle s'eclate
		gcd_aff_shake();
		S_playWavFromFile(C_Res_RS_explosion);
		cgb_obj_get_ptr_by_name(C_Objet_O_voiture_arret)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_voiture_crash)->SetisAfficher(T_TRUE);
		cgb_obj_get_ptr_by_name(C_Objet_O_tonneau_arbre)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_tonneau_flotte)->SetisAfficher(T_TRUE);
		cgb_obj_get_ptr_by_name(C_Objet_O_boulon)->SetisAfficher(T_TRUE);
		l_etat_voiture = E_voiture_arbre;
	}

	//
	// On donne la roue a robinson
	//
	if (  (l_objUtil->isName(C_Objet_O_pannel_boulon)) 
		&&(l_objSur->isName(C_Objet_O_robinson)) ) {
		// il est content
		l_objSur->AffText(C_Res_RT_UneVoiture, 2000, T_TRUE);
		S_playWavFromRes(C_Res_RS_UneVoiture);
		M_process_for_n_sec( 2000 );

		// il s'en va
		cgb_obj_get_ptr_by_name(C_Objet_O_robinson)->SetPointDest(C_Objet_O_pt_feu_droit, 1500);
		cgb_obj_get_ptr_by_name(C_Objet_O_robinson)->SetAnimCourantebyName(C_Res_R_robinson_marche);
		M_process_for_n_sec( 1500 );
		cgb_obj_get_ptr_by_name(C_Objet_O_robinson)->SetisAfficher(T_FALSE);

		// on a gagn des trucs
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_canne)->SetisAfficher(T_TRUE);
		cgb_obj_get_ptr_by_name(C_Objet_O_voiture_crash)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_tache_huile)->SetisAfficher(T_TRUE);
		l_etat_voiture = E_huile;
	}

	//
	// On donne la canne a peche au garde
	//
	if (  (l_objUtil->isName(C_Objet_O_panneau_canne)) 
		&&(l_objSur->isName(C_Objet_O_garde)) ) {
		cgb_obj_get_ptr_by_name(C_Objet_O_garde)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_panneau_canne)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_pecheur)->SetisAfficher(T_TRUE);		
		cgb_obj_get_ptr_by_name(C_Objet_O_seau)->SetisAfficher(T_TRUE);
		cgb_obj_get_ptr_by_name(C_Objet_ObjectId_Treuil_VersAtelier)->SetSceneSuivanteName(C_Scene_SceneId_Atelier);
	}

	//
	// On donne le matelas a Biond
	//
	if (  (l_objUtil->isName(C_Objet_O_panneau_matelas)) 
		&&(l_objSur->isName(C_Objet_O_parachutiste)) ) {
		M_biond_parachute_donne_matelas();
	}

	//
	// On donne la goutte d'huile au texan
	//
	if (  (l_objUtil->isName(C_Objet_O_panneau_goutte_huile)) 
		&&(l_objSur->isName(C_Objet_O_texan)) ) {
		cgb_obj_get_ptr_by_name(C_Objet_O_tache_huile)->SetisAfficher(T_FALSE);
		M_texan_fonce_petrole();
	}

	//
	// On donne la biere au scout 
	//
	if (  (l_objUtil->isName(C_Objet_O_panneau_biere_plein)) 
		&&(l_objSur->isName(C_Objet_O_scout_balcon_wait)) ) {
		M_scout_biere_boit_biere();
	}

	//
	// On donne le playboy au scout qui pisse
	//
	if (  (l_objUtil->isName(C_Objet_O_panneau_playboy)) 
		&&(l_objSur->isName(C_Objet_O_scout_balcon_pisse)) ) {
		cgb_obj_get_ptr_by_name(C_Objet_O_scout_balcon_pisse)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_scout_balcon_pisse_loin)->SetisAfficher(T_TRUE);
		cgb_obj_get_ptr_by_name(C_Objet_O_piscine_vide)->SetisAfficher(T_FALSE);
		cgb_obj_get_ptr_by_name(C_Objet_O_piscine_pleine)->SetisAfficher(T_TRUE);
	}

}



//
// Prciser anim sur in et sur out
//
void M_MouseMoveIn(TE_ObjectId i_Objet)
{
	TC_Object *l_obj;
	TPC_Res  lp_res;
	
	l_obj = &(O_gTab_Objets[i_Objet]);
	if (l_obj->isName(C_Objet_ObjectId_Truc2)) {
		lp_res = cgb_res_get_ptr_by_name(C_Res_ResId_Poubelle_over);
		l_obj->ptAnimCourante = &(lp_res->resAnim);
	}
}


void M_MouseMoveOut(TE_ObjectId i_Objet)
{
	TC_Object *l_obj;
	TPC_Res  lp_res;

	l_obj = &(O_gTab_Objets[i_Objet]);
	if (l_obj->isName(C_Objet_ObjectId_Truc2)) {
		lp_res = cgb_res_get_ptr_by_name(C_Res_ResId_Poubelle);
		l_obj->ptAnimCourante = &(lp_res->resAnim);
	}
}


//
// Dialogues
//

void M_dialogue_1(TE_Dialogue i_choix)
{
	cgb_dialog_off();
}

//
// Scenes
//

void M_enterScene(char *ip_scene)
{

	if (strcmp(ip_scene, C_Scene_S_Demo)==0) {
		gcd_aff_mouse_off();
		gcd_aff_player_off();
		S_playCD(0);

			cgb_obj_get_ptr_by_name(C_Objet_O_prof)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_ile)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_kourou)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_martien)->SetisAfficher(T_FALSE);

		// On place le decors, le Gver entre
		S_playWavFromRes(C_Res_RS_Demo_intro);
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_Fver)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_ile)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_periscope)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_cuvette_WC)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_fusee)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->Reinit();
		cgb_obj_get_ptr_by_name(C_Objet_O_sable)->ptVitScroll.x = 4;
		cgb_obj_get_ptr_by_name(C_Objet_O_periscope)->ptVit.x = -1;

		//cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->ptVit.x = 3;
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetPointDest(C_Objet_O_Demo_Pt_1, 6000);



		//cgb_obj_get_ptr_by_name(C_Objet_O_ile)->ptVit.x = -1;
	if (M_process_for_n_sec(3000)) ;


		// On laisse les deux vers approcher
		//cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->ptVit.x = -2;
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->SetPointDest(C_Objet_O_Demo_Pt_2, 50,0, 3000);
		//cgb_obj_get_ptr_by_name(C_Objet_O_Fver)->ptVit.x = -2;
		cgb_obj_get_ptr_by_name(C_Objet_O_Fver)->SetPointDest(C_Objet_O_Demo_Pt_2, 3000);
	M_process_for_n_sec(3000);
//return;
		// On laisse le ver approcher
		S_playWavFromRes(C_Res_RS_laser);
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetResAnimName(C_Res_R_Gver_coeur);
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetPointDest(C_Objet_O_Demo_Pt_2, -50,0, 2400);
	M_process_for_n_sec(1400);


		// La lunette part
		S_playWavFromRes(C_Res_RS_boing);
		cgb_obj_get_ptr_by_name(C_Objet_O_cuvette_WC)->ptVit.y = -6;
		cgb_obj_get_ptr_by_name(C_Objet_O_cuvette_WC)->ptVit.x = -3;
		cgb_obj_get_ptr_by_name(C_Objet_O_cuvette_WC)->SetisAfficher(T_TRUE);	
	M_process_for_n_sec(1000);

		// On laisse le ver approcher
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetResAnimName(C_Res_R_Gver_bizou);
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetPointDest(C_Objet_O_Demo_Pt_2, 0,0, 500);
	M_process_for_n_sec(500);

		// Smack
		S_playWavFromRes(C_Res_RS_smack);
		cgb_obj_get_ptr_by_name(C_Objet_O_Fver)->SetResAnimName(C_Res_R_Fver_surprise);
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->AffText(C_Res_RT_bizou, 500, T_TRUE);
		//cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->ptVit.x = 2;
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetPointDest(C_Objet_O_Demo_Pt_3, 100);
	M_process_for_n_sec(750);


		// Apres Smack
		cgb_obj_get_ptr_by_name(C_Objet_O_Fver)->SetResAnimName(C_Res_R_Fver_heureuse);
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetResAnimName(C_Res_R_Gver_vole);
		//cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->ptVit.x = 6;
	M_process_for_n_sec(1000);


		// On planque la lunette
		cgb_obj_get_ptr_by_name(C_Objet_O_cuvette_WC)->ptVit.y = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_cuvette_WC)->SetisAfficher(T_FALSE);	

		// Debut course
		S_playWavFromRes(C_Res_RS_revolver);
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->SetResAnimName(C_Res_R_Bver_vole);
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->SetPointDest(C_Objet_O_Demo_Pt_3, 500);
		//cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->ptVit.x = 6;
	M_process_for_n_sec(100);



		// On les replace vers la gauche
		cgb_obj_get_ptr_by_name(C_Objet_O_sable)->ptVitScroll.x = 8;
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->SetPointDest(C_Objet_O_Demo_Pt_4, 5000);
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->SetPointDest(C_Objet_O_Demo_Pt_4, 150, 0, 5000);
		cgb_obj_get_ptr_by_name(C_Objet_O_Fver)->SetPointDest(C_Objet_O_Demo_Pt_4, -300, 0, 5000);
	M_process_for_n_sec(1000);


		// Depart de la fusee
		S_playWavFromRes(C_Res_RS_explosion);
		cgb_obj_get_ptr_by_name(C_Objet_O_fusee)->ptVit.x = 3;
		cgb_obj_get_ptr_by_name(C_Objet_O_fusee)->ptVit.y = -3;
		cgb_obj_get_ptr_by_name(C_Objet_O_fusee)->SetisAfficher(T_TRUE);	
	M_process_for_n_sec(4000);


		// Il sont places
		cgb_obj_get_ptr_by_name(C_Objet_O_Fver)->ptVit.x = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->ptVit.x = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->ptVit.x = 0;

		// Poursuite
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->ptVit.y = -1;
		M_process_for_n_sec(400);
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->ptVit.y = -1;
	M_process_for_n_sec(2000);



		// On planque la fusee
		cgb_obj_get_ptr_by_name(C_Objet_O_fusee)->ptVit.x = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_fusee)->ptVit.y = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_fusee)->SetisAfficher(T_FALSE);	

		// Poursuite
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->ptVit.y = 1;
	M_process_for_n_sec(400);
		S_playWavFromRes(C_Res_RS_bris_verre);
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->ptVit.y = 1;
	M_process_for_n_sec(2000);


		// La meteorite part
		cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->SetPointDest(C_Objet_O_ile, 25,0, 2500);
		//cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->ptVit.y = 6;
		//cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->ptVit.x = -4;
		cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->SetisAfficher(T_TRUE);	



		// Il sont places
		cgb_obj_get_ptr_by_name(C_Objet_O_Bver)->ptVit.y = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_Gver)->ptVit.y = 0;
	M_process_for_n_sec(2500);


		// On vire la meteorite
		cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->ptVit.y = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->ptVit.x = 0;
		cgb_obj_get_ptr_by_name(C_Objet_O_meteorite)->SetisAfficher(T_FALSE);	
		S_playWavFromRes(C_Res_RS_explosion);
		gcd_aff_shake();
		
	M_process_for_n_sec(5000);


// Explications
			// texte
			S_playCD(1);

			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_1, 10000, T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_prof)->SetisAfficher(T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_ile)->SetisAfficher(T_TRUE);
			M_process_for_n_sec(5000);
			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_2, 10000, T_TRUE);
			M_process_for_n_sec(5000);
			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_3, 10000, T_TRUE);
			M_process_for_n_sec(5000);
			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_4, 10000, T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_kourou)->SetisAfficher(T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_ile)->SetisAfficher(T_FALSE);
			M_process_for_n_sec(5000);

			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_5, 10000, T_TRUE);
			M_process_for_n_sec(5000);

			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_6, 10000, T_TRUE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_kourou)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_martien)->SetisAfficher(T_TRUE);
			M_process_for_n_sec(5000);
			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_7, 10000, T_TRUE);
			M_process_for_n_sec(5000);

			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_8, 10000, T_TRUE);
			M_process_for_n_sec(6000);

			// texte
			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_9, 10000, T_TRUE);
			M_process_for_n_sec(6000);

			cgb_obj_get_ptr_by_name(C_Objet_O_Demo_Texte)->AffText(C_Res_RT_TexteIntro_10, 10000, T_TRUE);
			M_process_for_n_sec(3000);

			cgb_obj_get_ptr_by_name(C_Objet_O_prof)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_ile)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_kourou)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_photo_martien)->SetisAfficher(T_FALSE);
			cgb_obj_get_ptr_by_name(C_Objet_O_ile)->SetAnimCourantebyName(C_Res_R_Mouse_Click);
		gcd_aff_mouse_on();
	} else {
		gcd_aff_player_on();
	}

}



