/******************************
 *
 *  Coconut: Generation :
 *     du fichier d'enttes h
 *     d'une livraison compacte
 *     d'une livraison arborescente
 *  coconut_utils.cpp
 ******************************/
 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
 
//#include "coconut.h"
#include "M_files.h"
 
void usage(char *ip_prog)
{
	printf("Usage : %s <-H> <-CFich config> <-GCommande>\n", ip_prog);
	printf("-H : Usage\n");
	printf("-C<Fich config>         : Fichier de config a lire: \n");
	printf("                          coconut.dat par defaut\n");
	printf("-G Commande:\n");
	printf("-GH<Fich.h a generer>   : Fichier de header h a generer: \n");
	printf("                          src_scen\\coco_res.h pas defaut\n");
	printf("-GR<Fich.cre a generer> : Fichier de ressource .cre a generer: \n");
	printf("                          livraison\\coconut.cre pas defaut\n");
	printf("                          Les fichiers necessaire a une livraison \n");
	printf("                          compacte de coconut vont etre generes \n");
	printf("                          dans le repertoire de ce fichier.\n");
	printf("-GD<Fich.txt a generer> : Fichier de trace a generer: \n");
	printf("                          livraison\\coconut.txt pas defaut\n");
	printf("                          Les fichiers necessaire a une livraison \n");
	printf("                          arborescente de coconutvont etre generes \n");
	printf("                          dans le repertoire de ce fichier.\n");
	printf("-GX<Fich.cre a generer> : Fichiers de resources .cre: \n");
	printf("                          coconut.cre par defaut\n");
	printf("                          Les fichiers de resources contenus \n");
	printf("                          dans le fichier .cre vont tre\n");
	printf("                          extrait sous forme arborescente.\n");
	printf("\n");
	exit(0);
}

int main(int argc, char *argv[])
{
	char	*l_ptr;
	char	l_configFile[255]="coconut.dat";
	char	l_headerFile[255]="src_scen\\coco_res.h";
	char	l_resFile[255]="livraison\\coconut.cre";
	char	l_dirFile[255]="livraison\\coco_res.h";
	int		l_cpt;
	int		l_argc=argc;
	int		l_headerCmd=0;
	int		l_resCmd=0;
	int		l_dirCmd=0;
	int		l_extCmd=0;

	if (l_argc <2) usage(argv[0]);

	while ( l_argc > 1 ) {
		--l_argc;
		if ( strcmp(argv[l_argc], "-H") == 0 ) {		/// HELP
			 usage(argv[0]); 
		} else
		if ( strncmp(argv[l_argc], "-C",2) == 0 ) {		// Fichier de config
			l_ptr=argv[l_argc]+2;
			l_cpt = 0;
			while ((l_ptr)&&(*l_ptr)&&((*l_ptr)!=' ')) {
				l_configFile[l_cpt] = (*l_ptr); 
				l_cpt++;
				l_ptr++;
			}
			if (l_cpt) l_configFile[l_cpt] = 0;
		} else
		if ( strncmp(argv[l_argc], "-GH",3) == 0 ) {		/// CMD : Gen H
			l_ptr=argv[l_argc]+3;
			l_cpt = 0;
			while ((l_ptr)&&(*l_ptr)&&((*l_ptr)!=' ')) {
				l_headerFile[l_cpt] = (*l_ptr); 
				l_cpt++;
				l_ptr++;
			}
			if (l_cpt) l_headerFile[l_cpt] = 0;
			l_headerCmd=1;
		}  else
		if ( strncmp(argv[l_argc], "-GR",3) == 0 ) {		// CMD : Gen livraison compacte
			l_ptr=argv[l_argc]+3;
			l_cpt = 0;
			while ((l_ptr)&&(*l_ptr)&&((*l_ptr)!=' ')) {
				l_resFile[l_cpt] = (*l_ptr); 
				l_cpt++;
				l_ptr++;
			}
			if (l_cpt) l_resFile[l_cpt] = 0;
			l_resCmd=1;
		}  else
		if ( strncmp(argv[l_argc], "-GD",3) == 0 ) {		// CMD : Gen livraison arborescente
			l_ptr=argv[l_argc]+3;
			l_cpt = 0;
			while ((l_ptr)&&(*l_ptr)&&((*l_ptr)!=' ')) {
				l_dirFile[l_cpt] = (*l_ptr); 
				l_cpt++;
				l_ptr++;
			}
			if (l_cpt) l_dirFile[l_cpt] = 0;
			l_dirCmd=1;
		} else
		if ( strncmp(argv[l_argc], "-GX",3) == 0 ) {		// CMD : Extraction du .cre
			l_ptr=argv[l_argc]+3;
			l_cpt = 0;
			while ((l_ptr)&&(*l_ptr)&&((*l_ptr)!=' ')) {
				l_resFile[l_cpt] = (*l_ptr); 
				l_cpt++;
				l_ptr++;
			}
			if (l_cpt) l_resFile[l_cpt] = 0;
			l_extCmd=1;
		} 
	}

	// Charge le fichier de config
	M_loadFile(l_configFile);

	// Gnre le point h
	if (l_headerCmd) {
		if (!M_saveFile_H(l_headerFile)) {
			printf("Pb generation du fichier h [%s]\n", l_headerFile);
		} else {
			printf("Generation [%s] ok\n", l_headerFile);
		}
	}

	// Gnre la livraison compacte
	if (l_resCmd) {
		if (!M_saveFile_BaseRes(l_resFile)) {
			printf("Pb generation de la livraison compacte [%s]\n", l_resFile);
		} else {
			printf("Generation compacte [%s] ok\n", l_resFile);
		}
	}
	// Gnre la livraison arborescente
	if (l_dirCmd) {
		if (!M_saveFile_BaseFich(l_dirFile)) {
			printf("Pb generation de la livraison arborescente [%s]\n", l_dirFile);
		} else {
			printf("Generation arborescente [%s] ok\n", l_dirFile);
		}
	}

	// Extrait les fichiers du .cre
	if (l_dirCmd) {
		if (!M_saveFile_BaseExtract(l_resFile)) {
			printf("Pb extraction des fichiers du .cre [%s]\n", l_resFile);
		} else {
			printf("Extraction des fichiers [%s] ok\n", l_resFile);
		}
	}

	return 0;
}