/***************************************************/
/*                                                 */
/* BRAHMS IST Project Demonstrator                 */
/* -------------------------------                 */
/*                                                 */
/* Links Library                                   */
/*                                                 */
/* ll_client_sock.c                                */
/* Client side                                     */
/*                                                 */
/*                              S. Josset          */
/*                              Alcatel Space 2000 */
/*               sebastien.josset@space.alcatel.fr */
/*                                                 */
/***************************************************/

//
// System includes
//
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>

//
// Libraries includes
//
#include "ll_sock.h"
#include "port_uxnt.h"


//
// Global variables
//
int LL_fd_client;
char LL_servername[256];
TE_LL_id LL_client_id;
unsigned short LL_port;
int LL_num;

/***************** Connection ********************/
/* Return 1: OK
          0: KO
*/
int LL_snd_connect()
{
	struct	sockaddr_in 	lv_addr_in;	/* Adresse local AF_INET */
	DWORD   dwValue=5;
	struct	sockaddr *	lv_addr;	/* Adresse local */
	int		lv_longeur;	/* pour gethostbyname */
	struct hostent *phe;
	TC_LL_msg l_msg;

	P_InitWinsock();
	/* creation de la socket */
    if ((LL_fd_client = socket(AF_INET, SOCK_STREAM,0)) < 0) {
		LL_fd_client = 0;
		return 0;
    }

	/* Connection au serveur */
	phe = gethostbyname(LL_servername);
	if (phe == NULL) {
	 return 0;
	}
	memcpy((char *)&(lv_addr_in.sin_addr), phe->h_addr, phe->h_length);

    lv_addr_in.sin_family = AF_INET;
    lv_addr_in.sin_port = htons(LL_port);

	lv_addr = (struct sockaddr *) (&lv_addr_in);
	lv_longeur = sizeof(struct sockaddr_in);
	if (connect((int)LL_fd_client, (const struct sockaddr *)lv_addr, lv_longeur) < 0) {
		LL_fd_client = 0;
		return 0;
	}
	/* Passage en mode non bloquant */
	//P_socketSetNonBlocking(LL_fd_client);
	P_socketSetNoDelay(LL_fd_client);

	// Send id
	LL_num = 0;
	l_msg.sender_id = LL_client_id;
	l_msg.num = 0;
	l_msg.length = 0;
	LL_client_snd_buf(&l_msg);

	return 1;
}

int  LL_client_init(char *ip_server_name, int i_port, TE_LL_id i_client_id)
{
	int l_ret;

	LL_client_id = i_client_id;
	strcpy(LL_servername, ip_server_name);
	LL_port = i_port;
	l_ret = LL_snd_connect();
	return l_ret;
}



/***************** Send      ********************/
int LL_client_snd_buf(TC_LL_msg *ip_msg)
{
	int l_ret;

	(ip_msg->magic) = htonl(LL_MSG_MAGIC);
	(ip_msg->sender_id) = htonl(LL_client_id);
	(ip_msg->num) = htonl(ip_msg->num);
	(ip_msg->length) = htonl(ip_msg->length);

	if (LL_fd_client) {
		printf("Send Msg [%d octets] \n", LL_MSG_SIZE);
		l_ret = P_socketSend(LL_fd_client, (char *)ip_msg, LL_MSG_SIZE, 0);
	} else {
		LL_snd_connect();
		if (LL_fd_client) {
			printf("Send Msg [%d octets] \n", LL_MSG_SIZE);
			l_ret = P_socketSend(LL_fd_client, (char *)ip_msg, LL_MSG_SIZE, 0);
		}
		l_ret = 0;
	}

	(ip_msg->magic)		= ntohl(LL_MSG_MAGIC);
	(ip_msg->sender_id) = ntohl(LL_client_id);
	(ip_msg->num)		= ntohl(ip_msg->num);
	(ip_msg->length)	= ntohl(ip_msg->length);

	return l_ret;
}



/***************** Receive   ********************/
int LL_client_rcv_buf(TC_LL_msg *op_msg)
{
	int l_len;

	if (LL_fd_client) {
		l_len = P_socketRecv(LL_fd_client, (char *)op_msg, LL_MSG_SIZE, 0);  

		if (l_len==0) {   /* deconnection */
			P_closesocket(LL_fd_client);
			LL_fd_client = 0;
			printf("Distant deconnected cx(%d)\n", LL_fd_client);
		}
		if (l_len<0)  {   /* socket non valide */
			/*closesocket(fd);
			fd = 0; */
		}
		if (l_len>0) {    /* normal */
			/* On l'ajoute dans la fifo */
			printf("Received Msg [%d octets] par socket[%d]\n",l_len, LL_fd_client);

			(op_msg->magic)		= ntohl(op_msg->magic);
			(op_msg->sender_id) = ntohl(op_msg->sender_id);
			(op_msg->num)		= ntohl(op_msg->num);
			(op_msg->length)	= ntohl(op_msg->length);

			if ((op_msg->magic) != LL_MSG_MAGIC) {
				printf("Pb Magic not valide !!!\n");
				return 0;
			}
			return 1;
		}
	}
	return 0;
}



/***************** Close     ********************/
void LL_snd_close()
{
	P_closesocket(LL_fd_client);
	LL_fd_client = 0;
}


