/***************************************************/
/*                                                 */
/* Pang Project                                    */
/* ------------                                    */
/*                                                 */
/* Links Library                                   */
/*                                                 */
/* ll_sock.h                                       */
/* Client/Server interface                         */
/*                                                 */
/*                              S. Josset          */
/*                              Alcatel Space 2000 */
/*               sebastien.josset@space.alcatel.fr */
/*                                                 */
/***************************************************/

#ifndef LL_SOCK_H
#define LL_SOCK_H

#define LL_MSG_BUF_SIZE 4000
#define LL_MSG_MAGIC	16843009



/////////////////////////////////////////
// TC_LL_msg
// Message sent/receive by the ll_links library
//

typedef enum {
	TE_LL_id_Player1,
	TE_LL_id_Player2,
	TE_LL_id_Player3,
	TE_LL_id_Player4,
	TE_LL_id_Guest
} TE_LL_id;


typedef struct {
		unsigned long magic;   // ll_link magic number
        unsigned long  num;	   // Message counter
		TE_LL_id  sender_id;   // sender id
		unsigned long length;  // data length in buf 
	char buf[LL_MSG_BUF_SIZE]; // Fixed length buf
} TC_LL_msg;


#define LL_MSG_SIZE sizeof(TC_LL_msg)

/* Var */
extern TC_LL_msg g_LL_msg_null;


/* Server side */
int  LL_server_init(int i_port);
int  LL_server_rcv_buf(TC_LL_msg *op_msg);
int  LL_server_snd_buf(TE_LL_id i_client_id, TC_LL_msg *ip_msg);
void LL_server_close(void);

/* client side */
int  LL_client_init(char *ip_server_name, int i_port, TE_LL_id i_client_id);
int  LL_client_rcv_buf(TC_LL_msg *op_msg);
int  LL_client_snd_buf(TC_LL_msg *ip_msg);
void LL_client_snd_close(void);

#endif
