/***************************************************/
/*                                                 */
/* BRAHMS IST Project Demonstrator                 */
/* -------------------------------                 */
/*                                                 */
/* Port Library                                    */
/*                                                 */
/* port_uxnt.h                                     */
/* Porting functions between Unix/NT               */
/*                                                 */
/*                              S. Josset          */
/*                              Alcatel Space 1999 */
/*               sebastien.josset@space.alcatel.fr */
/*                                                 */
/***************************************************/

#ifndef PORT_UXNT_H
#define PORT_UXNT_H

//
// System includes
//
#ifdef WIN32
#include <windows.h>
#else
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <unistd.h>
#define DWORD	long
#endif


//
// Define
//
typedef long		T_INT32S;
typedef unsigned long	T_INT32U;
#define	T_INFO		 __LINE__,__FILE__


//
// Prototypes
//
long P_GetTickCount();
void P_Sleep(long l_ms);
void P_InitWinsock();
void P_closesocket(int i_FD);
void P_socketSetNonBlocking(int i_fd);
void P_socketSetNoDelay(int i_fd);
void P_AffWorking(int i_cpt);
int  P_socketRecv ( int i_fd,char *ip_buf, int i_len, int i_flags );
int  P_socketSend(int i_fd, char *ip_buf, int i_len, int i_flags);
void P_traceBuf(int i_sourceLine,
		      char *ip_sourceFilename,
		      int  i_seuil_trace,
		      char *ip_buf,
		      char *ip_label,
		      int  i_taillebuf);
void P_get_date(char *iop_date);
void P_get_entete_trace(
		  char *		iop_entete, 
		  const char *	ip_sourceFilename, 
		  int	     	i_sourceLine);

extern int P_g_trace_level;

#endif

